
#ifndef _GCOMMON_H_
#define _GCOMMON_H_

#include "gwin.h"
#define _WIN32_IE 0x0501	// dv
#include <commctrl.h>
// #pragma comment(lib, "comctl32.lib")

//==========================================
//	GCOMMON									
//==========================================
class GCOMMON : public GWIN_BASE {
	public:
	enum { TEXTER_TYPE=1, BUTTON_TYPE, CHECKBOX_TYPE, RADIO_TYPE, COMBOBOX_TYPE, EDIT_TYPE,
			LISTBOX_TYPE, LISTVIEW_TYPE, TAB_TYPE, SLIDER_TYPE, GROUPBOX_TYPE, UPDOWN_TYPE,
			HEADER_TYPE, PROGRESS_TYPE };
	enum { EWS_NORMAL=(WS_VISIBLE | WS_TABSTOP) };
	int type;
	GCOMMON();
	make_texter		(HWND parent_hwnd, char* a_name, int x, int y);		// X^eBbNEeLXg
	make_edit		(HWND parent_hwnd, char* a_name, int id, int x, int y, int w, int h);	// GfBbg
	make_button		(HWND parent_hwnd, char* a_name, int id, int x, int y, int w=-1, int h=-1);	// {^
	make_checkbox	(HWND parent_hwnd, char* a_name, int id, int x, int y);		// `FbN{bNX
	make_radio		(HWND parent_hwnd, char* a_name, int id, int x, int y);		// WI{^

	make_header		(HWND parent_hwnd, int id, int x, int y, int w, int h);		// wb_
	make_listview	(HWND parent_hwnd, int id, int x, int y, int w, int h);		// Xgr[
	make_tab		(HWND parent_hwnd, int id, int x, int y, int w, int h);		// ^u
	make_combo		(HWND parent_hwnd, int id, int x, int y, int w, int h);		// R{{bNX
	make_combo_edit	(HWND parent_hwnd, int id, int x, int y, int w, int h);		// R{{bNXEGfBbgt

	make_slider		(HWND parent_hwnd, int id, int x, int y, int w, int h, int bar_type);	// XC_
	make_group		(HWND parent_hwnd, char* a_name, int x, int y, int w, int h);	// O[v{bNX
	make_updown		(HWND parent_hwnd, int id, int x, int y, int w, int h);			// Abv_E
	make_progress	(HWND parent_hwnd, int id, int x, int y, int w, int h);			// vOXo[

	// ėp
	static 	call_InitCommonControls();
	set_font(HFONT a_hfont);
	virtual POSIZE get_in_posize();

	// Abv_En֐
	set_buddy(HWND edit_hwnd);
	// `FbN{bNXn֐
	is_checkbox(){	return (type==CHECKBOX_TYPE || type==RADIO_TYPE) ;	}
	get_check();
	set_check(int flag=-1);

	// Xgn
	is_list(){ return (type==COMBOBOX_TYPE || type==TAB_TYPE || type==LISTVIEW_TYPE || type==LISTBOX_TYPE) ; }
	del_item(int item_num=-1);
	del_allitems();
	insert_item	(char* str, int item_num, int column_num=0);
	add_item	(char* str, int column_num=0);
	set_item	(char* str, int item_num, int column_num=0);
	sel(int n);
	un_sel(int n);
	get_sel(int istart=-1);
	get_len();
	// R{{bNX
	// Xgr[
	get_column_len();
	get_column_width(int column_num);
	get_column(STR* pstr, int column_num);
	add_column	(char* str, int column_width);
	set_column	(char* str, int column_num, int column_width);
	find_item	(char* str, int start=-1);
	// ^u
	get_tab_inside_posize(POSIZE *poze){
		RECT rc;
		GetClientRect(m_hwnd, &rc);
		SendMessage(m_hwnd, TCM_ADJUSTRECT, 0, (LPARAM)&rc);
		*poze=rc;
		return 0;
	}
	// XC_EvOXo[
	set_range(int min_val, int max_val, int redraw_flag=0);
	set_val(int val, int redraw_flag=1);
	get_val();
	set_freq(int freq);
	virtual LRESULT CALLBACK EachProc(UINT msg, WPARAM wp, LPARAM lp);
	virtual on_keydown(WPARAM wp, LPARAM lp);
	virtual on_mou_up_right(WPARAM wp, LPARAM lp);
	static LRESULT CALLBACK WndProc_m_common(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	make_base_ex(int ex_style, char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id=0, HINSTANCE hins=NULL, LPVOID lp=NULL);
};
WNDPROC org_proc_listview;//(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
WNDPROC org_proc_edit=NULL;
WNDPROC org_proc_button;
WNDPROC org_proc_checkbox;
WNDPROC org_proc_radio;
WNDPROC org_proc_combobox;
WNDPROC org_proc_tab;
WNDPROC org_proc_slider;
WNDPROC org_proc_listbox;
//	enum { TEXTER_TYPE=1, GROUPBOX_TYPE, UPDOWN_TYPE };
static XLIST<GCOMMON*> g_gcom_list;
GCOMMON::GCOMMON(){
	type=0;
	g_gcom_list.push(this);
}
GCOMMON::on_mou_up_right(WPARAM wp, LPARAM lp){ return 0; };

GCOMMON::on_keydown(WPARAM wp, LPARAM lp){
	HWND next_hwnd=m_hwnd;
	int style, stat_ctrl, stat_shift;
	if(wp==VK_RETURN) {
		SendMessage(GetParent(m_hwnd), WM_COMMAND, GetWindowLong(m_hwnd, GWL_ID), 0);
	}
	else if(wp==VK_TAB) {
		stat_shift = (GetKeyState(VK_SHIFT)<0);
		stat_ctrl = (GetKeyState(VK_CONTROL)<0);
		while(1){
			if (stat_ctrl) {
				if (stat_shift) next_hwnd=GetParent(m_hwnd);
				else			next_hwnd=GetWindow(next_hwnd, GW_CHILD);
			}
			else if (stat_shift) next_hwnd=GetWindow(next_hwnd, GW_HWNDPREV);
			else next_hwnd=GetWindow(next_hwnd, GW_HWNDNEXT);
			if (next_hwnd)	{
				style = GetWindowLong(next_hwnd, GWL_STYLE);
				if (!(style & WS_TABSTOP) || ((style&0xf) == BS_GROUPBOX)) continue;
			}
			else 
				next_hwnd=GetWindow(GetParent(m_hwnd), GW_CHILD);
			if (next_hwnd)	{
				SetFocus(next_hwnd);
				InvalidateRect(next_hwnd, NULL, 1);
				return -1;
			}
		//	GW_CHILD
			break;
		}
	}
	return 0;
}
LRESULT CALLBACK GCOMMON::EachProc(UINT msg, WPARAM wp, LPARAM lp){
	switch (msg) {
	case WM_CHAR		: if(wp==VK_TAB && type==EDIT_TYPE) return -1;		break;
	case WM_KEYDOWN : return on_keydown(wp, lp);	//	break;
	case WM_RBUTTONUP :	on_mou_up_right(wp, lp); break;
	case WM_MOUSEMOVE	:
	case WM_DROPFILES:	SendMessage(GetParent(m_hwnd), msg, wp, lp);	break;	//
	default:;
	}
	return 0;
}
LRESULT CALLBACK GCOMMON::WndProc_m_common(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp){
	GCOMMON *pcom;
	int i;
	for(i=0;i<g_gcom_list.size();i++){
		pcom=g_gcom_list[i];
		if (hwnd!=pcom->m_hwnd) continue;
		if (pcom->EachProc(msg, wp, lp)<0) return 0;
		break;
	}
	if		(pcom->type==LISTVIEW_TYPE)	return CallWindowProc(org_proc_listview	,hwnd, msg, wp, lp);
	else if (pcom->type==BUTTON_TYPE)	return CallWindowProc(org_proc_button	,hwnd, msg, wp, lp);
	else if (pcom->type==CHECKBOX_TYPE)	return CallWindowProc(org_proc_checkbox	,hwnd, msg, wp, lp);
	else if (pcom->type==RADIO_TYPE)	return CallWindowProc(org_proc_radio	,hwnd, msg, wp, lp);
	else if (pcom->type==TAB_TYPE)		return CallWindowProc(org_proc_tab		,hwnd, msg, wp, lp);
	else if (pcom->type==SLIDER_TYPE)	return CallWindowProc(org_proc_slider	,hwnd, msg, wp, lp);
	else if (pcom->type==COMBOBOX_TYPE)	return CallWindowProc(org_proc_combobox	,hwnd, msg, wp, lp);
	else if (pcom->type==LISTBOX_TYPE)	return CallWindowProc(org_proc_listbox	,hwnd, msg, wp, lp);
	else if (pcom->type==EDIT_TYPE)		return CallWindowProc(org_proc_edit		,hwnd, msg, wp, lp);
	return 0;
}
GCOMMON::make_base_ex(int ex_style, char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id, HINSTANCE hins, LPVOID lp){
	GWIN_BASE::make_base_ex(ex_style, winc_name, name, style, x, y, w, h, parent_hwnd, id, hins, lp);

	if		(type==LISTVIEW_TYPE)	org_proc_listview	= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==BUTTON_TYPE)		org_proc_button		= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==CHECKBOX_TYPE)	org_proc_checkbox	= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==RADIO_TYPE)		org_proc_radio		= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==TAB_TYPE)		org_proc_tab		= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==SLIDER_TYPE)		org_proc_slider		= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==COMBOBOX_TYPE)	org_proc_combobox	= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==LISTBOX_TYPE)	org_proc_listbox	= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);
	else if (type==EDIT_TYPE)		org_proc_edit		= (WNDPROC)GetWindowLong(m_hwnd, GWL_WNDPROC);	// G[;

	else return 0;
	return SetWindowLong(m_hwnd, GWL_WNDPROC, (LONG)WndProc_m_common);
}
// tHg
GCOMMON::set_font(HFONT a_hfont){ return SendMessage(m_hwnd, WM_SETFONT, (WPARAM)a_hfont, TRUE); }

GCOMMON::make_texter(HWND parent, char* a_name, int x, int y){
	type=TEXTER_TYPE;
	SIZE size=get_str_size(parent, a_name);
	make_base_ex(0, "STATIC", a_name, EWS_NORMAL, x, y, size.cx, size.cy, parent, 0);
}
// RGfBbg		
GCOMMON::make_edit(HWND parent, char* a_name, int id, int x, int y, int w, int h){
	type=EDIT_TYPE;
	SIZE size=get_str_size(parent, "M");
	make_base_ex(WS_EX_CLIENTEDGE, "EDIT", a_name, 
			EWS_NORMAL | WS_BORDER | ES_LEFT | ES_AUTOHSCROLL, x, y, w, h, parent, id);
	return 0;
}

//===============vOXo[n֐=========================================
GCOMMON::make_progress	(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=PROGRESS_TYPE;
	call_InitCommonControls();
	return make_base_ex(0, PROGRESS_CLASS, NULL, EWS_NORMAL, x, y, w, h, parent_hwnd, id);
}
//===============Abv_En֐=========================================
GCOMMON::make_updown(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=UPDOWN_TYPE;
	make_base_ex(0, UPDOWN_CLASS, NULL, WS_VISIBLE | UDS_AUTOBUDDY | UDS_SETBUDDYINT, x, y, w, h, parent_hwnd, id);
	return 0;
}
GCOMMON::set_buddy(HWND edit_hwnd){
	if (type==UPDOWN_TYPE){
		SendMessage(m_hwnd, UDM_SETBUDDY, (WPARAM)edit_hwnd, 0);
		return add_style(UDS_SETBUDDYINT);
	}
	return 0;
}
//===============XC_n֐=========================================
GCOMMON::make_slider(HWND parent_hwnd, int id, int x, int y, int w, int h, int bar_type){
	type=SLIDER_TYPE;
	int style=0;
	if (bar_type=='v' || bar_type=='V') style=TBS_VERT;
	if (bar_type=='h' || bar_type=='H') style=TBS_HORZ;
	return make_base( TRACKBAR_CLASS, "", EWS_NORMAL | WS_BORDER | style | TBS_AUTOTICKS, x, y, w, h, parent_hwnd, id);
}
GCOMMON::set_freq(int freq){
	if (type==SLIDER_TYPE) {
		return SendMessage(m_hwnd, TBM_SETTICFREQ, freq, 0);
	}
	return 0;
}
GCOMMON::get_val(){
	if (type==SLIDER_TYPE) {
		return SendMessage(m_hwnd, TBM_GETPOS, 0, 0);
	}
	return 0;
}
GCOMMON::set_val(int val, int redraw_flag){
	if (type==SLIDER_TYPE) {
		return SendMessage(m_hwnd, TBM_SETPOS, redraw_flag, val);
	}
	else if (type==PROGRESS_TYPE) {
		return SendMessage(m_hwnd, PBM_SETPOS, val, 0);
	}
	return 0;
}
// l ͈͐ݒ
GCOMMON::set_range(int min_val, int max_val, int redraw_flag){
	if (type==SLIDER_TYPE) {
		SendMessage(m_hwnd, TBM_SETRANGEMAX, 0,			max_val);
		return (SendMessage(m_hwnd, TBM_SETRANGEMIN, redraw_flag, min_val));
	}
	else if (type==PROGRESS_TYPE) {
		return (SendMessage(m_hwnd, PBM_SETRANGE, 0, (MAKELPARAM(min_val, max_val)) ));
	}
	else if (type==UPDOWN_TYPE){
		return (SendMessage(m_hwnd, UDM_SETRANGE, 0, (MAKELPARAM(max_val, min_val))));
	}
	return 0;
}
//===============O[v{bNXn֐=========================================
GCOMMON::make_group(HWND parent_hwnd, char* a_name, int x, int y, int w, int h){
	type=GROUPBOX_TYPE;
	return make_base( TEXT("BUTTON"), a_name, EWS_NORMAL | BS_GROUPBOX | WS_GROUP, x, y, w, h, parent_hwnd, 0);
};

//==============={^n֐=========================================
GCOMMON::make_button(HWND parent_hwnd, char* a_name, int id, int x, int y, int w, int h){
	type=BUTTON_TYPE;
	SIZE size=get_str_size(parent_hwnd, a_name);
	if (w<0) w=size.cx;
	if (h<0) h=size.cy+7;
	return make_base( TEXT("BUTTON"), a_name, EWS_NORMAL | BS_PUSHBUTTON, x, y, w, h, parent_hwnd, id);
};

//===============`FbN{bNXn֐=========================================
//=`FbN{bNX		
GCOMMON::make_checkbox(HWND parent_hwnd, char* a_name, int id, int x, int y){
	type=CHECKBOX_TYPE ;
	SIZE size=get_str_size(parent_hwnd, a_name);
	size.cx+=(size.cy);
	make_base( TEXT("BUTTON"), a_name, EWS_NORMAL | BS_AUTOCHECKBOX, x, y, size.cx, size.cy, parent_hwnd, id);
	return 0;
};
// WI{^		
GCOMMON::make_radio(HWND parent_hwnd, char* a_name, int id, int x, int y){
	type=RADIO_TYPE ;
	SIZE size=get_str_size(parent_hwnd, a_name);
	size.cx+=(size.cy);
	return make_base( TEXT("BUTTON"), a_name, EWS_NORMAL | BS_AUTORADIOBUTTON, x, y, size.cx, size.cy, parent_hwnd, id);
};

GCOMMON::get_check(){
	if (!is_checkbox()) return 0;
	int val=SendMessage(m_hwnd , BM_GETCHECK , 0 , 0) ;
	if (val==BST_CHECKED) return 1;
	if (val==BST_UNCHECKED) return 0;
	return -1;
}
GCOMMON::set_check(int flag){
	if (!is_checkbox()) return 0;
	if (flag==-1) flag = !get_check();
	return SendMessage(m_hwnd , BM_SETCHECK , flag, 0);
}

//===============gRRg[n֐=========================================
GCOMMON::call_InitCommonControls(){
	static bool init_m_common_flag=0 ;
	if (init_m_common_flag) return 0;
	init_m_common_flag=1;
	InitCommonControls();
	return 0;
}

//===============Xg{bNXn   ֐=========================================
// ACeS폜
GCOMMON::del_allitems(){
	if (type==LISTVIEW_TYPE) return SendMessage(m_hwnd, LVM_DELETEALLITEMS,	0, 0);
	if (type==COMBOBOX_TYPE) return SendMessage(m_hwnd, CB_RESETCONTENT,		0, 0);
	if (type==TAB_TYPE)		 return SendMessage(m_hwnd, TCM_DELETEALLITEMS,	0, 0);
	return -1;
}
// ACe폜
GCOMMON::del_item(int item_num){
	if (item_num==-1) item_num=get_sel();
	if (type==LISTVIEW_TYPE) return ListView_DeleteItem(m_hwnd, item_num);
	if (type==COMBOBOX_TYPE) return SendMessage(m_hwnd, CB_DELETESTRING , item_num, 0);
	if (type==TAB_TYPE)		 return SendMessage(m_hwnd, TCM_DELETEITEM, item_num, 0);
	return -1;
}

// IACeݒ
GCOMMON::sel(int n){
	if (type==COMBOBOX_TYPE) return SendMessage(m_hwnd, CB_SETCURSEL , n, 0);
	if (type==TAB_TYPE)		 return SendMessage(m_hwnd, TCM_SETCURSEL, n, 0) ;
	if (type==LISTVIEW_TYPE) {
		LVITEM item = {0};
		item.mask = LVIF_STATE;
		item.iItem = n;
		item.state = LVIS_SELECTED;
		return ListView_SetItem(m_hwnd, &item);
	}
	return 0;
}
GCOMMON::un_sel(int n){
	if (type==LISTVIEW_TYPE) {
		LVITEM item = {0};
		item.mask = LVIF_STATE;
		item.iItem = n;
		ListView_GetItem(m_hwnd , &item);
		item.mask = LVIF_STATE;
		item.state = (item.state & ~LVIS_SELECTED);
		return ListView_SetItem(m_hwnd , &item);
	}
	return 0;
}
// ACeQbg
GCOMMON::get_len(){
	if (type==COMBOBOX_TYPE) return SendMessage(m_hwnd, CB_GETCOUNT , 0 , 0) ;
	if (type==LISTVIEW_TYPE) return SendMessage(m_hwnd, LVM_GETITEMCOUNT, 0, 0) ;	// ListView_GetItemCount(m_hwnd);łOK
	if (type==TAB_TYPE)		 return SendMessage(m_hwnd, TCM_GETITEMCOUNT, 0, 0) ;
	return 0;
}
// IACeԍQbg
GCOMMON::get_sel(int istart){
	if (type==COMBOBOX_TYPE) return SendMessage(m_hwnd, CB_GETCURSEL , 0, 0) ;
	if (type==TAB_TYPE)		 return SendMessage(m_hwnd, TCM_GETCURSEL, 0, 0) ;
	if (type==LISTVIEW_TYPE) {
		return (ListView_GetNextItem( m_hwnd, istart, (LVNI_ALL | LVNI_SELECTED)));
	}
	return 0;
}
// ACe}
GCOMMON::insert_item(char* str, int item_num, int column_num){
	if (!is_list()) return 0;
	int res;
	if (type==COMBOBOX_TYPE){
		return SendMessage(m_hwnd, CB_INSERTSTRING, item_num, (LPARAM)str);
	}
	if (type==LISTVIEW_TYPE){
		LVITEM *pitem;
		pitem = new LVITEM;
		memset(pitem, 0, sizeof(LVITEM));
		pitem->mask = LVIF_TEXT;
		pitem->pszText = str;
		pitem->iItem = item_num;
		pitem->iSubItem = column_num;
		if (column_num>0)	res=ListView_SetItem(m_hwnd , pitem);
		else 				res=ListView_InsertItem(m_hwnd , pitem);
		delete pitem;
		return res;
	}
	if (type==TAB_TYPE){
		TCITEM tci;
		memset(&tci, 0, sizeof(TCITEM));
		tci.mask=TCIF_TEXT;
		tci.pszText=str;
		return SendMessage(m_hwnd, TCM_INSERTITEM, item_num, (LPARAM)&tci);
	}
	return -1;
}
// ACeǉ
GCOMMON::add_item(char* str, int column_num){
	if (!is_list()) return 0;
	int len=get_len();
	if (column_num>0 && type==LISTVIEW_TYPE) len--;
	return insert_item(str, len, column_num);
}
GCOMMON::set_item(char* str, int item_num, int column_num){
	if (!is_list()) return 0;
	if (type==LISTVIEW_TYPE){
		LVITEM item = {0};
		item.mask = LVIF_TEXT;
		item.pszText = str;
		item.iItem = item_num;
		item.iSubItem = column_num;
		if (!column_num && item_num>=get_len())	return	ListView_InsertItem(m_hwnd , &item);
		ListView_SetItem(m_hwnd , &item);
	}
	if (type==TAB_TYPE){
		TCITEM tci;
		memset(&tci, 0, sizeof(TCITEM));
		tci.mask=TCIF_TEXT;
		tci.pszText=str;
		return SendMessage(m_hwnd, TCM_SETITEM, item_num, (LPARAM)&tci);
	}
	if (type==COMBOBOX_TYPE){
		SendMessage(m_hwnd, CB_DELETESTRING, item_num, (LPARAM)0);
		return SendMessage(m_hwnd, CB_INSERTSTRING, item_num, (LPARAM)str);
		//return SendMessage(hwnd, CB_SETSTRING, item_num, (LPARAM)str);
	}
	return -1;
}
GCOMMON::find_item(char* s, int start){
	if (!is_list()) return -1;
	if (type==LISTVIEW_TYPE){
		LVFINDINFO info = {0};
		info.flags	= LVFI_STRING;
		info.psz	=s;
		return SendMessage(m_hwnd, LVM_FINDITEM, start, (LPARAM)&info);
	}
	if (type==COMBOBOX_TYPE){
		return SendMessage(m_hwnd, CB_FINDSTRING, start, (LPARAM)s);
	}
	if (type==TAB_TYPE){
		return dialog("^ũACe͖T|[g");
	}
	return -1;
}
//===============wb_[n֐=========================================
GCOMMON::make_header(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=HEADER_TYPE;
	call_InitCommonControls();
	return make_base_ex( 0, WC_HEADER, NULL,
		EWS_NORMAL | HDS_BUTTONS,	//| HDS_DRAGDROP | HDS_FULLDRAG hbO͕ύXʂfȂBOS
		 x, y, w, h, parent_hwnd, id);
}
GCOMMON::get_column_width(int column_num){
	if (type==HEADER_TYPE){
		HDITEM hi;
		memset(&hi, 0, sizeof(HDITEM));
		hi.mask = HDI_WIDTH;
		SendMessage(m_hwnd, HDM_GETITEM, column_num, (LPARAM)&hi);
		return hi.cxy;
	}
	return 0;
}
GCOMMON::get_column(STR* pstr, int column_num){
	if (type==HEADER_TYPE){
		if (!pstr) return 0;
		HDITEM hi;
		memset(&hi, 0, sizeof(HDITEM));
		hi.mask = HDI_LPARAM;	// ACeݒ莞hi.lParamstrlenĂ
		SendMessage(m_hwnd, HDM_GETITEM, column_num, (LPARAM)&hi);
		pstr->resize(hi.lParam+1);
		hi.mask = HDI_TEXT  | HDI_LPARAM;
		hi.pszText = pstr->buf;
		hi.cchTextMax = hi.lParam+1;
		SendMessage(m_hwnd, HDM_GETITEM, column_num, (LPARAM)&hi);
	}
	return 0;
}
//===============Xgr[n֐=========================================
GCOMMON::make_listview(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=LISTVIEW_TYPE;
	call_InitCommonControls();
	make_base_ex(WS_EX_ACCEPTFILES | WS_EX_CLIENTEDGE,
				WC_LISTVIEW, NULL, EWS_NORMAL | LVS_REPORT | LVS_SHOWSELALWAYS, x, y, w, h, parent_hwnd, id);
	DWORD style_ex=ListView_GetExtendedListViewStyle(m_hwnd);
	return ListView_SetExtendedListViewStyle( m_hwnd, style_ex | LVS_EX_FULLROWSELECT );
/*
	LVS_EX_CHECKBOXES `FbN{bNX܂
	LVS_EX_FULLROWSELECT PsI\ɂ܂
	LVS_EX_GRIDLINES Obh܂
	LVS_EX_HEADERDRAGDROP wb_hbO&hbv\ɂ܂
	̂Comctl32.dll̃o[W4.70ȍ~ł邱ƂKvłB
*/
}

GCOMMON::get_column_len(){
	if (type==LISTVIEW_TYPE) {
		HWND header_hwnd=(HWND)SendMessage(m_hwnd, LVM_GETHEADER, 0, 0);
		return SendMessage(header_hwnd, HDM_GETITEMCOUNT, 0, 0);
	}
	else if (type==HEADER_TYPE) {
		return SendMessage(m_hwnd, HDM_GETITEMCOUNT, 0, 0);
	}
	return 0;
}

GCOMMON::add_column(char* str, int column_width){
	if (type==LISTVIEW_TYPE) {
	//	int len=ListView_ColumnCount(hwnd);
		LVCOLUMN col;
		memset(&col, 0, sizeof(LVCOLUMN));
		int column_num=get_column_len();
		col.mask	= LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
		col.fmt		= LVCFMT_LEFT;
		col.cx		= column_width;
		col.pszText	= str;
		col.iSubItem = column_num;
		return ListView_InsertColumn(m_hwnd, column_num, &col);
	}
	else if (type==HEADER_TYPE) {
		int column_num=get_column_len();
		HDITEM hi;
		memset(&hi, 0, sizeof(HDITEM));
		hi.mask = HDI_TEXT | HDI_WIDTH | HDI_LPARAM | HDI_ORDER;
		hi.pszText = str;
		hi.cchTextMax = strlen(str);
		hi.cxy = column_width;
		hi.lParam = strlen(str);
		hi.iOrder = column_num;
		SendMessage(m_hwnd, HDM_INSERTITEM, column_num, (LPARAM)&hi);
	}
	return 0;
}
GCOMMON::set_column(char* str, int column_num, int column_width){
	if (type==LISTVIEW_TYPE) {
	//	int len=ListView_ColumnCount(hwnd);
		LVCOLUMN col;
		memset(&col, 0, sizeof(LVCOLUMN));
		col.mask	= LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
		col.fmt		= LVCFMT_LEFT;
		col.cx		= column_width;
		col.pszText	= str;
		col.iSubItem = column_num;
		return (ListView_SetColumn(m_hwnd, column_num, &col));
	}
	else if (type=HEADER_TYPE) {
		HDITEM hi;
		memset(&hi, 0, sizeof(HDITEM));
		hi.mask = HDI_TEXT | HDI_WIDTH  | HDI_ORDER;
		hi.pszText = str;
		hi.cchTextMax = strlen(str);
		hi.cxy = column_width;
		hi.lParam = strlen(str);
		hi.iOrder = column_num;
		return SendMessage(m_hwnd, HDM_SETITEM, column_num, (LPARAM)&hi);
	}
	return 0;
}
//===============R{{bNXn֐=========================================
GCOMMON::make_combo(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=COMBOBOX_TYPE;
	make_base( TEXT("COMBOBOX"), "", EWS_NORMAL | WS_VSCROLL | CBS_DROPDOWNLIST, x, y, w, h, parent_hwnd, id);
	return 0;
};
GCOMMON::make_combo_edit(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=COMBOBOX_TYPE;
	make_base( TEXT("COMBOBOX"), "", EWS_NORMAL | WS_VSCROLL | CBS_DROPDOWN, x, y, w, h, parent_hwnd, id);
	return 0;
};

//===============^uRg[n֐=========================================
GCOMMON::make_tab(HWND parent_hwnd, int id, int x, int y, int w, int h){
	type=TAB_TYPE;
	call_InitCommonControls();
	make_base(WC_TABCONTROL, NULL, WS_VISIBLE , x, y, w, h, parent_hwnd, id);
	return 0;
}
POSIZE GCOMMON::get_in_posize(){
	POSIZE poze;
	RECT rc;
	if (type==TAB_TYPE) get_tab_inside_posize(&poze);
	else {
		GetClientRect(m_hwnd, &rc);
		poze=rc;
	}
	return poze;
}

#endif	// _GCOMMON_H_

