
#ifndef _GLISTVIEW_H_
#define _GLISTVIEW_H_

#include <windows.h>
#include "gwin.h"
#include "gobj.h"
#include "gcommon.h"

//==========================================
//	GLISTVIEW_BODY_WIN						
//==========================================

// Xgr[pACe
class GLISTVIEW_BODY_WIN_ITEM {
	public :
	PLIST<STR> m_buf;
	set_font();
	char n_selecting;
	GLISTVIEW_BODY_WIN_ITEM(){
		n_selecting=0;
	}
	sel(){		return n_selecting=1;	}
	un_sel(){	return n_selecting=0;	}
	is_sel(){	return n_selecting;		}
};
// Xgr[{
class GLISTVIEW_BODY_WIN : public GWIN {
	GCOMMON m_head_ctrl;
	GFONT m_gfont;
	int m_head_len, m_focus_item_num;
	XLIST<int> m_width_list;
	SCROLL_BAR m_v_scroll_bar, m_h_scroll_bar;
	public :
	PLIST<GLISTVIEW_BODY_WIN_ITEM> m_data;

	GLISTVIEW_BODY_WIN(){
		m_gfont.set_size(13);
		m_head_len=m_focus_item_num=0;
	}
	virtual redraw(int f=0){
		GWIN_BASE::redraw(f);
		m_head_ctrl.redraw(f);
	}
	// ACeI
	sel(int n){		if (m_data[n]) m_data[n]->sel();	return 0;	}
	un_sel(int n){	if (m_data[n]) m_data[n]->un_sel();	return 0;	}
	is_sel(int n){	if (m_data[n]) return m_data[n]->is_sel(); return -1;	}

	// ACeύX
	del_allitems(){ m_data.del_all();	return 0; }
	set_column(char *str, int column_num, int width);
	add_column(char *add_name, int width);
	set_item(char *str, int item_num, int column_num);
	add_item(char *str);
	del_item(int item_num){ m_data.pop(item_num); 	return 0; }

	// ACe
	get_item_by_pos(POINT po);
	get_sel(start_num=0);
	get_len(){ return m_data.size(); }
	get_column(STR* pstr, int column_num){ return m_head_ctrl.get_column(pstr, column_num); }

	// vV[Wn
	make(HWND parent, char *name, int style, int x, int y, int w, int h);
	virtual LRESULT CALLBACK EachProc(UINT msg, WPARAM wp, LPARAM lp) ;
	pre_on_paint();
	on_mou_up_right(WPARAM wp, LPARAM lp) ;
	on_mou_up_left(WPARAM wp, LPARAM lp) ;
	on_mou_move(WPARAM wp, LPARAM lp) ;
	on_notify(WPARAM wp, LPARAM lp) ;
	on_vscroll(WPARAM wp, LPARAM lp) ;
	on_hscroll(WPARAM wp, LPARAM lp) ;
	on_mousewheel(WPARAM wp, LPARAM lp);
	on_mou_dblclk		(WPARAM wp, LPARAM lp);
	on_drop(WPARAM wp, LPARAM lp);
	virtual set_posize(int x, int y, int cx, int cy);
	virtual on_size(WPARAM wp, LPARAM lp);

	// ֗
	on_timer(WPARAM wp, LPARAM lp) ;
	font_update();
	get_font_height();
	adjust_posize();
	set_scroll_bar();
	enum { IDT_SCROLL_UPDATE=1 };
};
GLISTVIEW_BODY_WIN::on_mou_up_right(WPARAM wp, LPARAM lp){
	SendMessage(GetParent(m_hwnd), WM_RBUTTONUP, wp, lp);
	return 0;
}
GLISTVIEW_BODY_WIN::on_mou_dblclk		(WPARAM wp, LPARAM lp){
	SendMessage(GetParent(m_hwnd), WM_LBUTTONDBLCLK, wp, lp);
	return 0;
}
GLISTVIEW_BODY_WIN::on_drop(WPARAM wp, LPARAM lp){
	SendMessage(GetParent(m_hwnd), WM_DROPFILES, wp, lp);
	return 0;
}
// ^C}[
GLISTVIEW_BODY_WIN::on_timer(WPARAM wp , LPARAM lp){
	switch(wp) {
	case IDT_SCROLL_UPDATE:	
		kill_timer(IDT_SCROLL_UPDATE);
		set_scroll_bar();		break;
	}
	return 0;
}
GLISTVIEW_BODY_WIN::on_mousewheel(WPARAM wp, LPARAM lp){
	m_v_scroll_bar.on_mousewheel(wp, lp);
	redraw(1);
	return 0;
}
GLISTVIEW_BODY_WIN::on_vscroll(WPARAM wp, LPARAM lp){
	m_v_scroll_bar.on_scroll(wp, lp);
	redraw(1);
	return 0;
}
GLISTVIEW_BODY_WIN::on_hscroll(WPARAM wp, LPARAM lp){
	m_h_scroll_bar.on_scroll(wp, lp);
	m_head_ctrl.set_pos(-m_h_scroll_bar.get_pos(), 0);
	redraw(1);
	return 0;
}
GLISTVIEW_BODY_WIN::set_scroll_bar(){
	POSIZE head_pz=m_head_ctrl.get_out_posize();
	POSIZE pz=get_in_posize();
	int i, ww=0;
	for(i=0;i<m_head_len;i++) ww+=m_width_list[i];
	head_pz.cx=(pz.cx>ww)? pz.cx : ww;
	m_head_ctrl.set_size(head_pz.cx, head_pz.cy);
	m_v_scroll_bar.set_range(0, m_data.size()+1, (pz.cy-head_pz.cy)/get_font_height());
	m_h_scroll_bar.set_range(0, ww, pz.cx+6);
	m_head_ctrl.redraw(1);
	redraw(1);
	return 0;
}

// IACeEQbg
GLISTVIEW_BODY_WIN::get_item_by_pos(POINT po){
	POSIZE head_poze=m_head_ctrl.get_out_posize();
	po.y-=(head_poze.y+head_poze.cy);
	int fh=get_font_height();
	int target=po.y/fh + m_v_scroll_bar.get_pos()-1;
	if (target>=0 && target<m_data.size()) return target;
	return -1;
}
// IACeEQbg
GLISTVIEW_BODY_WIN::get_sel(int start_num){
	for(int i=start_num;i<m_data.size();i++){
		if (is_sel(i)) return i;
	}
	return -1;
}
// wb_ERg[̈ʒu␳iޕύX̫ĕύXٕ`ύX) 
GLISTVIEW_BODY_WIN::adjust_posize(){
	POSIZE pz=get_in_posize();
	int i, y=0, fh=get_font_height();
	m_head_ctrl.set_posize(0,0,pz.cx, fh+6);
	for(i=0;i<m_head_len;i++){
		m_width_list[i] = m_head_ctrl.get_column_width(i);
	}
	set_scroll_bar();
	return 0;
}
// TCYύXibyvV[Wj
GLISTVIEW_BODY_WIN::on_size(WPARAM wp, LPARAM lp){
	if (wp==SIZE_MINIMIZED ) return 0;
	adjust_posize();
	return 0;
}
// TCYύXiŏIj
GLISTVIEW_BODY_WIN::set_posize(int x, int y, int cx, int cy){
	if (!m_hwnd) return 0;
	GWIN_BASE::set_posize(x, y, cx, cy);
	adjust_posize();
	return 0;
}
// Ps̍
GLISTVIEW_BODY_WIN::get_font_height(){
	HDC hdc = GetDC(m_hwnd);
	SelectObject(hdc, m_gfont.m_hfont);
	SIZE size=get_str_size(hdc, "M");
	ReleaseDC(m_hwnd, hdc);
	return size.cy;
}
// tHgXV
GLISTVIEW_BODY_WIN::font_update(){
	m_head_ctrl.set_font(m_gfont.m_hfont);
	adjust_posize();
	redraw();
	return 0;
}
// }EXNbNɈACeI
GLISTVIEW_BODY_WIN::on_mou_up_left(WPARAM wp, LPARAM lp) {
	SetFocus(m_hwnd);
	POINT po;
	GetCursorPos(&po);
	ScreenToClient(m_hwnd, &po);
	POSIZE head_poze=m_head_ctrl.get_out_posize();
	po.y-=(head_poze.y+head_poze.cy);
	int i, fh=get_font_height();
	int target=po.y/fh+m_v_scroll_bar.get_pos();
	if (po.y>0){
		int ctrl_stat=(GetKeyState(VK_CONTROL)<0), shift_stat=(GetKeyState(VK_SHIFT)<0);
		// I
		if (!ctrl_stat){
			// Rg[EL[ĂȂΑSI
			for(i=0;i<m_data.size();i++) un_sel(i);
		}
		if (shift_stat) {
			// VtgEL[ĂȂtH[JXʒuSI
			int max_val, min_val;
			if (m_focus_item_num<target) { min_val=m_focus_item_num; max_val=target;}
			else { min_val=target; max_val=m_focus_item_num; }
			for(i=min_val;i<max_val;i++) sel(i);
		}
		// NbNACȇI
		if (!ctrl_stat){	// Rg[EL[ĂȂΖI
			sel(target);
		}
		else if (is_sel(target)) un_sel(target); else sel(target);
		// tH[JXACȇI
		if (!shift_stat){
			if (target>=0 && target<m_data.size()) m_focus_item_num=target;
		}
	}
	redraw(1);
	return 0;
}
// wb_ERg[烁bZ[W
GLISTVIEW_BODY_WIN::on_notify(WPARAM wp, LPARAM lp){
	LPNMHDR pn=(LPNMHDR)lp;
	NMHEADER *lpnh;
	switch(pn->code){
	case HDN_TRACK:			break;
	case HDN_BEGINTRACK:	break;
	case HDN_ENDTRACK:
		lpnh = (NMHEADER *)lp;
		m_width_list[lpnh->iItem] = lpnh->pitem->cxy;
		redraw(1);
		// windowsG[@set_scroll_bar()ĂԂƃR܂XVȂ
		set_timer(IDT_SCROLL_UPDATE, 100);
		break;

	case HDN_DIVIDERDBLCLICK:	break;

 //	case HDN_BEGINDRAG:	break;hbO͕ύXʂfȂBOS
//	case HDN_ENDDRAG:	break;
	case HDN_GETDISPINFO:	break;
	case HDN_ITEMCHANGED:	break;
	case HDN_ITEMCLICK:		break;
	case HDN_ITEMDBLCLICK:	break;
	}
	return 0;
}
// vV[Wion_paint̓I[o[[hpɂƂƂj
LRESULT CALLBACK GLISTVIEW_BODY_WIN::EachProc(UINT msg, WPARAM wp, LPARAM lp){
	switch(msg){
	case WM_PAINT : pre_on_paint();on_paint(); break;
	case WM_MOUSEMOVE : on_mou_move(wp, lp); break;
	default : return GWIN::EachProc(msg, wp, lp);
	}
	return DefWindowProc(m_hwnd, msg, wp, lp);
}
GLISTVIEW_BODY_WIN::on_mou_move(WPARAM wp, LPARAM lp){
	POINT po;
	GetCursorPos(&po);
	ScreenToClient(m_hwnd, &po);
//	set_cursor(IDC_ARROW);
	return 0;
}
// ACeݒ
GLISTVIEW_BODY_WIN::set_item(char *a_str, int item_num, int column_num){
	GLISTVIEW_BODY_WIN_ITEM *pitem=m_data[item_num];
	STR *pstr;
	if (pitem) {
		pstr=pitem->m_buf[column_num];
		if (pstr) *pstr = a_str;
	}
	set_scroll_bar();
	redraw(1);
	return 0;
}
// s̒ǉ
GLISTVIEW_BODY_WIN::add_item(char *a_str){
	GLISTVIEW_BODY_WIN_ITEM *pitem= new GLISTVIEW_BODY_WIN_ITEM;
	m_data.pushp(pitem);
	STR *pstr;
	for(int ix=0;ix<m_head_len;ix++) {
		pstr=new STR;
		pitem->m_buf.pushp(pstr);
	}
	if (a_str){
		pstr=pitem->m_buf[0];
		if (pstr) *pstr = a_str;
	}
	set_scroll_bar();
	redraw(1);
	return 0;
}
GLISTVIEW_BODY_WIN::set_column(char *str, int column_num, int width){
	m_head_ctrl.set_column(str, column_num, width);
	set_scroll_bar();
	redraw(1);
	return 0;
}
// ̒ǉ
GLISTVIEW_BODY_WIN::add_column(char *add_name, int width){
	m_width_list.push(width+2);
	m_head_len++;
	m_head_ctrl.add_column(add_name, width);
	GLISTVIEW_BODY_WIN_ITEM *pitem;
	STR *pstr;
	for(int i=0;i<m_data.size();i++){
		pitem=m_data[i];
		if (pitem) {
			pstr=new STR;
			pitem->m_buf.pushp(pstr);
		}
	}
	set_scroll_bar();
	redraw(1);
	return 0;
}
// `
GLISTVIEW_BODY_WIN::pre_on_paint(){
	STR *pstr;
	GLISTVIEW_BODY_WIN_ITEM *pitem;
	RECT rc;
	GetClientRect(m_hwnd, &rc);
	int iy, ix, pos_x=0, winx=rc.right, head_height=0;
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(m_hwnd , &ps);
	SelectObject(hdc, m_gfont.m_hfont);
	SIZE size=get_str_size(hdc, "");
	POSIZE head_poze=m_head_ctrl.get_out_posize();
	head_height=head_poze.y+head_poze.cy;
	SetBkMode(hdc, TRANSPARENT);	// eLXgwi͕`悵Ȃ
	// ACe`
	for(iy=0;iy<m_data.size();iy++){
		pos_x=2-m_h_scroll_bar.get_pos();
		pitem=m_data[iy+m_v_scroll_bar.get_pos()];
		if (!pitem) continue;
		rc.top=iy*size.cy+head_height;
		rc.bottom=rc.top+size.cy;
		if (pitem->is_sel()) 
			fill(hdc, 0, rc.top, winx, rc.bottom-rc.top, GetSysColor(COLOR_HIGHLIGHT));
		for(ix=0;ix<m_head_len;ix++){
			pstr=pitem->m_buf[ix];
			if (pstr && pstr->buf) {
				rc.left=pos_x;
				rc.right=rc.left+m_width_list[ix]-4;
				if (pitem->is_sel()) {
			//		SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
					SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
				}else {
			//		SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
					SetTextColor(hdc, GetSysColor(COLOR_WINDOWTEXT));
				}
				DrawText(hdc, pstr->buf, strlen(pstr->buf), &rc, DT_END_ELLIPSIS);
			}
			pos_x+=m_width_list[ix];
		}
	}
	EndPaint(m_hwnd , &ps);
	return 0;
}
// 
GLISTVIEW_BODY_WIN::make(HWND parent, char *name, int style, int x, int y, int w, int h){
	GWIN::make(parent, NULL, name, style | WS_CLIPCHILDREN | WS_BORDER | WS_VSCROLL | WS_HSCROLL, x, y, w, h);
	add_style(WS_BORDER, WS_EX_ACCEPTFILES);	// | WS_EX_CLIENTEDGE̓Rg[H
	RECT rc;
	GetClientRect(m_hwnd, &rc);
	m_head_ctrl.make_header(m_hwnd, 1, 0,0, rc.right, 20);
	m_v_scroll_bar.make(m_hwnd, 'v');
	m_h_scroll_bar.make(m_hwnd, 'h');
	font_update();
	return 0;
}
//==========================================
//	GLISTVIEW								
//==========================================
class GLISTVIEW : public GWIN{
	int m_draw_name_flag;
	GFONT m_gfont;
	public:
	GLISTVIEW(){
		m_draw_name_flag=1;
		m_gfont.set_size(13);
	}
	GLISTVIEW_BODY_WIN m_body_win;
	virtual redraw(int f=0){
		GWIN_BASE::redraw(f);
		m_body_win.redraw(f);
	}
	set_draw_name_on()	{ m_draw_name_flag=1; adjust_posize();	return 0; }
	set_draw_name_off()	{ m_draw_name_flag=0; adjust_posize();	return 0; }

	sel(int n){		return m_body_win.sel(n);	}
	un_sel(int n){	return m_body_win.un_sel(n);	}
	is_sel(int n){	return m_body_win.is_sel(n);	}

	// ACe
	get_len(){	return m_body_win.get_len(); }
	get_item_by_pos(POINT po){	return m_body_win.get_item_by_pos(po);	};
	get_sel(start_num=0){		return m_body_win.get_sel(start_num);	};
	get_column(STR* pstr, int column_num){ return m_body_win.get_column(pstr, column_num); }

	// ACeύX
	del_allitems(){ return m_body_win.del_allitems(); }
	set_column(char *str, int column_num, int width){ return m_body_win.set_column(str,column_num, width); };
	add_column(char *add_name, int width){ return m_body_win.add_column(add_name, width); };
	set_item(char *str, int item_num, int column_num){ return m_body_win.set_item(str, item_num, column_num); };
	add_item(char *str){ return m_body_win.add_item(str); };
	del_item(int item_num){ return m_body_win.del_item(item_num); };

	LRESULT CALLBACK EachProc(UINT msg, WPARAM wp, LPARAM lp);
	make(HWND parent, char *name, int style, int x, int y, int w, int h);
	pre_on_paint();
	adjust_posize();
	virtual set_posize(int x, int y, int cx, int cy);
	virtual set_size(int cx, int cy);
	virtual on_size(WPARAM wp, LPARAM lp);
	virtual on_create_x();
};
GLISTVIEW::adjust_posize(){
	POSIZE pz=get_in_posize();
	int y=0;
	HDC hdc = GetDC(m_hwnd);
	SelectObject(hdc, m_gfont.m_hfont);
	SIZE size=get_str_size(hdc, "M");
	ReleaseDC(m_hwnd, hdc);
	if (m_draw_name_flag) y=size.cy;
	m_body_win.set_posize(0, y, pz.cx, pz.cy-y);
	return 0;
}

GLISTVIEW::pre_on_paint(){
	PAINTSTRUCT ps;
	STR tmp_name;
	RECT rc;
	GetClientRect(m_hwnd, &rc);
	HDC hdc = BeginPaint(m_hwnd , &ps);
	SelectObject(hdc, m_gfont.m_hfont);
	SIZE size=get_str_size(hdc, "");
	SetBkMode(hdc, TRANSPARENT);	// eLXgwi͕`悵Ȃ
	if (m_draw_name_flag) {
		fill(hdc, 0,0, rc.right, size.cy+1, GetSysColor(COLOR_BTNFACE ));
		get_text(&tmp_name);
		TextOut(hdc, 0,0, tmp_name.buf, strlen(tmp_name.buf));
	}
	EndPaint(m_hwnd , &ps);
	return 0;
}
// TCYύXibyvV[Wj
GLISTVIEW::on_size(WPARAM wp, LPARAM lp){
	if (wp==SIZE_MINIMIZED ) return 0;
	adjust_posize();
	return 0;
}
// TCYύXiŏIj
GLISTVIEW::set_posize(int x, int y, int cx, int cy){
	if (!m_hwnd) return 0;
	GWIN_BASE::set_posize(x, y, cx, cy);
	adjust_posize();
	return 0;
}
// TCYύXiŏIj
GLISTVIEW::set_size(int cx, int cy){
	if (!m_hwnd) return 0;
	GWIN_BASE::set_size(cx, cy);
	adjust_posize();
	return 0;
}
// vV[Wion_paint̓I[o[[hpɂƂƂj
LRESULT CALLBACK GLISTVIEW::EachProc(UINT msg, WPARAM wp, LPARAM lp){
	switch(msg){
	case WM_PAINT : pre_on_paint();on_paint(); break;
	default : return GWIN::EachProc(msg, wp, lp);
	}
	return DefWindowProc(m_hwnd, msg, wp, lp);
}
GLISTVIEW::make(HWND parent, char *name, int style, int x, int y, int w, int h){
	GWIN::make(parent, NULL, name, style | WS_CLIPCHILDREN | WS_BORDER, x, y, w, h);
	set_bg_color(GetSysColorBrush(COLOR_BTNFACE ));
	m_body_win.make(m_hwnd, name,
			WS_VISIBLE | WS_CLIPCHILDREN | WS_CHILD | WS_BORDER | WS_VSCROLL | WS_HSCROLL, 0, 0, w, h);
	adjust_posize();
	on_create_x();
	size_update();
	return 0;
}
GLISTVIEW::on_create_x(){return 0;};

#endif	// _GLISTVIEW_H_
