
#ifndef _GOBJ_H_
#define _GOBJ_H_

#include <windows>

// ~[gsNZ	
log_to_pix(HDC hdc, int val, int vh_flag){
	if (vh_flag=='h') return val * GetDeviceCaps(hdc, HORZRES)/GetDeviceCaps(hdc, HORZSIZE);
	if (vh_flag=='v') return val * GetDeviceCaps(hdc, VERTRES)/GetDeviceCaps(hdc, VERTSIZE); // *mm/pix
	return 1;
}
// sNZ~[g	
pix_to_log(HDC hdc, int val, int vh_flag){
	if (vh_flag=='h') return val * GetDeviceCaps(hdc, HORZSIZE)/GetDeviceCaps(hdc, HORZRES);
	if (vh_flag=='v') return val * GetDeviceCaps(hdc, VERTSIZE)/GetDeviceCaps(hdc, VERTRES); // *pix/mm
	return 1;
}
get_dc_width(HDC hdc){	return GetDeviceCaps(hdc, HORZRES); }
get_dc_height(HDC hdc){	return GetDeviceCaps(hdc, VERTRES); }

//===============tHgTCYύX===================================
HFONT change_font_size_rel(HFONT hfont, int val){
	LOGFONT lf;
	if (!GetObject(hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=lf.lfHeight*val;
	return CreateFontIndirect(&lf);
}
HFONT change_font_size(HFONT hfont, int val){
	LOGFONT lf;
	if (!GetObject(hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=val;
	return CreateFontIndirect(&lf);
}
//===============hԂ===================================
fill(HDC hdc, int x, int y, int w, int h, COLORREF col){
	HBRUSH br;
	br=CreateSolidBrush(col);
//	HBRUSH old_br=(HBRUSH)SelectObject(hdc, br);
//	Rectangle(hdc, x, y, w, h);
	RECT rc;
	rc.top=y;
	rc.left=x;
	rc.right=x+w;
	rc.bottom=y+h;
	FillRect(hdc, &rc, br);
	SelectObject(hdc, (HBRUSH)GetStockObject(BLACK_BRUSH));
	return DeleteObject(br);
}
fill(HDC hdc, int x, int y, int w, int h, HBRUSH hbr){
	RECT rc;
	rc.top=y;
	rc.left=x;
	rc.right=x+w;
	rc.bottom=y+h;
	FillRect(hdc, &rc, hbr);
	SelectObject(hdc, (HBRUSH)GetStockObject(BLACK_BRUSH));
	return 0;
}
line_draw(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col, int thick=1){
	HPEN hpen=CreatePen(PS_SOLID, thick, col);
	SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, ey);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return DeleteObject(hpen);
}

rim_draw(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col, int thick=1){
	HPEN hpen=CreatePen(PS_SOLID, thick, col);
	SelectObject(hdc, hpen);
//	HPEN old_hpen=(HPEN)SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, sy);
	LineTo(hdc, ex, ey);
	LineTo(hdc, sx, ey);
	LineTo(hdc, sx, sy);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return DeleteObject(hpen);
}
rim_draw(HDC hdc, int sx, int sy, int ex, int ey, HPEN hpen){
	SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, sy);
	LineTo(hdc, ex, ey);
	LineTo(hdc, sx, ey);
	LineTo(hdc, sx, sy);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return 0;
}

//==========================================
//	GFONT									
//==========================================
class GFONT {
	public :
	HFONT m_hfont;
	set_size_rel(int val);
	set_size(int val);
	//tHgTCYύX
	GFONT(){
		m_hfont=NULL;
	}
	~GFONT(){
		DeleteObject(m_hfont);
	}
};
GFONT::set_size_rel(int val){
	LOGFONT lf;
	if (!GetObject(m_hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=lf.lfHeight*val;
	DeleteObject(m_hfont);
	m_hfont=CreateFontIndirect(&lf);
	return 0;
}
GFONT::set_size(int val){
	LOGFONT lf;
	if (!GetObject(m_hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=val;
	DeleteObject(m_hfont);
	m_hfont=CreateFontIndirect(&lf);
	return 0;
}
//==========================================
// 	GFILE									
//==========================================
class GFILE {
	public:
	OPENFILENAME ofn;
	TCHAR m_init_dir[MAX_PATH], m_fullpath[MAX_PATH], m_filename[256], m_custom_filter[256];
	STR m_filter;
	int m_filter_size;
	char *m_ext;	// gq

	GFILE();
	open_dlg(HWND hwnd);
	save_dlg(HWND hwnd, char *filter);
	set(char *a_s);
	set_ext();
	add_filter(char *acc_str, char *ext_str);
	get_file_size();
};
GFILE::get_file_size(){
	int filesize=-1;
	HANDLE hFile = CreateFile( m_fullpath, GENERIC_READ, 0, NULL,	OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if (hFile != INVALID_HANDLE_VALUE) filesize=GetFileSize(hFile , NULL);
	CloseHandle(hFile);
	return filesize;
};
GFILE::set_ext(){
	char *s=m_filename;
	m_ext=NULL;
	int i, slen=strlen(s);
	for(i=slen-1;i>0;i--){
		if (s[i]=='.') { m_ext=s+i+1; break; }
	}
	return 0;
}
GFILE::save_dlg(HWND hwnd, char *filter){
	ofn.Flags = 0;
	m_filter_size=0;
	add_filter("Ŷļނ̧ [*.nak]\0", "*.nak\0");
	add_filter("ׂĕ\ [*.*]\0", "*.*\0");
	if (!GetSaveFileName(&ofn)) return -1;
	ofn.lpstrInitialDir =NULL;
	set_ext();
	return 0;
}
GFILE::open_dlg(HWND hwnd){
	m_filter_size=0;
	add_filter("ׂĕ\ [*.*]\0", "*.*\0");
	add_filter("C ̧ [*.c]\0", "*.c;*.cpp;*.h;*.hpp\0");
	add_filter("÷ ̧ [*.txt]\0", "*.txt\0");
	add_filter("HTML ̧ [*.htm]\0", "*.htm;*.html\0");
	ofn.Flags = OFN_HIDEREADONLY; // | OFN_FILEMUSTEXIST
	if (!GetOpenFileName(&ofn)) return -1;
	ofn.lpstrInitialDir =NULL;
	set_ext();
	return 0;
}
GFILE::set(char *a_s){
	char *long_s;
	int i, len = GetLongPathName(a_s, NULL, -1);
	long_s = new char[len];
	GetLongPathName(a_s, long_s, len);
	strcpy(m_fullpath, long_s);
	for(i=strlen(long_s)-1;i>0;i--){
		if (long_s[i]=='\\') { strcpy(m_filename, long_s+i+1); break; }
	}
	delete long_s;
	set_ext();
	return 0;
}
GFILE::add_filter(char *acc_str, char *ext_str){
	char *s;
	int len;
	len=strlen(acc_str)+strlen(ext_str)+4+m_filter_size;
	if (len>m_filter.len) m_filter.resize(len);
	s=m_filter.buf + m_filter_size;
	strcpy(s, acc_str);		s += strlen(acc_str)+1;	// 
	strcpy(s, ext_str);		s += strlen(ext_str)+1;	// gq
	*s='\0';
	m_filter_size=len-2;
	return 0;
}
GFILE::GFILE(){
	m_ext=NULL;
	memset(&ofn, 0, sizeof(OPENFILENAME));
	m_custom_filter[0]='\0';
	m_fullpath[0]='\0';
	m_filename[0]='\0';
	m_filter_size=0;
	m_filter.resize(200);
	add_filter("C ̧ [*.c]\0", "*.c;*.cpp;*.h;*.hpp\0");
	add_filter("÷ ̧ [*.txt]\0", "*.txt\0");
	add_filter("HTML ̧ [*.htm]\0", "*.htm;*.html\0");
	add_filter("ׂĕ\ [*.*]\0", "*.*\0");

	ofn.lStructSize = sizeof (OPENFILENAME);
	ofn.lpstrFilter = m_filter.buf;
	ofn.lpstrCustomFilter = m_custom_filter;
	ofn.nMaxCustFilter = 256;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = m_fullpath;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = m_filename;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	GetCurrentDirectory(MAX_PATH, m_init_dir);
	ofn.lpstrInitialDir =m_init_dir;
	return ;
}

//==========================================
// 	SCROLL_BAR								
//==========================================
class SCROLL_BAR {
	SCROLLINFO m_scr_info;
	int m_bar_type;
	HWND m_hwnd;
	public:
	get_pos(){ return m_scr_info.nPos; }
	SCROLL_BAR(){
		m_bar_type=0;
		m_hwnd=NULL;
		memset(&m_scr_info, 0, sizeof(SCROLLINFO));

		m_scr_info.cbSize = sizeof(SCROLLINFO);
		m_scr_info.fMask = SIF_PAGE | SIF_RANGE;// | SIF_DISABLENOSCROLL;
		m_scr_info.nMin = m_scr_info.nMax = 0;
		m_scr_info.nPage = 1;
	}
	make(HWND a_hwnd, int vh){
		m_hwnd=a_hwnd;
		if (vh=='v') m_bar_type=SB_VERT;
		if (vh=='h') m_bar_type=SB_HORZ;
		set();
		return 0;
	}
	on_scroll(WPARAM wp , LPARAM lp);
	on_mousewheel(WPARAM wp, LPARAM lp);
	set_range(int min_val, int max_val, int page_val);
	set_pos(int pos_val);
	adjust_pos();
	set(bool flag=TRUE);
};
SCROLL_BAR::set(bool flag){
	if (!m_hwnd)return 0;
	return SetScrollInfo(m_hwnd, m_bar_type, &m_scr_info, flag);
}

// }EXzC[	
SCROLL_BAR::on_mousewheel(WPARAM wp, LPARAM lp){
	static char working=0;
	if (working || !m_hwnd)return 0;
	working=1;
	short n=(short)HIWORD(wp);
	int old_pos  = m_scr_info.nPos;
	if (n>0 && m_scr_info.nPos>(m_scr_info.nMin+1)) m_scr_info.nPos-=2;
	else if (n<0) m_scr_info.nPos+=2;
	adjust_pos();
	set();
	Sleep(10);
	working=0;
	return (old_pos != m_scr_info.nPos);
	//	Mouse_stat.fwkeys=(int)wprm; //{^
	//	Mouse_stat.xpos=(int)LOWORD(lp); //wW
	//	Mouse_stat.ypos=(int)HIWORD(lp); //xW 
}


SCROLL_BAR::adjust_pos(){
	int min_val=m_scr_info.nMin, max_val=m_scr_info.nMax, page_val=m_scr_info.nPage;
	if (m_scr_info.nPos > (max_val-page_val+1)) { m_scr_info.nPos=max_val-page_val+1; }
	if (m_scr_info.nPos < min_val) m_scr_info.nPos = min_val;
	m_scr_info.fMask = SIF_POS;// | SIF_DISABLENOSCROLL;
	return 0;
}
SCROLL_BAR::set_pos(int pos_val){
	m_scr_info.nPos=pos_val;
	adjust_pos();
	set();
	return 0;
}
// y[Wݒ	
SCROLL_BAR::set_range(int min_val, int max_val, int page_val){
	m_scr_info.nPage=page_val;
	m_scr_info.nMax = max_val;
	m_scr_info.nMin = min_val;
	adjust_pos();
	m_scr_info.fMask = SIF_POS | SIF_PAGE | SIF_RANGE;// | SIF_DISABLENOSCROLL;
	set();
	return 0;
}

// XN[	
SCROLL_BAR::on_scroll(WPARAM wp, LPARAM lp){
	if (!m_hwnd) {
		dialog("܂XN[o[̐eEBhEݒ肳ĂȂB");return 0;
	}
	int old_npos = m_scr_info.nPos;
	switch(LOWORD(wp)) {
	case SB_TOP:		m_scr_info.nPos = m_scr_info.nMin;break;
	case SB_BOTTOM:		m_scr_info.nPos = m_scr_info.nMax;break;
	case SB_LINEUP:		m_scr_info.nPos--;		break;
	case SB_LINEDOWN:	m_scr_info.nPos++;		break;
	case SB_PAGEUP:		m_scr_info.nPos -= m_scr_info.nPage;break;
	case SB_PAGEDOWN:	m_scr_info.nPos += m_scr_info.nPage;break;
	case SB_THUMBPOSITION:	m_scr_info.nPos = HIWORD(wp);break;
	case SB_THUMBTRACK:		m_scr_info.nPos = HIWORD(wp);break;
	}
	adjust_pos();
	if (old_npos == m_scr_info.nPos) return 0;
	m_scr_info.fMask = SIF_POS;// | SIF_DISABLENOSCROLL;
	set();
	return 0;
}

#endif	//_GOBJ_H_
