
#ifndef _GSPLITTER_H_
#define _GSPLITTER_H_

#include "gwin.h"
#include "gobj.h"

//==========================================
// 	EBhEt[					
//==========================================
class GSPLIT_BAR {
	public :
	POSIZE m_poze;
	char m_type, m_grasping;
	GSPLIT_BAR *m_p_parent_A, *m_p_parent_B;
	XLIST<GSPLIT_BAR*> m_children_A, m_children_B;

	GSPLIT_BAR(){
		m_type=m_grasping=0;
		m_p_parent_A=m_p_parent_B=NULL;
	}
	apply(POINT *ppo);
	is_overing(POINT *ppo);
	make(char vh_flag, GSPLIT_BAR *p_parent_A, GSPLIT_BAR *p_parent_B, int x, int y, int w, int h);
	draw(HDC hdc, POINT *ppo);
};
GSPLIT_BAR::apply(POINT *ppo){
	int i, x, y;
	if (ppo->x<0) ppo->x=0;
	if (ppo->y<0) ppo->y=0;
	POSIZE *ppz;
	if (m_type=='h') {
		m_poze.y=ppo->y;
		for(i=0;i<m_children_A.size();i++) {
			ppz=&m_children_A[i]->m_poze;
			y=ppz->cy+ppz->y;
			ppz->y=m_poze.y;
			ppz->cy=y-ppz->y;
		}
		for(i=0;i<m_children_B.size();i++) {
			ppz=&m_children_B[i]->m_poze;
			ppz->cy = m_poze.y+m_poze.cy - ppz->y;
		}
	}
	if (m_type=='v') {
		m_poze.x=ppo->x;
		for(i=0;i<m_children_A.size();i++) {
			ppz=&m_children_A[i]->m_poze;
			x=ppz->cx+ppz->x;
			ppz->x=m_poze.x;
			ppz->cx=x-ppz->x;
		}
		for(i=0;i<m_children_B.size();i++) {
			ppz=&m_children_B[i]->m_poze;
			ppz->cx = m_poze.x+m_poze.cx - ppz->x;
		}
	}
	return 0;
}
// `
GSPLIT_BAR::draw(HDC hdc, POINT *ppo){
	int x, y, cx, cy;
	if (ppo->x<0) ppo->x=0;
	if (ppo->y<0) ppo->y=0;
	if (m_type=='h') {
		x=m_poze.x;
		if (m_p_parent_A && m_p_parent_A->m_grasping) x=ppo->x;
		if (m_p_parent_B && m_p_parent_B->m_grasping) cx=ppo->x+m_p_parent_B->m_poze.cx;
		else cx=m_poze.cx+m_poze.x-2;
		line_draw(hdc, x, ppo->y, cx, ppo->y, GetSysColor(COLOR_GRAYTEXT), m_poze.cy);
	}
	if (m_type=='v') {
		y=m_poze.y;
		if (m_p_parent_A && m_p_parent_A->m_grasping) y=ppo->y;
		if (m_p_parent_B && m_p_parent_B->m_grasping) cy=ppo->y+m_p_parent_B->m_poze.cy;
		else cy=m_poze.cy+m_poze.y-2;
		line_draw(hdc, ppo->x, y, ppo->x, cy, GetSysColor(COLOR_GRAYTEXT), m_poze.cx);
	}
	return 0;
}
GSPLIT_BAR::is_overing(POINT *ppo){
	if (!ppo) return 0;
	if (ppo->x>=m_poze.x && ppo->y>=m_poze.y
		&& ppo->x<=(m_poze.x+m_poze.cx) && ppo->y<=(m_poze.y+m_poze.cy)) return 1;
	return 0;
}
GSPLIT_BAR::make(char vh_flag, GSPLIT_BAR *p_parent_A, GSPLIT_BAR *p_parent_B, int x, int y, int w, int h){
	m_poze.set(x, y, w, h);
	m_type=vh_flag;
	m_p_parent_A=p_parent_A;
	m_p_parent_B=p_parent_B;
	return 0;
}
//==========================================
// 	EBhEVXe					
//==========================================
class GSPLITTER {
	GWIN* m_master;
	PLIST<GSPLIT_BAR> m_bars;
	XLIST<GSPLIT_BAR*> m_grasping_bar;
	XLIST<GSPLIT_BAR*> m_h_bar_order, m_v_bar_order;
	int m_base_thickness;
	POSIZE m_master_poze;
	public :

	GSPLIT_FRAME(){
		m_master=NULL;
		m_base_thickness=0;
	}
	make(GWIN* master, int base_thickness);		// 
	adjust_grasp_po(POINT *ppo);
	change_master_size();
	get_bar_pos(int bar_num) {
		if (!m_master) return 0;
		GSPLIT_BAR* pbar=m_bars[bar_num];
		if (pbar){
			if (pbar->m_type=='v') return pbar->m_poze.x;
			if (pbar->m_type=='h') return pbar->m_poze.y;
		}
		return 0;
	}
	set_bar_pos(int bar_num, int pos) {
		if (!m_master) return 0;
		GSPLIT_BAR* pbar=m_bars[bar_num];
		if (pbar){
			if (pbar->m_type=='v') return pbar->m_poze.x=pos;
			if (pbar->m_type=='h') return pbar->m_poze.y=pos;
		}
		return 0;
	}
	is_overing(POINT *ppo);
	set_cursor(POINT *ppo);
	draw(HDC hdc, POINT *ppo);
	is_grasp();
	grasp(POINT *ppo);
	leave(POINT *ppo);
	add_bar_indep(char vh_flag, int x, int y, int length);
	add_bar(char vh_flag, int parent_a, int parent_b, int pos);
};

// o[
GSPLITTER::add_bar(char vh_flag, int parent_a, int parent_b, int pos){
	if (!m_master) return 0;
	GSPLIT_BAR *pbar= new GSPLIT_BAR;
	m_bars.pushp(pbar);
	POSIZE pz=m_master->get_in_posize();
	int i, x, y, length;
	if (vh_flag=='h')		{
		x=pz.x;
		length=pz.cx;
		if (m_bars[parent_a]) x=m_bars[parent_a]->m_poze.x;
		if (m_bars[parent_b]) length=m_bars[parent_b]->m_poze.x+m_bars[parent_b]->m_poze.cx-x;
		pbar->make(vh_flag, m_bars[parent_a], m_bars[parent_b], x, pos, length, m_base_thickness);
		i=0;
		for(i=0;i<m_h_bar_order.size();i++) if (m_h_bar_order[i]->m_poze.y>pos) break;
		m_h_bar_order.push(pbar, i);
	}
	else if (vh_flag=='v')	{
		y=pz.y;
		length=pz.cy;
		if (m_bars[parent_a]) y=m_bars[parent_a]->m_poze.y;
		if (m_bars[parent_b]) length=m_bars[parent_b]->m_poze.y+m_bars[parent_b]->m_poze.cy-y;
		pbar->make(vh_flag, m_bars[parent_a], m_bars[parent_b], pos, y, m_base_thickness, length);
		i=0;
		for(i=0;i<m_v_bar_order.size();i++) if (m_v_bar_order[i]->m_poze.x>pos) break;
		m_v_bar_order.push(pbar, i);
	};
	if (m_bars[parent_a]) m_bars[parent_a]->m_children_A.push(pbar);
	if (m_bars[parent_b]) m_bars[parent_b]->m_children_B.push(pbar);
	return 0;
}
// o[ (Ɨ) 
GSPLITTER::add_bar_indep(char vh_flag, int x, int y, int length){
	if (!m_master) return 0;
	GSPLIT_BAR *pbar= new GSPLIT_BAR;
	m_bars.pushp(pbar);
	if (vh_flag=='h')		pbar->make(vh_flag, NULL, NULL, x, y, length, m_base_thickness);
	else if (vh_flag=='v')	pbar->make(vh_flag, NULL, NULL, x, y, m_base_thickness, length);
	return 0;
}
// 
GSPLITTER::make(GWIN* master, int base_thickness){
	m_master=master;
	m_base_thickness = base_thickness;
	if (!m_master) return 0;
	m_master_poze=master->get_in_posize();
	return 0;
}
// `
GSPLITTER::draw(HDC hdc, POINT *ppo){
	if (!is_grasp()) return 0;
	adjust_grasp_po(ppo);	// hbOʒu␳
	int i;
	for(i=0;i<m_grasping_bar.size();i++) {
		m_grasping_bar[i]->draw(hdc, ppo);
	}
	return 0;
}
GSPLITTER::change_master_size(){
	if (!m_master) return 0;
	POSIZE new_pz=m_master->get_in_posize(), *ppz;
	GSPLIT_BAR *pbar;
	int i,x, y, b;
	for(i=0;i<m_bars.size();i++){
		ppz = &m_bars[i]->m_poze;
		ppz->x	= new_pz.cx*ppz->x	/m_master_poze.cx;
		ppz->y	= new_pz.cy*ppz->y	/m_master_poze.cy;
		if (m_bars[i]->m_type=='h') ppz->cx	= new_pz.cx*ppz->cx	/m_master_poze.cx;
		if (m_bars[i]->m_type=='v') ppz->cy	= new_pz.cy*ppz->cy	/m_master_poze.cy;
	}
	// I[o[E`FbN
	y=new_pz.cy-m_base_thickness-2;
	for(i=m_h_bar_order.size()-1;i>=0;i--) {
		if (y<m_h_bar_order[i]->m_poze.y) m_h_bar_order[i]->m_poze.y=y;
		y=m_h_bar_order[i]->m_poze.y-m_base_thickness-2;
	}
	// EI[o[E`FbN
	x=new_pz.cx-m_base_thickness-2;
	for(i=m_v_bar_order.size()-1;i>=0;i--) {
		if (x<m_v_bar_order[i]->m_poze.x) m_v_bar_order[i]->m_poze.x=x;
		x=m_v_bar_order[i]->m_poze.x-m_base_thickness-2;
	}

	// I[o[E`FbN
	y=0;
	for(i=0;i<m_h_bar_order.size();i++) {
		if (y>m_h_bar_order[i]->m_poze.y) m_h_bar_order[i]->m_poze.y=y;
		y=m_h_bar_order[i]->m_poze.y+m_base_thickness+2;
	}
	// I[o[E`FbN
	x=0;
	for(i=0;i<m_v_bar_order.size();i++) {
		if (x>m_v_bar_order[i]->m_poze.x) m_v_bar_order[i]->m_poze.x=x;
		x=m_v_bar_order[i]->m_poze.x+m_base_thickness+2;
	}
	m_master_poze=new_pz;
	return 0;
}
// hbO␳
GSPLITTER::adjust_grasp_po(POINT *ppo){
	if (!m_master) return 0;
	int i, b, min_x=0, min_y=0, max_x, max_y, tx, ty;
	max_x=m_master_poze.cx-m_base_thickness-2;
	max_y=m_master_poze.cy-m_base_thickness-2;
	GSPLIT_BAR *pbar;
	for(i=0;i<m_grasping_bar.size();i++) {
		pbar = m_grasping_bar[i];
		if (pbar->m_type=='h'){
			for(b=0;b<m_h_bar_order.size();b++) {
				if (m_h_bar_order[b]!=pbar){
					ty=m_h_bar_order[b]->m_poze.y;
					if (min_y<ty && ty<pbar->m_poze.y) min_y=ty+m_base_thickness+2;
					if (max_y>ty && ty>pbar->m_poze.y) max_y=ty-m_base_thickness-2;
				}
			}
		}
		if (pbar->m_type=='v'){
			for(b=0;b<m_v_bar_order.size();b++) {
				if (m_v_bar_order[b]!=pbar){
					tx=m_v_bar_order[b]->m_poze.x;
					if (min_x<tx && tx<pbar->m_poze.x) min_x=tx+m_base_thickness+2;
					if (max_x>tx && tx>pbar->m_poze.x) max_x=tx-m_base_thickness-2;
				}
			}
		}
	}
	if (ppo->x<min_x) ppo->x=min_x;
	if (ppo->y<min_y) ppo->y=min_y;
	if (ppo->x>max_x) ppo->x=max_x;
	if (ppo->y>max_y) ppo->y=max_y;
	return 0;
}
// o[
GSPLITTER::leave(POINT *ppo){
	if (!m_master) return 0;
	if (!m_grasping_bar.size()) return 0;
	ReleaseCapture();
	//	ShowCursor(1);
	adjust_grasp_po(ppo);	// hbOʒu␳
	int i;
	for(i=0;i<m_grasping_bar.size();i++) m_grasping_bar[i]->apply(ppo);
	for(i=0;i<m_grasping_bar.size();i++) m_grasping_bar[i]->m_grasping=0;
	m_grasping_bar.del_all();
	return 0;
}
// o[͂ł邩
GSPLITTER::is_grasp(){
	if (!m_master) return 0;
	if (m_grasping_bar.size()) return 1;
	return 0;
}
// o[͂
GSPLITTER::grasp(POINT *ppo){
	if (!m_master) return 0;
	for(int i=0;i<m_bars.size();i++){
		if (m_bars[i]->is_overing(ppo)) {
			m_grasping_bar.push(m_bars[i]);
			m_bars[i]->m_grasping=1;
		}
	}
	if (m_grasping_bar.size()) {
		SetCapture(m_master->m_hwnd);
	//	ShowCursor(0);
	}
	return 0;
}
// }EXEJ[\ύX
GSPLITTER::set_cursor(POINT *ppo){
	if (!m_master) return 0;
	int res=is_overing(ppo);
	if (res){
		HCURSOR old_hcur=NULL;
		if		(res==1) old_hcur=(HCURSOR)SetCursor(LoadCursor(NULL,IDC_SIZENS) );	//㉺
		else if (res==2) old_hcur=(HCURSOR)SetCursor(LoadCursor(NULL,IDC_SIZEWE) );	//E
		else if (res==3) old_hcur=(HCURSOR)SetCursor(LoadCursor(NULL,IDC_SIZEALL));	//S
		if (old_hcur) DestroyCursor(old_hcur);
		return 1;
	}
	return res;
}
// o[̏Ƀ}EXĂ邩
GSPLITTER::is_overing(POINT *ppo){
	if (!m_master) return 0;
	int res=0;
	for(int i=0;i<m_bars.size();i++){
		if (m_bars[i]->is_overing(ppo)) {
			if (m_bars[i]->m_type=='h') res |= 1;
			else if (m_bars[i]->m_type=='v')  res |= 2;
		}
	}
	return res;
}
#endif // _GSPLITTER_H_


