
#ifndef _GTABCON_H_
#define _GTABCON_H_

#include <windows.h>
#include "gwin.h"
#include "gobj.h"
#include "gcommon.h"

//==========================================
//	GTABCON									
//==========================================
class GTABCON : public GWIN {
	typedef GWIN_T<GTABCON> GWIN_GTABCON_T;
	PLIST<GWIN_GTABCON_T> m_child_win_list;

	// qEBhEE}X^[
	static sub_on_command_child_frame(GTABCON* ptab, GWIN *pwin, WPARAM wp, LPARAM lp);
	static on_vscroll_child_frame_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp);
	static on_hscroll_child_frame_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp);

	// qEBhE
	static on_paint_child_static(GTABCON *ptab, GWIN *pwin);
	static on_vscroll_child_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp);
	static on_hscroll_child_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp);
	public :
	GFONT m_gfont;
	GCOMMON m_common;
	GWIN_T<GTABCON> m_child_frame, *m_p_child_win;
	virtual on_paint_child();
	virtual on_vscroll_child(WPARAM wp, LPARAM lp);
	virtual on_hscroll_child(WPARAM wp, LPARAM lp);
	virtual on_vscroll_child_frame(WPARAM wp, LPARAM lp);
	virtual on_hscroll_child_frame(WPARAM wp, LPARAM lp);

	GTABCON(){
		m_p_child_win=NULL;
	}
	HWND get_child(int n){
		if (m_child_win_list[n]) return m_child_win_list[n]->m_hwnd;
		else return NULL;
	}
	GWIN* get_child_p(int n){	return m_child_win_list[n];	}

	redraw(int f=0);
	virtual make(HWND parent_hwnd, char* a_name, int style, int x, int y, int w, int h, HINSTANCE a_hins, char* winc){
		return 0; };
	make(HWND parent_hwnd, char* a_name, int style, int x, int y, int w, int h);
	virtual on_notify(WPARAM wp, LPARAM lp);
	virtual tab_changed();
	virtual on_create_x();
	add_item(char* str, int column_num=0);

	// ^u
	virtual set_size(int cx, int cy);
	virtual set_posize(int x, int y, int cx, int cy);
	POSIZE get_in_posize(){ return m_common.get_in_posize(); }
	del_item(int item_num=-1){ return m_common.del_item(item_num); };
	del_allitems(){ return m_common.del_allitems(); };
	insert_item	(char* str, int item_num, int column_num=0){ return m_common.insert_item(str, item_num, column_num); };
	set_item	(char* str, int item_num, int column_num=0){ return m_common.set_item(str, item_num, column_num); };
	sel(int n){ return m_common.sel(n); };
	get_sel(int istart=-1){ return m_common.get_sel(istart); };
	get_len(){ return m_common.get_len(); };
};
GTABCON::add_item(char* str, int column_num){
	m_common.add_item(str, column_num);

	GWIN_GTABCON_T *pwin = new GWIN_GTABCON_T;
	m_child_win_list.pushp(pwin);
	pwin->send_obj=this;
	pwin->make_ez(m_child_frame.m_hwnd, "tool_body", 0);
	pwin->set_bg_color(GetSysColorBrush(COLOR_BTNFACE ));
	pwin->sub_on_paint=on_paint_child_static;
	pwin->sub_on_vscroll=on_vscroll_child_static;
	pwin->sub_on_hscroll=on_hscroll_child_static;
	return 0;
}
GTABCON::on_hscroll_child(WPARAM wp, LPARAM lp){ return 0; }
GTABCON::on_hscroll_child_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp){
	if (ptab && pwin) ptab->on_hscroll_child(wp, lp);
	return 0;
}
GTABCON::on_vscroll_child(WPARAM wp, LPARAM lp){ return 0; }
GTABCON::on_vscroll_child_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp){
	if (ptab && pwin) ptab->on_vscroll_child(wp, lp);
	return 0;
}
GTABCON::on_paint_child(){ return 0;}
GTABCON::on_paint_child_static(GTABCON *ptab, GWIN *pwin){
	if (ptab && pwin) ptab->on_paint_child();
	return 0;
}

GTABCON::on_vscroll_child_frame(WPARAM wp, LPARAM lp){ return 0; }
GTABCON::on_vscroll_child_frame_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp){
	if (ptab && pwin) ptab->on_vscroll_child_frame(wp, lp);
	return 0;
}
GTABCON::on_hscroll_child_frame(WPARAM wp, LPARAM lp){ return 0; }
GTABCON::on_hscroll_child_frame_static(GTABCON *ptab, GWIN *pwin, WPARAM wp, LPARAM lp){
	if (ptab && pwin) ptab->on_hscroll_child_frame(wp, lp);
	return 0;
}
// qEBhẼR}h
GTABCON::sub_on_command_child_frame(GTABCON* ptab, GWIN *pwin, WPARAM wp, LPARAM lp){
	if (ptab && pwin) SendMessage(GetParent(ptab->m_hwnd), WM_COMMAND, wp, lp);
	return 0;
}
GTABCON::redraw(int f){ return m_common.redraw(f); }
GTABCON::on_create_x(){ return 0;}
GTABCON::on_notify(WPARAM wp, LPARAM lp){
	LPNMHDR pn=(LPNMHDR)lp;
	switch(pn->code){
	case TCN_SELCHANGE:	tab_changed();	break;
	}
	return 0;
};
GTABCON::tab_changed(){
	int i, len=get_len(), n=get_sel();
	for(i=0;i<len;i++) m_child_win_list[i]->hide();
	m_p_child_win=m_child_win_list[n];
//	POSIZE body_poze, poze=get_in_posize();
	if (m_p_child_win){
		m_p_child_win->show();
	}
	return 0;
}
GTABCON::make(HWND parent_hwnd, char* a_name, int style, int x, int y, int w, int h){
	GWIN::make(parent_hwnd, "GTABCON", a_name, style, x, y, w, h);
	m_gfont.set_size(13);

	m_common.make_tab(m_hwnd, 2, 0, 0, w, h);
	m_common.set_font(m_gfont.m_hfont);

	m_child_frame.send_obj=this;
	m_child_frame.sub_on_vscroll=on_vscroll_child_frame_static;
	m_child_frame.sub_on_hscroll=on_hscroll_child_frame_static;
	m_child_frame.sub_on_command=sub_on_command_child_frame;
	m_child_frame.make_ez(m_common.m_hwnd, "child_frame", 0);
	m_child_frame.set_bg_color(GetSysColorBrush(COLOR_BTNFACE ));

	on_create_x();
	m_p_child_win=m_child_win_list[0];
	m_child_frame.show();
	tab_changed();
	return 0;
}

GTABCON::set_size(int cx, int cy){
	if (!m_hwnd) return 0;
	GWIN_BASE::set_size(cx, cy);
	m_common.set_size(cx, cy);
	POSIZE poze=get_in_posize();
	m_child_frame.set_size(poze.cx, poze.cy);
	int i, len=get_len();//, n=get_sel();
	for(i=0;i<len;i++) m_child_win_list[i]->set_size(poze.cx, poze.cy);
	size_update();
	return 0;
}
GTABCON::set_posize(int x, int y, int cx, int cy){
	if (!m_hwnd) return 0;
	GWIN_BASE::set_posize(x, y, cx, cy);
	m_common.set_posize(0, 0, cx, cy);
	POSIZE poze=get_in_posize();
	m_child_frame.set_posize(poze.x, poze.y, poze.cx, poze.cy);
	int i, len=get_len();//, n=get_sel();
	for(i=0;i<len;i++) m_child_win_list[i]->set_posize(0, 0, poze.cx, poze.cy);
	size_update();
	return 0;
}

#endif	// _GTABCON_H_
