
#ifndef _GWIN_H_
#define _GWIN_H_

#include <windows.h>
#include "atom.h"
#include "list.h"

#ifndef WM_MOUSEWHEEL
#include <zmouse.h>
#endif

//==========================================
// 	GWIN_BASE	`						
//==========================================
class GWIN_BASE{
	public:
	HWND m_hwnd;
	make_base(char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id=0, HINSTANCE hins=NULL, LPVOID lp=NULL);
	virtual make_base_ex(int ex_style, char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id=0, HINSTANCE hins=NULL, LPVOID lp=NULL);
	virtual kill(){
		DestroyWindow(m_hwnd);
		m_hwnd=NULL;
	}

	// RXgN^
	GWIN_BASE(){
		m_hwnd=NULL;
	}
	~GWIN_BASE(){};	// fXgN^
	virtual set_text(char* str);
	virtual get_text(STR *pstr);

	// CX^X擾
	HINSTANCE get_hins(HWND hwnd){ return (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE); };
	// ʒuTCYύX
	virtual POSIZE get_in_posize();
	virtual POSIZE get_out_posize();
	virtual set_z_pos(int z);
	virtual set_pos(int x, int y);
	virtual set_size(int cx, int cy);
	virtual set_posize(int x, int y, int cx, int cy);
	virtual int size_update();

	// \
	redraw(int flag=FALSE);			// ĕ` v
	show(int n=SW_SHOWNORMAL);		// EBhE\
	hide();							// EBhEB

	use_on(int n=TRUE){ return EnableWindow(m_hwnd, n); };
	use_off(){ return EnableWindow(m_hwnd, 0); };
	COLORREF get_bg_color();	// wiFQbg
	virtual set_cursor(char *cur_name, HINSTANCE hins=NULL);	// }EXJ[\ύX

	add_style(int style, int ex_style=0);	// EBhEX^Cǉ
	del_style(int style, int ex_style=0);	// EBhEX^C폜
	get_id();		// hcQbg
	HWND get_next_win(int n=GW_HWNDNEXT){ return GetWindow(m_hwnd, n); };
	virtual set_center();
	virtual get_style();
	virtual get_ex_style();
};
GWIN_BASE::set_center(){
	//	EBhEʒ
	HWND parent_hwnd;
	RECT parent_rc, rc;
	POSIZE pz;

	parent_hwnd=GetParent(m_hwnd);
	if (!parent_hwnd) parent_hwnd = GetDesktopWindow();

	GetWindowRect(parent_hwnd, (LPRECT)&parent_rc);
	GetWindowRect(m_hwnd, (LPRECT)&rc);
	pz.set_size((rc.right-rc.left), (rc.bottom-rc.top));

	pz.x = ((parent_rc.right-parent_rc.left) -  pz.cx)/2;
	pz.y = ((parent_rc.bottom-parent_rc.top) - pz.cy)/2;
	SetWindowPos(m_hwnd, NULL, pz.x, pz.y, pz.cx, pz.cy, SWP_SHOWWINDOW | SWP_DRAWFRAME); 
	return 0;

}
//------------------------------------------
// 	GWIN_BASE	֐						
//------------------------------------------

// }EXJ[\
GWIN_BASE::set_cursor(char *cur_name, HINSTANCE hins){
	HCURSOR hc=LoadCursor(hins, cur_name);
	if (hc) {
		HCURSOR old_cur=(HCURSOR)SetClassLong(m_hwnd, GCL_HCURSOR, (long)hc);
		return DestroyCursor(old_cur);
	}
	return 0;
}

// 	
GWIN_BASE::make_base(char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id, HINSTANCE hins, LPVOID lp){
	return make_base_ex(0, winc_name, name, style, x, y, w, h, parent_hwnd, id, hins, lp);
}
GWIN_BASE::make_base_ex(int ex_style, char *winc_name, char *name, int style, int x, int y, int w, int h,
			HWND parent_hwnd, int id, HINSTANCE hins, LPVOID lp){
	if (!hins) hins=get_hins(parent_hwnd);
	if (m_hwnd) return -1;	// 쐬ς݃G[
	if (parent_hwnd) style |= WS_CHILD;
	m_hwnd = CreateWindowEx(ex_style, winc_name, name, style, x, y, w, h, parent_hwnd, (HMENU)id, hins, lp);
	if (m_hwnd == NULL) {
		char s[100];
		sprintf(s, "EBhE [ %s ] ł܂", name);
		dialog(s);
		throw;
	}
	return (m_hwnd!=NULL);
}

// wiFQbg
COLORREF GWIN_BASE::get_bg_color(){
	if (!m_hwnd) return 0;
	HBRUSH hbrush = ( HBRUSH ) GetClassLong ( m_hwnd, GCL_HBRBACKGROUND );
	LOGBRUSH logbrush;
	GetObject ( hbrush, sizeof(LOGBRUSH), &logbrush );
	return logbrush.lbColor ;
}

// EBhETCY擾ij
POSIZE GWIN_BASE::get_in_posize(){
	RECT rc;		GetClientRect(m_hwnd, &rc);
	POSIZE poze;	poze=rc;
	return poze;
}
// EBhETCY擾iOj
POSIZE GWIN_BASE::get_out_posize(){
	RECT rc;		GetWindowRect(m_hwnd, &rc);
	POSIZE poze;	poze=rc;
	HWND par_hwnd=GetParent(m_hwnd);
	if (par_hwnd){
		GetWindowRect(par_hwnd, &rc);
		poze.x-=rc.left;	poze.y-=rc.top;
	}
	return poze;
}
// TCYύX
GWIN_BASE::set_z_pos(int z){
	if (!m_hwnd) return 0;
	HWND after_hwnd=NULL;
	if (z==-1)		after_hwnd=HWND_BOTTOM;
	else if (z==2)	after_hwnd=HWND_TOPMOST;
	else if (z==1)	after_hwnd=HWND_TOP;
	else return 0;
	SetWindowPos(m_hwnd, after_hwnd, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
}
GWIN_BASE::set_pos(int x, int y){
	if (!m_hwnd) return 0;
	SetWindowPos(m_hwnd, 0, x, y, 0, 0,		SWP_NOSIZE);
	size_update();
	return 0;
}
GWIN_BASE::set_size(int cx, int cy){
	if (!m_hwnd) return 0;
	SetWindowPos(m_hwnd, 0, 10, 10, cx, cy,	SWP_NOMOVE);
	size_update();
	return 0;
}
GWIN_BASE::set_posize(int x, int y, int cx, int cy){
	if (!m_hwnd) return 0;
	SetWindowPos(m_hwnd, 0, x, y, cx, cy, 0 );
	size_update();
	return 0;
}
// EBhEEeLXgݒ		
GWIN_BASE::set_text(char* str){
	if (str) return SetWindowText(m_hwnd, str);
	return 0;
}
GWIN_BASE::get_text(STR *pstr){
	if (!m_hwnd || !pstr) return 0;
	int len=SendMessage(m_hwnd, WM_GETTEXTLENGTH, 0, 0);
	pstr->resize(len+1);
	SendMessage(m_hwnd, WM_GETTEXT, len+1, (LPARAM)pstr->buf);
	return 0;
}

// ĕ`		
GWIN_BASE::redraw(int flag){ return InvalidateRect(m_hwnd, NULL, flag);}

// EBhEE\/\		
GWIN_BASE::show(int n){	return ShowWindow(m_hwnd, n); }
GWIN_BASE::hide(){		return ShowWindow(m_hwnd, 0); }

GWIN_BASE::get_id(){ return GetWindowLong(m_hwnd, GWL_ID); };

// X^C擾
GWIN_BASE::get_style(){ return GetWindowLong(m_hwnd, GWL_STYLE); }
GWIN_BASE::get_ex_style(){ return GetWindowLong(m_hwnd, GWL_EXSTYLE); }
// X^Cǉ		
GWIN_BASE::add_style(int style, int ex_style){
	if (!m_hwnd) return 0;
	if (style)		SetWindowLong(m_hwnd, GWL_STYLE,	style	 | GetWindowLong(m_hwnd, GWL_STYLE));
	if (ex_style)	SetWindowLong(m_hwnd, GWL_EXSTYLE,	ex_style | GetWindowLong(m_hwnd, GWL_EXSTYLE));
	return style;
}
// X^C폜		
GWIN_BASE::del_style(int style, int ex_style){
	if (!m_hwnd) return 0;
	if (style)		SetWindowLong(m_hwnd, GWL_STYLE,	(~style)	& GetWindowLong(m_hwnd, GWL_STYLE));
	if (ex_style)	SetWindowLong(m_hwnd, GWL_EXSTYLE,	(~ex_style) & GetWindowLong(m_hwnd, GWL_EXSTYLE));
	return style;
}
GWIN_BASE::size_update(){	return 0;}

//==========================================
// 	GWIN	`							
//==========================================
class GWIN : public GWIN_BASE{
	set_winc(HINSTANCE hins, char *winc);
	EachProcRonder(UINT msg, WPARAM wp, LPARAM lp);
	STR m_winc_name;
	static BOOL CALLBACK DialogProc(HWND hwnd, UINT msg , WPARAM wp , LPARAM lp);
	static LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) ;
	public:
	STR sub_menu_name;
	virtual on_create();
	virtual on_paint();
	virtual on_paint_core(HDC hdc);
	virtual on_destroy();
	virtual int on_vscroll(WPARAM wp, LPARAM lp);	// cXN[
	virtual int on_hscroll(WPARAM wp, LPARAM lp);	// XN[
	virtual int on_command		(WPARAM wp, LPARAM lp);		// j[bZ[W
	virtual int on_mousewheel	(WPARAM wp, LPARAM lp);		// }EXEzC[
	virtual int on_notify		(WPARAM wp, LPARAM lp);		// NOTIFY
	virtual int on_mou_up_left	(WPARAM wp, LPARAM lp);		// NbN
	virtual int on_mou_up_right	(WPARAM wp, LPARAM lp);		// ENbN
	virtual int on_mou_dblclk	(WPARAM wp, LPARAM lp);		// _uNbN
	virtual int on_mou_down_left	(WPARAM wp, LPARAM lp);		// NbN
	virtual int on_mou_down_right	(WPARAM wp, LPARAM lp);		// ENbN
	virtual int on_drop			(WPARAM wp, LPARAM lp);		// hbv
	virtual int on_getminmaxinfo(WPARAM wp, LPARAM lp);		// TCYύX
	virtual int on_size			(WPARAM wp, LPARAM lp);		// TCYύX
	virtual int on_timer(WPARAM wp, LPARAM lp);				// ^C}[
	virtual int on_nchittest(WPARAM wp, LPARAM lp);			// NCqbgeXg

	GWIN();
	kill_timer(int id){ return KillTimer(m_hwnd, id); }
	set_timer(int id, int interval){ return SetTimer(m_hwnd, id, interval, NULL); }
	set_bg_color(HBRUSH hbrush);
	call_sub_menu();		// |bvAbvj[Ăяo
	virtual kill();

	set_menu(char *menu_name);
	set_sub_menu(char *menu_name);
	virtual LRESULT CALLBACK EachProc(UINT msg, WPARAM wp, LPARAM lp) ;
	virtual make_indep(HINSTANCE hins, char *winc_name, char *name, int style, int x, int y, int w, int h);
	virtual make(HWND hwnd, char *winc_name, char *name, int style, int x, int y, int w, int h);
	virtual make_ez(HWND parent, char *name, int style);
	virtual make_dialog(HWND parent, char *temp_name);
	virtual add_menuitem(char *item_str, int id, int index1=-1, int index2=-1);
	insert_menuitem(int insert_pos, char *item_str, int id, int index1=-1, int index2=-1);
	del_menuitem(int id, int index1=-1, int index2=-1);
};
//------------------------------------------
// 	GWIN	֐							
//------------------------------------------

static XLIST<GWIN*> g_gwin_list;
GWIN::kill(){
	HINSTANCE hins=get_hins(m_hwnd);
	GWIN_BASE::kill();
	if (sub_menu_name.len>0) UnregisterClass(sub_menu_name.buf, hins);
}
GWIN::make_dialog(HWND parent, char *temp_name){
	m_hwnd = CreateDialogParam(get_hins(parent), temp_name , parent , DialogProc, (LPARAM)this );
	return 0;
}

GWIN::set_sub_menu(char *menu_name){
	sub_menu_name=menu_name;
	return 0;
}
// j[ݒ
GWIN::set_menu(char *menu_name){
	if (!m_hwnd) return 0;
	HMENU old_hmenu=GetMenu(m_hwnd);	// j[̃nh
	SetMenu(m_hwnd, NULL);	// j[
	DestroyMenu(old_hmenu);	// j[̃J
	SetMenu(m_hwnd, LoadMenu(get_hins(m_hwnd), menu_name));	// Vj[ݒ
	return 0;
}
// j[ݒ
GWIN::insert_menuitem(int insert_pos, char *item_str, int id, int index1, int index2){
	HMENU hmenu=GetMenu(m_hwnd);
	if (index1>=0) hmenu = GetSubMenu(hmenu, index1);
	if (index2>=0) hmenu = GetSubMenu(hmenu, index2);
	if (!hmenu) return 0;
	MENUITEMINFO mii={0};
	mii.cbSize = sizeof (MENUITEMINFO);
	mii.fMask = MIIM_TYPE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.dwTypeData = item_str;
	mii.wID =id;

	InsertMenuItem(hmenu, insert_pos , TRUE , &mii);
//	SetMenuItemInfo(hmenu , index , TRUE, &mii);
	return 0;
}
GWIN::add_menuitem(char *item_str, int id, int index1, int index2){
	HMENU hmenu=GetMenu(m_hwnd);
	if (index1>=0) hmenu = GetSubMenu(hmenu, index1);
	if (index2>=0) hmenu = GetSubMenu(hmenu, index2);
	if (!hmenu) return 0;
	int index=GetMenuItemCount(hmenu);
	insert_menuitem(index, item_str, id, index1, index2);
	return 0;
}

GWIN::del_menuitem(int id, int index1, int index2){
	HMENU hmenu=GetMenu(m_hwnd);
	if (index1>=0) hmenu = GetSubMenu(hmenu, index1);
	if (index2>=0) hmenu = GetSubMenu(hmenu, index2);
	if (!hmenu) return 0;
	DeleteMenu(hmenu, id, MF_BYCOMMAND);
	return 0;
}

// Tuj[		
GWIN::call_sub_menu(){
	if (!m_hwnd) return 0;
	if (!sub_menu_name.buf) return 0;
	POINT po;
	GetCursorPos(&po);
	int now_menu_id		= 0;
	HMENU hmenu_tmp, hmenu;
	hmenu_tmp = LoadMenu(get_hins(m_hwnd), sub_menu_name.buf);
	hmenu = GetSubMenu(hmenu_tmp , now_menu_id);
//	po.x = LOWORD(lp);
//	po.y = HIWORD(lp);
	TrackPopupMenu(hmenu, TPM_LEFTALIGN, po.x, po.y, 0, m_hwnd, NULL );
	DestroyMenu(hmenu_tmp);
	DestroyMenu(hmenu);
	return 0;
}
GWIN::on_command(WPARAM wp, LPARAM lp){ SendMessage(GetParent(m_hwnd), WM_COMMAND, wp, lp); return 0; }
GWIN::on_create(){	return 0;}
GWIN::on_destroy(){ m_hwnd=NULL; return 0; };
GWIN::on_paint(){
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(m_hwnd, &ps);
	on_paint_core(hdc);
	EndPaint(m_hwnd, &ps);
	return 0;
}
GWIN::on_paint_core(HDC hdc){
	return 0;
}
GWIN::on_hscroll(WPARAM wp, LPARAM lp){	return 0; }
GWIN::on_vscroll(WPARAM wp, LPARAM lp){	return 0; }
GWIN::on_notify	(WPARAM wp, LPARAM lp){	return 0; }
GWIN::on_size	(WPARAM wp, LPARAM lp){	size_update(); return 0; }
GWIN::on_mou_up_left	(WPARAM wp, LPARAM lp){ SetFocus(m_hwnd); return 0; }
GWIN::on_mou_up_right	(WPARAM wp, LPARAM lp){ call_sub_menu(); return 0; }
GWIN::on_mou_down_left	(WPARAM wp, LPARAM lp){ return 0; }
GWIN::on_mou_down_right	(WPARAM wp, LPARAM lp){ call_sub_menu(); return 0; }
GWIN::on_mousewheel		(WPARAM wp, LPARAM lp){ return 0; }
GWIN::on_mou_dblclk		(WPARAM wp, LPARAM lp){ return 0; }
GWIN::on_drop(WPARAM wp, LPARAM lp){ return 0; }
GWIN::on_getminmaxinfo(WPARAM wp, LPARAM lp){ return 0; };
GWIN::on_nchittest(WPARAM wp, LPARAM lp){ return 0; };
GWIN::on_timer(WPARAM wp, LPARAM lp){ return 0; };


GWIN::GWIN(){
	g_gwin_list.push(this);
	return ;
}
// wiFZbg
GWIN::set_bg_color(HBRUSH hbrush){
	if (!m_hwnd) return 0;
	SetClassLong ( m_hwnd, GCL_HBRBACKGROUND, (DWORD)hbrush);
	return 0;
}
// ƗEBhE쐬
GWIN::make_indep(HINSTANCE hins, char *winc_name, char *name, int style, int x, int y, int w, int h){
	set_winc(hins, winc_name);
	style |= WS_CAPTION | WS_SYSMENU | WS_CLIPCHILDREN;
	make_base_ex(0, m_winc_name.buf, name, style, x, y, w, h, NULL, NULL, hins, (LPVOID)this);
	if (m_hwnd == NULL) throw;
	return (m_hwnd != NULL);
}
// qEBhE쐬
GWIN::make(HWND parent, char *winc_name, char *name, int style, int x, int y, int w, int h){
	HINSTANCE hins=get_hins(parent);
	set_winc(hins, winc_name);
	make_base_ex(0, m_winc_name.buf, name, style | WS_CLIPSIBLINGS | WS_CHILD, x, y, w, h, parent, NULL, hins, (LPVOID)this);
	if (m_hwnd == NULL) throw;
	return (m_hwnd != NULL);
}
// qEBhE쐬() 
GWIN::make_ez(HWND parent, char *name, int style){
	static ez_number=0;
	ez_number++;
	return make(parent, NULL, name, style, ez_number*10, 0, 10, 30);
}
GWIN::EachProcRonder(UINT msg, WPARAM wp, LPARAM lp){
	switch (msg) {
//	case WM_NCHITTEST:	return on_nchittest(wp, lp);
	case WM_GETMINMAXINFO:on_getminmaxinfo(wp, lp);	break;// TCYύX
	case WM_DROPFILES:	on_drop(wp, lp);		break;	// hbv
	case WM_TIMER:		on_timer(wp, lp);		break;	// ^C}[
	case WM_PAINT:		on_paint();				break;	// ĕ`
	case WM_NOTIFY :	on_notify(wp, lp);		break;	// NOTIFY
	case WM_SIZE :		on_size(wp, lp);		break;	// TCY
	case WM_COMMAND:	on_command(wp, lp);		break;	// R
	case WM_MOUSEWHEEL:	on_mousewheel(wp, lp);	break;	// }EXzC[
	case WM_LBUTTONUP:	on_mou_up_left(wp, lp);	break;	// NbN
	case WM_RBUTTONUP:	on_mou_up_right(wp, lp);	break;	// ENbN
	case WM_LBUTTONDOWN:	on_mou_down_left(wp, lp);	break;	// NbN
	case WM_RBUTTONDOWN:	on_mou_down_right(wp, lp);	break;	// ENbN
	case WM_LBUTTONDBLCLK:	on_mou_dblclk(wp, lp);		break;	// _uNbN
	case WM_VSCROLL:	on_vscroll(wp, lp);		break;	// cXN[
	case WM_HSCROLL:	on_hscroll(wp, lp);		break;	// XN[
	}
	return 0;
}
LRESULT CALLBACK GWIN::EachProc(UINT msg, WPARAM wp, LPARAM lp){
	EachProcRonder(msg, wp, lp);
	return DefWindowProc(m_hwnd, msg, wp, lp);
}
// _CAO
BOOL CALLBACK GWIN::DialogProc(HWND hwnd, UINT msg , WPARAM wp , LPARAM lp) {
	int i;
	GWIN* pwin=NULL;
	for(i=0;i<g_gwin_list.size();i++){
		if (g_gwin_list[i] && hwnd==g_gwin_list[i]->m_hwnd){ pwin=g_gwin_list[i]; break; }
	}
	switch (msg) {
	case WM_CLOSE:;	DestroyWindow(hwnd);if (pwin)pwin->m_hwnd=NULL; 	return TRUE;
	default:;
	}
		if (pwin) {
			return pwin->EachProcRonder(msg, wp, lp);
		}
	return FALSE;
}
LRESULT CALLBACK GWIN::WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	GWIN* pwin=NULL;
	int i;
	static HWND main_hwnd=NULL;
	if (msg==WM_CREATE){
		pwin=((GWIN*)((LPCREATESTRUCT)lp)->lpCreateParams);
		for(i=0;i<g_gwin_list.size();i++){
			if (pwin==g_gwin_list[i]){
				pwin->m_hwnd=hwnd;
				pwin->on_create();
				break;
			}
		}
		if (g_gwin_list.size()>0 && !main_hwnd ) main_hwnd=g_gwin_list[0]->m_hwnd;
		return 0;
	}
	else {
		for(i=0;i<g_gwin_list.size();i++){
			if (g_gwin_list[i] && hwnd==g_gwin_list[i]->m_hwnd){ pwin=g_gwin_list[i]; break; }
		}
	}
	switch (msg) {
	case WM_DESTROY:
		if (!main_hwnd || main_hwnd==hwnd) PostQuitMessage(0);
		if (pwin) pwin->on_destroy();
		return 0;
	default:
		if (pwin) return pwin->EachProc(msg, wp, lp);
	}
	return DefWindowProc(hwnd, msg, wp, lp);
}
// EBhENXo^
GWIN::set_winc(HINSTANCE hins, char *winc_name){
	WNDCLASS winc;
	static winc_number=1;
	char s[40];
	if (!winc_name){
		sprintf(s, "gwin_%d", winc_number++);
		winc_name=s;
	}
	if (m_winc_name.len) return 0;	// EBhENXłɂ

	winc.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	winc.lpfnWndProc	= WndProc;
	winc.cbClsExtra		= winc.cbWndExtra	= 0;
	winc.hInstance		= hins;
	winc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	winc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	winc.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	winc.lpszMenuName	= winc_name;
	winc.lpszClassName	= winc_name;

	if (!RegisterClass(&winc)) -1;
	m_winc_name=winc_name;	// ޳̔jƐJԂꍇɔeEBhENXoĂ
	return 0;
}

//==========================================
//	GWIN_T									
//==========================================
template <class T> class GWIN_T : public GWIN {
	public :
	T *send_obj;
	GWIN_T();
	int (*sub_on_create)	(T* poj, GWIN* pwin);
	int (*sub_on_paint)		(T* poj, GWIN* pwin);		// `iI[o[[hp
	int (*sub_on_size)		(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);
	int (*sub_on_command)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);		// j[bZ[W
	int (*sub_on_mousewheel)(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);		// }EXEzC[
	int (*sub_on_notify)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);		// NOTIFY
	int (*sub_on_vscroll)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);
	int (*sub_on_hscroll)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);
	int (*sub_on_mou_up_left)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);
	int (*sub_on_mou_up_right)	(T* poj, GWIN* pwin, WPARAM wp, LPARAM lp);
	virtual int on_create();
	virtual int on_paint();		// `iI[o[[hp
	virtual int on_size		(WPARAM wp, LPARAM lp);
	virtual int on_command	(WPARAM wp, LPARAM lp);		// j[bZ[W
	virtual int on_mousewheel(WPARAM wp, LPARAM lp);	// }EXEzC[
	virtual int on_notify	(WPARAM wp, LPARAM lp);		// NOTIFY
	virtual int on_vscroll(WPARAM wp, LPARAM lp);
	virtual int on_hscroll(WPARAM wp, LPARAM lp);
	virtual int on_mou_up_left(WPARAM wp, LPARAM lp);
	virtual int on_mou_up_right(WPARAM wp, LPARAM lp);
//	virtual EachProc(HWND hwnd, UINT msg , WPARAM wp , LPARAM lp);	// EBhEEvV[W

};

template <class T> GWIN_T<T>::GWIN_T(){
	send_obj			=NULL;
	sub_on_create		=NULL;
    sub_on_paint		=NULL;
    sub_on_size			=NULL;
    sub_on_command		=NULL;
    sub_on_mousewheel	=NULL;
	sub_on_notify		=NULL;
	sub_on_mou_up_left	=NULL;
	sub_on_mou_up_right	=NULL;
	sub_on_vscroll		=NULL;
	sub_on_hscroll		=NULL;
}
//I[o[[hp֐		
template <class T> GWIN_T<T>::on_create(){ if (sub_on_create) (*sub_on_create)(send_obj, this);};
template <class T> GWIN_T<T>::on_mou_up_left(WPARAM wp, LPARAM lp){
	if (sub_on_mou_up_left) (*sub_on_mou_up_left)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_mou_up_right(WPARAM wp, LPARAM lp){
	if (sub_on_mou_up_right) (*sub_on_mou_up_right)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_notify	(WPARAM wp, LPARAM lp){
	if (sub_on_notify) (*sub_on_notify)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_vscroll	(WPARAM wp, LPARAM lp){
	if (sub_on_vscroll) (*sub_on_vscroll)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_hscroll	(WPARAM wp, LPARAM lp){
	if (sub_on_hscroll) (*sub_on_hscroll)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_size(WPARAM wp, LPARAM lp){
	if (sub_on_size) (*sub_on_size)(send_obj, this, wp, lp);
};
template <class T> GWIN_T<T>::on_mousewheel(WPARAM wp, LPARAM lp){
	if (sub_on_mousewheel) (*sub_on_mousewheel)(send_obj, this, wp, lp);
};
// R		
template <class T> GWIN_T<T>::on_command(WPARAM wp , LPARAM lp){
	if (sub_on_command) (*sub_on_command)(send_obj, this, wp, lp);
	else return SendMessage(GetParent(m_hwnd), WM_COMMAND, wp, lp); 
}
// `		
template <class T> GWIN_T<T>::on_paint(){
	if (sub_on_paint) (*sub_on_paint)(send_obj, this);
//	HDC hdc;	PAINTSTRUCT ps;	hdc = BeginPaint(hwnd , &ps);	EndPaint(hwnd , &ps);
}
#endif	// _GWIN_H_

