
#ifndef _XLIST_H_
#define _XLIST_H_

#include <stdio>
#include <stdlib>
/*
namespace {
	// O
}*/

//==========================================
//		Xg^ev[g				
//==========================================

// AACeENX
template <class T> class LIST_ITEM{
	public:
	T t;					// ACe{   
	LIST_ITEM *next, *before;			// m[h
	LIST_ITEM(){ next=before=NULL; }	// RXgN^
};

//==========================================
//		XLIST								
//==========================================
template <class T> class XLIST {
	private:
	// oϐ
	LIST_ITEM<T> *head, *tail;
	LIST_ITEM<T>	*last_use;
	int				last_use_id;
	int item_length;

	public :
	XLIST();		// RXgN^
	~XLIST();		// fXgN^
	push(T t);		// ACeǉ
	push(T t, int n);		// ACeǉ
	pop(int n=-1);	// nԖڂ̃ACe폜
	// _ANZX
	LIST_ITEM<T>*	get_ptr_abs(int n);
	LIST_ITEM<T>*	get_ptr_rel(LIST_ITEM<T>* pitem, int n);
	virtual LIST_ITEM<T>*	get_ptr(int n);
	T &operator [](int n);
	T &last();
	del_all();
	init();
	set_default(T &t);
	size();		// ACeԂ
	resize(int n);
	swap(int n1, int n2){
		LIST_ITEM<T> *p
		T tmp_t=*get_ptr(n1);
		*get_ptr(n1)=*get_ptr(n2);
		*get_ptr(n2)=tmp_t;
	};
};

// RXgN^ 
template <class T> XLIST<T>::XLIST(){ init(); }

// fXgN^
template <class T> XLIST<T>::~XLIST(){ del_all(); delete head; }

// 		
template <class T> XLIST<T>::init(){
	head = new LIST_ITEM<T>;
	last_use	= tail = head;
	last_use_id	= item_length= 0;
	return 0;
}

// ACe		
template <class T> XLIST<T>::size(){
	return item_length;
}
// ACeύX		
template <class T> XLIST<T>::resize(int n){
	if (n<0) n=0;
	int i, add_size = n - item_length;
	if (!add_size){
		return item_length;
	}
	else if (add_size>0){
		T t;
		for(i=0;i<add_size;i++) push(t);
		return add_size;
	}
	else if (add_size<0){
		add_size=-add_size;
		for(i=0;i<add_size;i++) pop();
		return -add_size;
	}
	return item_length;
}

// ANZXG[̕Ԃl ݒ		
template <class T> XLIST<T>::set_default(T &t){ head->t = t; return 0; }

// Sj		
template <class T> XLIST<T>::del_all(){
	int i, del_len=size()+1;
	for(i=0;i<del_len;i++) pop();
	return 0;
}
// ====== _ANZX =====================================================
// Zq []    
template <class T> T& XLIST<T>::operator [](int n){
	LIST_ITEM<T> *p=get_ptr(n);
	return p->t;
}
// Zq []    
template <class T> T& XLIST<T>::last(){
	return tail->t;
}


// ΃pX    
template <class T> LIST_ITEM<T>* XLIST<T>::get_ptr_rel(LIST_ITEM<T>* pitem, int n){
	if (n>0){
		for(int i=0;i<n;i++) if (pitem->next)	pitem=pitem->next;
	} else if (n<0){
		n=-n;
		for(int i=0;i<n;i++) if (pitem->before)	pitem=pitem->before;
	}
//	printf("rel  ");
	return pitem;
};

// ΃pX    
template <class T> LIST_ITEM<T>* XLIST<T>::get_ptr_abs(int n){
	LIST_ITEM<T> *pitem=head->next;
	for(int i=0;i<n;i++) if (pitem->next)	pitem=pitem->next;
	return pitem;
}

// _ANZX֐    
template <class T> LIST_ITEM<T>* XLIST<T>::get_ptr(int n){
	LIST_ITEM<T> *pitem;
	int i = n-last_use_id, len=size();
	if (n>=len || n<0) return head;

	if (n > abs(i)){
		if ((len-n-1) > abs(i))	pitem = get_ptr_rel(last_use, i);
		else					pitem = get_ptr_rel(tail, n-len+1);
	}
	else pitem = get_ptr_abs(n);	// 擪m[h

	if (pitem) {	// ŌɃANZXACeXV
		last_use	=pitem;
		last_use_id	=n;
	}
	return pitem;
}

// ACe폜    (nԖڂ̃ACe폜)   
template <class T> XLIST<T>::pop(int n){
	if (item_length<=0) return 0;		// LISTACeȂ
	LIST_ITEM<T> *del, *bef, *nex;
	if (n<0 || n>=item_length) del=tail;	// n ͈͊OȂ疖폜
	else del = get_ptr(n);
	if (del==head) return 0;
	bef = del->before;	// 폜ACȇÕm[hGET
	nex = del->next;	// 폜ACe̎̃m[hGET
	bef->next=nex;		// Õm[h͊mɑ݂̂łɍXV
	if (nex) {
		nex->before=bef;	// 폜ACeȂƂnexNULLȂ̂ŉ
	}
	else tail=bef;
	delete del;
	item_length--;
		last_use	=bef;	// ŌɃANZXACeXViÕm[hɑj
		last_use_id	=n-1;
	return item_length;
}

// ACeǉ   
template <class T> XLIST<T>::push(T t){
	LIST_ITEM<T> *old_tail=tail;		// XVO̖|C^ێ
	tail->next = new LIST_ITEM<T>;		// ACenextɐVXg쐬
	tail=tail->next;				// VXgtail|C^킹
	tail->t = t;					// VXgɃACe
	tail->before=old_tail;
	item_length++;
	return item_length;
};
// ACeǉ (}^)  
template <class T> XLIST<T>::push(T t, int n){
	if (n>=item_length) return push(t);
	if (n<=0) n=0;
	LIST_ITEM<T> *bef_pitem, *nex_pitem, *pitem;
	bef_pitem=get_ptr(n-1);			// }̑O|C^擾(mɑ)
	nex_pitem=bef_pitem->next;		// }̎|C^ێ(NULL̂Ƃ)
	pitem = new LIST_ITEM<T>;	// ACenextɐVXg쐬
	pitem->t = t;					// VXgɃACe
	pitem->before=bef_pitem;
	pitem->next=nex_pitem;
	bef_pitem->next = pitem;
	if (nex_pitem) nex_pitem->before = pitem;
		item_length++;
		last_use	=pitem;
		last_use_id	=n;
	return item_length;
};

//==========================================
//		PLIST								
//==========================================
template <class T> class PLIST {
	char destruct_flag;
	public :
	XLIST<T*> xlist;	// has a^ipush쐬̂is ałȂj

	swap(int n1, int n2){
		T* tmp_t=xlist[n1];
		xlist[n1]=xlist[n2];
		xlist[n2]=tmp_t;
	};
	T* &last(){	return xlist.last(); };
	len(){	return xlist.size(); };
	size(){	return xlist.size(); };
	resize(int n){ return xlist.resize(n); };
	set_no_destruct(){ return destruct_flag=0; } // popACedeleteȂ

	// RXgN^
	PLIST(){
		destruct_flag=1;
		xlist.set_default(NULL);	// 
	};
	// fXgN^
	~PLIST(){ del_all(); };
	push(T &t, int n=-1){
		T* pt = new T;
		*pt=t;
		if (n==-1)	xlist.push(pt);
		else		xlist.push(pt, n);
		return 0;
	}
	pushp(T *t=NULL, int n=-1){
		if (!t) t = new T;
		if (n==-1) xlist.push(t);
		else		xlist.push(t, n);
		return 0;
	};		// ACeǉ
	pop(int n=-1){
		if (destruct_flag) delete xlist[n];
		xlist[n]=NULL;
		xlist.pop(n);
		return 0;
	};	// nԖڂ̃ACe폜
	// _ANZX
	T* &operator [](int n){
		return xlist[n];
	};
	del_all(){
		int i, del_len=xlist.size()+1;
		for(i=0;i<(del_len);i++)pop();
		return 0;
	}
};

#endif  // _XLIST_H_

