
#include "gwin.h"
#include "gobj.h"
#include "img_lib/gdib.h"

#include "puyo_gv.h"
#include "puyo_gv_ex.h"
#include "puyo_drop.h"
#include "puyo_table.h"
#include "puyo_input.h"
#include "puyo_player.h"
#include "puyo_menu_box.h"
#include "puyo_game.h"

//======================================================
//		AvP[VENX						
//======================================================
class APP : public GWIN {
	public :
	GAME_BASE *m_pgame;
	int m_fps_count;
	APP(){
		m_pgame=NULL;
	};
	~APP(){
		if (m_pgame) delete m_pgame; m_pgame=NULL;
	};
	change_game_mode(int mode);
	main_loop();
	frame_up();
	init(HINSTANCE hins, char* wndclass, char* title, GSIZE *psize);
	on_paint();
	LRESULT CALLBACK EachProc(UINT msg, WPARAM wp, LPARAM lp) ;
};
// `
APP::on_paint(){
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(m_hwnd, &ps);
	g_gv.app_core_draw(hdc);
	EndPaint(m_hwnd, &ps);
	return 0;
}
// Q[E[h؂ւ
APP::change_game_mode(int mode){
	if (mode==GV::GV_OK) return 0;
	if (mode!=GV::GV_OK){
		delete m_pgame;
		m_pgame=NULL;
	}
	if (!m_pgame){
		Sleep(100);
		g_gv.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
		g_gv.set_effect(GV::GV_EFFECT_FADE_IN);
	}
	switch(mode){
	case GV::GV_TITLE:	m_pgame = new GAME_TITLE;	break;
	case GV::GV_VS_CPU:	m_pgame = new GAME_VS_CPU;	break;
	case GV::GV_ALONE:	m_pgame = new GAME_ALONE;	break;
	case GV::GV_OPTION:	m_pgame = new GAME_OPTION;	break;
	case GV::GV_APP_DESTROY: SendMessage(m_hwnd, WM_CLOSE, 0, 0);	break;
	}
	return 0;
}
// C[` 
APP::frame_up(){
	int res;
	POINT po;
	GetCursorPos(&po);
	ScreenToClient(m_hwnd, &po);
	if (po.x<0 || po.y<0 || po.x>g_gv.get_win_width() || po.y>g_gv.get_win_height()) g_gv.show_sys_mouse();
	else g_gv.hide_sys_mouse();

	if (m_pgame) {
		if (g_gv.is_effect()){
			g_gv.effect();
			g_gv.carry_out_draw();
			return 0;
		}
		res = m_pgame->frame_up();
		if (res!=GV::GV_OK) change_game_mode(res);
		else g_gv.draw_fps();
		g_gv.carry_out_draw();
	}
	if (m_pgame) return 0;
	return -1;
}
// vV[W		
LRESULT CALLBACK APP::EachProc(UINT msg, WPARAM wp, LPARAM lp){
	switch (msg) {
	case WM_KEYUP:	if (wp == VK_ESCAPE ) SendMessage(m_hwnd, WM_CLOSE, 0, 0);	break;
	case WM_PAINT:		on_paint();		break;	// ĕ`
	case WM_CLOSE:		kill();			break;
	case WM_DESTROY:	PostQuitMessage(0);	break;
	}
	return DefWindowProc(m_hwnd, msg, wp, lp);
}

// C[` 
APP::main_loop(){
	MSG msg;
	int bfore_time=0, rdf=0, active_flag=1, one_frame_time=16;

	change_game_mode(GV::GV_TITLE);	// Q[[h

	bfore_time=g_gv.update_time();	// OS̏O
	srand(g_gv.get_now_time());		// 
	m_fps_count=0;
	g_gv.make_lapse_time(GV::LAPSE_TIME_ID_FPS);
	g_gv.make_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);

	while(1){	// EBhEC[`
		while(PeekMessage(&msg , NULL , 0 , 0 , PM_REMOVE)) {
			if(msg.message == WM_QUIT) return 0;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (!m_hwnd) return 0;	// 
		if (m_hwnd!=GetActiveWindow()) {
			if (active_flag) { g_gv.update_time(); g_gv.stop_lapse_time(); active_flag=0; }
			continue;
		}
		else if (!active_flag) { g_gv.update_time(); g_gv.restart_lapse_time(); active_flag=1; };

		if (frame_up()<0) kill();	// C
		if (!g_gv.m_frame_skip || rdf) redraw();	// ĕ`tO
		if (rdf && ((DWORD)(g_gv.update_time()-bfore_time)>one_frame_time)) rdf=0;
		else rdf=1;

		while((DWORD)(g_gv.update_time()-bfore_time)<one_frame_time) Sleep(1);
		bfore_time=g_gv.get_now_time();

		m_fps_count++;
		if (g_gv.get_lapse_time(GV::LAPSE_TIME_ID_FPS)>=1000) {
			g_gv.m_fps=m_fps_count;
			m_fps_count=0;
			g_gv.start_lapse_time(GV::LAPSE_TIME_ID_FPS);
			if (g_gv.m_fps<50) one_frame_time--;
			else if (g_gv.m_fps>70) one_frame_time++;
			if (one_frame_time<=0) one_frame_time=1;
		}
	}
	return 0;
}
// 
APP::init(HINSTANCE hins, char* wndclass, char* title, GSIZE *psize){
	make_indep(hins, wndclass, title,  WS_MINIMIZEBOX, 0, 0, psize->cx, psize->cy);
	RECT rc=*psize;
	AdjustWindowRectEx(&rc, get_style(), 0, get_ex_style());
	POSIZE pz;
	pz=rc;

	//	EBhEʒ
	HWND hdeskwnd;
	RECT deskrc;

	hdeskwnd = GetDesktopWindow();
	GetWindowRect(hdeskwnd, (LPRECT)&deskrc);
	pz.x = (deskrc.right -  pz.cx)/2;
	pz.y = (deskrc.bottom - pz.cy)/2;
//	dialog(pz.cx, pz.cy);
//	dialog(GV::GV_WIN_BASE_LEN*GV::GV_BX, GV::GV_WIN_BASE_LEN*GV::GV_BY);
	SetWindowPos(m_hwnd, (HWND_TOP), pz.x, pz.y, pz.cx, pz.cy, SWP_SHOWWINDOW | SWP_DRAWFRAME); 

	g_gv.set_p_gwin(this);
	g_gv.select_font(GV::GV_BIG);
	show();
	return 0;
}
//==========================================================
//		WinMain												
//==========================================================

GV_EX g_gv;

// WinMain
int WINAPI WinMain(HINSTANCE hInstance , HINSTANCE hPrevInstance , PSTR lpCmdLine , int nCmdShow ) {
	char title[]=TEXT("Ղ肷 ver1.5");
	APP *app=NULL;
	try{
		app	= new APP;
		app->init(hInstance, "puyolis", title, &g_gv.m_win_in_size);
		app->main_loop();
		g_gv.kill_fullscreen();
	}
	// ȉQ[I
	catch(char* str){ dialog(str);	}
	catch(...)		{ dialog("G[");		}
	if (app) delete app; app=NULL;
	return 0;
}

