
//======================================
//		DROP_PEICE						
//======================================
class DROP_PEICE {
	public :
	char m_id, m_type, m_cmb, m_act, m_eff, m_eff_di;
	draw(int x, int y);
	DROP_PEICE(){
		reset();
	}
	is_normal(){ return (m_id>0 && m_id<GV::DROP_COL_LEN); };
	is_vailed(){ return (m_id || m_type); };
	is_jama(){ return (m_id==GV::GV_PEICE_JAMA); };
	reset(){
		m_id=m_type=m_act=m_cmb=0;
		m_eff=0;
		m_eff_di=0;
	}
	is_erase(){ return (m_type==GV::GV_PEICE_ERACE); };
	set_erase(){
		m_type=GV::GV_PEICE_ERACE;
	}
	set_jama(){
		m_id=GV::GV_PEICE_JAMA;
	}
	erase_action(){
		m_act++;
		if (is_erase() && m_act>=5) {
			reset();
			return GV::GV_OK;
		}
		return GV::GV_NG;
	}
	set_wall(){
		m_id=0;
		m_type=GV::GV_PEICE_WALL;
	}
};
DROP_PEICE::draw(int x, int y){
	if (is_erase()){
		g_gv.img_draw(x, y, &g_gv.m_puyo_piece_img, 200, m_act/2*19, GV::GV_BX, GV::GV_BY);
	}
	else if (is_jama()){
		g_gv.img_draw(x, y, &g_gv.m_puyo_piece_img, 150, m_eff/10*19, GV::GV_BX, GV::GV_BY);
	}
	else if (m_id==0){
		g_gv.reback_draw(x, y, GV::GV_BX, GV::GV_BY);
	}
	else if (m_id>0 && m_id<GV::DROP_COL_LEN){
		g_gv.img_draw(x, y, &g_gv.m_puyo_piece_img, (m_id-1)*25, m_eff/10*19, GV::GV_BX, GV::GV_BY);
		m_eff+=m_eff_di;
		if (m_eff<=0) m_eff_di=1;
		else if (m_eff>=29) m_eff_di=-1;
	}
};
//======================================
//		DROP_UNIT						
//======================================
class DROP_UNIT {
	public :
	int m_cx, m_cy, m_axis_x, m_axis_y;
	DROP_PEICE m_pcs[GV::DROP_CX][GV::DROP_CY];
	draw(int x, int y);
	DROP_UNIT(){
		m_cx=0;	m_cy=0;
		m_axis_x=0;	m_axis_y=0;
	}
	set(int type);
	rotate(int angle);
	~DROP_UNIT(){
	}
};
//	]
DROP_UNIT::rotate(int angle){
	static DROP_UNIT tmp;
	int ix,iy;
	for(iy=0;iy<GV::DROP_CY;iy++){
		for(ix=0;ix<GV::DROP_CX;ix++){
			tmp.m_pcs[ix][iy].reset();
		}
	}
	tmp.m_cx=m_cy;
	tmp.m_cy=m_cx;

	if (angle==90){
		for(ix=0;ix<m_cx;ix++){
			for(iy=0;iy<m_cy;iy++){
				tmp.m_pcs[m_cy-iy-1][ix] = m_pcs[ix][iy] ;
			}
		}
		if (m_axis_x>=0 && m_axis_y>=0) {
			tmp.m_axis_x	=m_cy-1-m_axis_y	;
			tmp.m_axis_y	=m_axis_x	;
		}
		else tmp.m_axis_y=tmp.m_axis_x=-1;
	}
	else if (angle==-90){
		for(ix=0;ix<m_cx;ix++){
			for(iy=0;iy<m_cy;iy++){
				tmp.m_pcs[iy][m_cx-ix-1] = m_pcs[ix][iy] ;
			}
		}
		if (m_axis_x>=0 && m_axis_y>=0) {
			tmp.m_axis_x	=m_axis_y	;
			tmp.m_axis_y	=m_cx-m_axis_x-1;
		}
		else tmp.m_axis_y=tmp.m_axis_x=-1;
	}
	*this=tmp;
	return 0;
};
// `
DROP_UNIT::draw(int x, int y){
	int ix, iy, pos_y;
	for(iy=0;iy<GV::DROP_CY;iy++){
		pos_y = y+iy*GV::GV_BY;
		for(ix=0;ix<GV::DROP_CX;ix++){
			if (m_pcs[ix][iy].is_vailed())
			m_pcs[ix][iy].draw(ix*GV::GV_BX +x, pos_y);
		}
	}
}
// VK
DROP_UNIT::set(int type){
	int i, ary_id[4];
	for(i=0;i<4;i++){
	 	ary_id[i]=rand() % (GV::DROP_COL_LEN-1);	ary_id[i]++;	// F		//RAND_MAX
	};

	int ix,iy;
	for(iy=0;iy<GV::DROP_CY;iy++){
		for(ix=0;ix<GV::DROP_CX;ix++){
			m_pcs[ix][iy].reset();
		}
	}
	if (type<0) type = rand() % 7;
	switch(type){
		case 0 :	m_pcs[0][0].m_id = (char)ary_id[0];		// 
					m_pcs[0][1].m_id = (char)ary_id[1];		// 
					m_pcs[0][2].m_id = (char)ary_id[2];		// 
					m_pcs[1][1].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=3;
					m_axis_x=0;	m_axis_y=1;
					break;
		case 1 :	m_pcs[0][0].m_id = (char)ary_id[0];		// 
					m_pcs[0][1].m_id = (char)ary_id[1];		// 
					m_pcs[0][2].m_id = (char)ary_id[2];		// 
					m_pcs[0][3].m_id = (char)ary_id[3];		// 
					m_cx=1;	m_cy=4; 
					m_axis_x=0;	m_axis_y=1;
					break;
		case 2 :	m_pcs[0][0].m_id = (char)ary_id[0];		// 
					m_pcs[0][1].m_id = (char)ary_id[1];		// 
					m_pcs[1][1].m_id = (char)ary_id[2];		// 
					m_pcs[1][2].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=3; 
					m_axis_x=1;	m_axis_y=1;
					break;
		case 3 :	m_pcs[1][0].m_id = (char)ary_id[0];		// 
					m_pcs[1][1].m_id = (char)ary_id[1];		// 
					m_pcs[0][1].m_id = (char)ary_id[2];		// 
					m_pcs[0][2].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=3; 
					m_axis_x=0;	m_axis_y=1;
					break;
		case 4 :	m_pcs[0][0].m_id = (char)ary_id[0];		// 
					m_pcs[0][1].m_id = (char)ary_id[1];		// 
					m_pcs[0][2].m_id = (char)ary_id[2];		// 
					m_pcs[1][0].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=3; 
					m_axis_x=0;	m_axis_y=1;
					break;
		case 5 :	m_pcs[1][0].m_id = (char)ary_id[0];		// 
					m_pcs[1][1].m_id = (char)ary_id[1];		// 
					m_pcs[1][2].m_id = (char)ary_id[2];		// 
					m_pcs[0][0].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=3; 
					m_axis_x=1;	m_axis_y=1;
					break;
		case 6 :	m_pcs[0][0].m_id = (char)ary_id[0];		// 
					m_pcs[0][1].m_id = (char)ary_id[1];		// 
					m_pcs[1][0].m_id = (char)ary_id[2];
					m_pcs[1][1].m_id = (char)ary_id[3];
					m_cx=2;	m_cy=2; 
					m_axis_x=-1;	m_axis_y=-1;
					break;
	};
	return 0;
};

