
//======================================
//		GAME_BASE						
//======================================
class GAME_BASE {
	int m_game_mode;
	protected :
	int m_game_effect_step;
	get_game_mode(){ return m_game_mode; };
	set_game_mode(int mode){
		m_game_effect_step=0;
		m_game_mode=mode;
	};
	public :
	virtual frame_up()=0;
	GAME_BASE(){
		m_game_mode=GV::PLAY_STAND_BY;
		m_game_effect_step=0;
	}
};
//======================================
//		Q[EIvV				
//======================================
class GAME_OPTION : public GAME_BASE {
	char m_bg_draw_flag, m_menu_draw_flag;
	public :
	PLURAL_MEMU_BOX_MANAGER m_menu_manager;
	GDIB m_item_img, m_back_img;
	int m_last_sel;
	MENU_BOX m_head_menu, m_win_size_menu, m_game_level_menu, m_button_layout_menu;
	MENU_BOX *m_p_sub_menu, *m_p_last_focus_menu;
	INPUT m_input;
	MOUSE m_mouse;
	frame_up();
	draw();
	enum { WIN_SIZE_SELECT = GV::GV_OK+1, BUTTON_LAYOUT, GAME_LEVEL, CLOSE_OPTION,	};
	GAME_OPTION();
	change_focus_menu(int di);
	call_sub_menu();
	decide_sub_menu();
	erase_sub_menu();
	get_estab_id(int sub_menu_num);

};

// RXgN^
GAME_OPTION::GAME_OPTION(){

	m_p_sub_menu=NULL;
	m_p_last_focus_menu=NULL;
	m_last_sel=-1;
	g_gv.load_img(&m_item_img, "puyo_option.png");
	g_gv.load_img(&m_back_img, "puyo_option_back.png");
	g_gv.to_back_draw(0,0,&m_back_img, 0,0, g_gv.get_win_width(), g_gv.get_win_height());
	g_gv.img_draw(0,0,&m_back_img, 0,0, g_gv.get_win_width(), g_gv.get_win_height());

	int title_height=47, sub_menu_x=g_gv.get_win_width()/3+10, sub_menu_y, x, y, w, h;
	sub_menu_y=title_height+30;

	m_head_menu.set_cur_pos(30, sub_menu_y);
	w=109; h=144/4;
	m_head_menu.push(WIN_SIZE_SELECT,	&m_item_img, 14,60,		w, h,	&m_item_img, 132,60,	w, h);	// ʃTCY
	m_head_menu.push(GAME_LEVEL,		&m_item_img, 14,60+h,	w, h,	&m_item_img, 132,60+h,	w, h);	// x
//	m_head_menu.push(BUTTON_LAYOUT,		"   {^zu", "{^zu ");
	m_head_menu.push(CLOSE_OPTION,		&m_item_img, 14,60+h*3,	w,h,	&m_item_img, 132,60+h*3,w, h);// ǂ
	POSIZE pz=m_head_menu.get_posize();

	sub_menu_y += 20;
	sub_menu_x+=20;
	m_win_size_menu.set_cur_pos(sub_menu_x, sub_menu_y);
	x=235; y=222; w=217; h=105/3;
	m_win_size_menu.push(GV::WIN_SIZE_DEFAULT,	&m_item_img, 0,y,w,h,		&m_item_img, x,y,w, h);		// WTCY
	m_win_size_menu.push(GV::WIN_SIZE_640X480,	&m_item_img, 0,y+h,w,h,		&m_item_img, x,y+h,w, h);	// 640 X 480
	m_win_size_menu.push(GV::WIN_SIZE_FULL,		&m_item_img, 0,y+h*2,w,h,	&m_item_img, x,y+h*2,w, h);	// tXN[

	m_game_level_menu.set_cur_pos(sub_menu_x, sub_menu_y);
	x=400; y=63; w=94; h=136/4;
	m_game_level_menu.push(GV::GAME_LEVEL_EAZY,		&m_item_img, 295,y,w,h,	&m_item_img, x,y,w, h);	// 񂽂
	m_game_level_menu.push(GV::GAME_LEVEL_NORMAL,	&m_item_img, 295,y+h,w,h,	&m_item_img, x,y+h,w, h);	// 
	m_game_level_menu.push(GV::GAME_LEVEL_HARD,		&m_item_img, 295,y+h*2,w,h,	&m_item_img, x,y+h*2,w, h);	// 

	m_bg_draw_flag= m_menu_draw_flag==1;
	m_menu_manager.make(2);
	m_menu_manager.set_pmenu(0, &m_head_menu);
	m_menu_manager.change_focus_menu(-1);
	g_gv.img_draw(5, 5, &m_item_img, 0,0, 141, 43);
	g_gv.set_effect(GV::GV_EFFECT_FADE_IN);

//	m_button_layout_menu.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
//	m_button_layout_menu.set_bg_mode(TRANSPARENT, TRANSPARENT);
//	m_button_layout_menu.push(GV::GAME_LEVEL_EAZY,		&m_item_img, 295,y,w,h,	&m_item_img, x,y,w, h);	// 񂽂
}
GAME_OPTION::get_estab_id(int sub_menu_num){
	if (sub_menu_num<0) sub_menu_num=m_head_menu.get_sel();
	switch(sub_menu_num){
	case WIN_SIZE_SELECT:
		return g_gv.m_win_size_mode;
	case GAME_LEVEL:
		return g_gv.m_game_level;
		break;
	}
}
// `
GAME_OPTION::draw(){
	if (m_p_last_focus_menu!=m_menu_manager.get_focus_pmenu()){
		m_bg_draw_flag= m_menu_draw_flag=1;
	}
	if (m_bg_draw_flag){
		m_menu_manager.draw_bg(&m_back_img);
		m_bg_draw_flag=0;
	}
	POSIZE pz;
	if (m_menu_draw_flag){
		m_menu_manager.draw_unfocus();
		if (m_p_sub_menu && m_p_sub_menu==m_menu_manager.get_focus_pmenu()){
			int id, sub_menu_num=m_head_menu.get_sel_id();
			id=get_estab_id(sub_menu_num);
			pz=m_p_sub_menu->get_item_posize(m_p_sub_menu->get_num_by_id(id));
			POINT po=m_p_sub_menu->get_cur_pos();
			g_gv.fill_main(po.x+pz.x-3, po.y+pz.y-2, pz.cx+6, pz.cy+2, 255, 192, 0, 255);
			g_gv.img_draw(po.x+pz.x-35, po.y+pz.y-15, &m_item_img, 425, 20, 45, 27, 255, 1);
		}
		m_menu_manager.draw_focus();
		m_menu_draw_flag=0;
		m_menu_manager.set_picker_back();
	}
	m_menu_manager.draw_picker();
	return GV::GV_OK;
}
GAME_OPTION::call_sub_menu(){
	if (m_menu_manager.get_focus_pmenu()==&m_head_menu){
		// wbhEj[őI
		if (m_head_menu.get_sel_id()==CLOSE_OPTION) {
			// IvVE[h߂
			g_gv.set_alpha_work(0,0, g_gv.get_win_width(), g_gv.get_win_height(), 255);
			set_game_mode(GV::GAME_CLOSE);
			return GV::GV_OK;
		}
		else {
			// TuEj[Ăяo
			MENU_BOX *p_last_sub_pmenu=m_p_sub_menu;
			switch(m_head_menu.get_sel_id()){
			case WIN_SIZE_SELECT:
					m_p_sub_menu=&m_win_size_menu;
					m_win_size_menu.select_id(g_gv.m_win_size_mode);
					break;
			case GAME_LEVEL:
					m_p_sub_menu=&m_game_level_menu;
					m_game_level_menu.select_id(g_gv.m_game_level);
					break;
			case CLOSE_OPTION:		m_p_sub_menu=NULL;					break;
			}
			m_menu_manager.set_pmenu(1, m_p_sub_menu);
			m_menu_manager.change_focus_menu(1);
			m_menu_draw_flag=m_bg_draw_flag=1;
		}
	}
	return GV::GV_OK;

}
GAME_OPTION::decide_sub_menu(){
	if (!m_p_sub_menu) return 0;
	switch(m_head_menu.get_sel_id()){
	case WIN_SIZE_SELECT:
		switch(m_p_sub_menu->get_sel_id()){
		case GV::WIN_SIZE_DEFAULT:	g_gv.change_win_size(GV::WIN_SIZE_DEFAULT); break;
		case GV::WIN_SIZE_640X480:	g_gv.change_win_size(GV::WIN_SIZE_640X480); break;
		case GV::WIN_SIZE_FULL:		g_gv.change_win_size(GV::WIN_SIZE_FULL);	break;
		}
		break;
	case GAME_LEVEL:
		switch(m_p_sub_menu->get_sel_id()){
		case GV::GAME_LEVEL_EAZY:	g_gv.m_game_level=1; break;
		case GV::GAME_LEVEL_NORMAL:	g_gv.m_game_level=2; break;
		case GV::GAME_LEVEL_HARD:	g_gv.m_game_level=3; break;
		}
		break;
	}
	m_menu_draw_flag=1;

	return GV::GV_OK;
}
// wbhEj[
GAME_OPTION::erase_sub_menu(){
	POSIZE pz;
	if (m_p_sub_menu) {
		pz=m_p_sub_menu->get_posize();
		g_gv.reback_draw(pz.x-40, pz.y-20, pz.cx+60, pz.cy+40);
	}
	return GV::GV_OK;
}
// frame_up
GAME_OPTION::frame_up(){
	m_input.update_stat();
	m_mouse.update_stat();
	switch(get_game_mode()){
	case GV::PLAY_STAND_BY:
		set_game_mode(GV::PLAY_NOMAL);
		m_menu_draw_flag=m_bg_draw_flag=1;
		break;
	// ʏv[
	case GV::PLAY_NOMAL:
		// ȎIlXV
		m_p_last_focus_menu=m_menu_manager.get_focus_pmenu();
		m_last_sel=m_menu_manager.get_sel();

		// }EX
		if (m_mouse.is_move()) {	// }EX̓CEj[ATuEj[I
			if (m_menu_manager.select_pos(m_mouse.get_pos())==GV::GV_OK
			 && m_last_sel!=m_menu_manager.get_sel()) m_menu_draw_flag=1;
		}
		// L[{[hI
		if (m_menu_manager.select_rel(m_input.get_vert())==GV::GV_OK) m_menu_draw_flag=1;	// L[{[hIE㉺

		if (m_input.get_side()<0 || m_input.get_cancel_btn(1) || m_mouse.get_right(1)
			|| (m_mouse.get_left(1) && !m_menu_manager.is_ride(m_mouse.get_pos()))){
			m_menu_manager.change_focus_menu(-1);
		}
		// Tuj[wbhEj[ɖ߂
		if (&m_head_menu==m_menu_manager.get_focus_pmenu() && &m_head_menu!=m_p_last_focus_menu){
			erase_sub_menu();
			m_menu_manager.set_pmenu(1, NULL);
			m_menu_draw_flag=m_bg_draw_flag=1;
		}

		// 
		if (m_input.get_decide_btn(1) || m_input.get_side()>0		// L[{[h
			|| (m_mouse.get_left(1) && m_menu_manager.is_ride(m_mouse.get_pos()))){
			if (m_menu_manager.get_focus_pmenu()==&m_head_menu) call_sub_menu();
			else decide_sub_menu();

			m_bg_draw_flag= m_menu_draw_flag=1;
		}
		draw();
		break;
	// ^Cgʂɂǂ
	case GV::GAME_CLOSE:
		if (m_game_effect_step==0){
			g_gv.set_effect(GV::GV_EFFECT_FADE_OUT);
			m_game_effect_step++;
		}
		else return GV::GV_TITLE;
		break;
	}
	return GV::GV_OK;
}
//======================================
//		Q[E^Cg				
//======================================
class GAME_TITLE : public GAME_BASE {
	MENU_BOX m_game_menu;
	INPUT m_input;
	GDIB m_title_img, m_title_menu_img;
	int m_title_img_x, eazy_manual_x, eazy_manual_y, eazy_manual_pix_cx;
	char *eazy_manual_str;
	public :
	frame_up();
	draw();
	GAME_TITLE();
	MOUSE m_mouse;
};
GAME_TITLE::GAME_TITLE(){
	g_gv.load_img(&m_title_img, "puyo_title.png");
	g_gv.load_img(&m_title_menu_img, "puyo_title_menu.png");
	m_input.set_joystick(&g_gv.m_joy1);
	m_game_menu.set_bg_color(RGB(192, 192, 192), RGB(255, 255, 255));
	int w=165, h=102/4, sel_x=170;
	m_game_menu.push(GV::GV_VS_CPU,		&m_title_menu_img, 0,0,w, h,	&m_title_menu_img, sel_x,0,w, h);
	m_game_menu.push(GV::GV_ALONE,		&m_title_menu_img, 0,h,w, h,	&m_title_menu_img, sel_x,h,w, h);
	m_game_menu.push(GV::GV_OPTION,		&m_title_menu_img, 0,h*2,w,h,	&m_title_menu_img, sel_x,h*2,w, h);
	m_game_menu.push(GV::GV_APP_DESTROY,&m_title_menu_img, 0,h*3,w,h,	&m_title_menu_img, sel_x,h*3,w, h);

	g_gv.fill_main(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	g_gv.fill_back(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	POSIZE pz;
	// j[
	pz=m_game_menu.get_posize();
	m_game_menu.set_cur_pos((g_gv.get_win_width()-pz.cx)/2, (m_title_img.m_height)+50);

	m_title_img_x=(g_gv.get_win_width()-m_title_img.m_width)/2;
	eazy_manual_x=g_gv.get_win_width()+5;
	eazy_manual_y=g_gv.get_win_height()-30;
	draw();
	g_gv.set_effect(GV::GV_EFFECT_FADE_IN);
	eazy_manual_str="VѕEEEĂubN𑀍삵ēF̃ubNSȏキ΃ubN܂B"
		"L[{[h̑@㉺Ȇ́L[ΉĂ܂B{^΃ubN͉]܂B"
		"  {^zu @P{^ : Z@@Q{^ : X@@R{^ : C   S{^ : `@@T{^ : EnterL[@@"
		"}EX̑ ĂubN̍NbN΍ɁAENbNΉEɃubN͈ړ܂"
		"ubÑ}EX̍{^ςȂɂΑ܂B"
		"WCXeBbNAWCpbhɂlɑΉĂ܂B";
	SIZE size=g_gv.get_str_size(eazy_manual_str);
	eazy_manual_pix_cx=size.cx;
}
// `
GAME_TITLE::draw(){
	char *s, t[20];
	int i, y;
	g_gv.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
	y=35+10;
	if (!m_title_img.m_hdc){
		s="Ղ肷";
		g_gv.draw_text(s, 10, y);
	}
	else {
		g_gv.reback_draw(m_title_img_x-1, y, m_title_img.m_width+3, m_title_img.m_height);
		g_gv.img_draw(m_title_img_x++, y, &m_title_img, 0,0, m_title_img.m_width, m_title_img.m_height);
		if (m_title_img_x>g_gv.get_win_width()) m_title_img_x=-m_title_img.m_width-5;
		y+=m_title_img.m_height;
	}
	y+=10;
	s=eazy_manual_str;

	eazy_manual_x-=1;
	g_gv.select_font(GV::GV_BIG);
	g_gv.reback_draw(0, eazy_manual_y, g_gv.get_win_width(), g_gv.get_win_height()-eazy_manual_y);
	g_gv.set_bg_mode(TRANSPARENT);
	g_gv.draw_text(s, eazy_manual_x, eazy_manual_y);
	if (eazy_manual_x<-eazy_manual_pix_cx)eazy_manual_x=g_gv.get_win_width()+5;
	m_game_menu.draw();
	return GV::GV_OK;
}
// ^CgEt[EAbv
GAME_TITLE::frame_up(){
	m_input.update_stat();
	m_mouse.update_stat();
	switch(get_game_mode()){
	case GV::PLAY_STAND_BY:
		set_game_mode(GV::PLAY_NOMAL);
		break;
	// ʏv[
	case GV::PLAY_NOMAL:
		if (m_input.get_any_btn(1) || m_mouse.get_left(1)){
			set_game_mode(GV::GAME_CLOSE);
			break;
		}

		if (m_mouse.is_move()) m_game_menu.select_pos(m_mouse.get_pos());
		m_game_menu.select_rel(m_input.get_vert());
		draw();
		break;
	case GV::GAME_CLOSE:
		if (m_game_effect_step==0){
			g_gv.set_effect(GV::GV_EFFECT_FADE_OUT);
			m_game_effect_step++;
		}
		else return m_game_menu.get_sel_id();
		break;
	}
	return GV::GV_OK;
}
//======================================
//		GAME_PLAY_TYPE_BASE				
//======================================
class GAME_PLAY_TYPE_BASE : public GAME_BASE {
	public :
	PLAYER_BASE *m_p_p1, *m_p_p2;
	int m_play_time;
	GAME_PLAY_TYPE_BASE(){
		m_play_time=0;
		m_p_p1=m_p_p2=NULL;
	}
	draw_play_time();
	update_play_time(){
		m_play_time=g_gv.get_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME)/1000;
	}
};
GAME_PLAY_TYPE_BASE::draw_play_time(){
	g_gv.draw_time(m_play_time, GV::TIME_CENTER_PIX_X, GV::TIME_PIX_Y);
}
//======================================
//		GAME_CLEAR_ENDING				
//======================================
class GAME_CLEAR_ENDING {
	public :
	int m_effect_step;
	frame_up();
	GAME_CLEAR_ENDING(){
		m_effect_step=0;
	}
};
GAME_CLEAR_ENDING::frame_up(){
	if (m_effect_step==0)g_gv.draw_game_clear(g_gv.get_win_width()/2, g_gv.get_win_height()/2);
	m_effect_step++;
}
//======================================
//		GAME_VS_CPU						
//======================================
class GAME_VS_CPU : public GAME_PLAY_TYPE_BASE {
	MOUSE m_mouse;
	DROP_UNIT m_drop_list[GV::DROP_LIST_LEN];
	HUM_PLAYER m_p1;
	CPU_PLAYER m_p2;
	int m_drop_num1, m_drop_num2;
	int m_stage;
	MENU_BOX m_continue_menu;
	GAME_CLEAR_ENDING *m_p_clear_ending;

	public :
	frame_up();
	game_clear_frame_up();
	GAME_VS_CPU();
	game_stand_by();
	proceed_stage(){
		m_stage++;
		if (m_stage>3) return GV::GV_NG;
		return GV::GV_OK;
	}
	call_next_drop(PLAYER_BASE *pplayer, int *p_drop_num);
};
GAME_VS_CPU::call_next_drop(PLAYER_BASE *pplayer, int *p_drop_num){
	if(GV::GV_NG==pplayer->set_new_drop(&m_drop_list[(*p_drop_num)++])) {
		pplayer->set_lose();
		return GV::GV_NG;
	}
	if ((*p_drop_num)%10==0) pplayer->fall_speed_up();
	if ((*p_drop_num)>=GV::DROP_LIST_LEN) (*p_drop_num)=0;
	return GV::GV_OK;
}
// GAME_VS_CPU RXgN^
GAME_VS_CPU::GAME_VS_CPU(){
	m_p_clear_ending=NULL;
	m_p_p1=&m_p1;
	m_p_p2=&m_p2;
	m_stage=1;
	g_gv.fill_main(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	g_gv.fill_back(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);

	m_p1.init(GV::GV_LEFT);
	m_p1.m_input.set_joystick(&g_gv.m_joy1);
	m_p2.init(GV::GV_RIGHT);
	m_p1.set_enemy(&m_p2);
	m_p1.mouse_use_on(&m_mouse);
	m_p2.set_enemy(&m_p1);

	// ReBj[
	m_continue_menu.push(GV::GV_YES, &g_gv.sys_img, 275,210,54, 32, &g_gv.sys_img, 275,170,54, 26);
	m_continue_menu.push(GV::GV_NO,  &g_gv.sys_img, 333,210,42, 32, &g_gv.sys_img, 333,170,42, 26);

	m_p1.draw();
	m_p2.draw();
	g_gv.set_effect(GV::GV_EFFECT_FADE_IN);
}
// game_stand_by
GAME_VS_CPU::game_stand_by(){
	int i;
	g_gv.fill_main(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	g_gv.fill_back(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	m_p1.init(m_p1.m_play_side);
	m_p2.init(m_p2.m_play_side);
	for(i=0;i<GV::DROP_LIST_LEN;i++){
		m_drop_list[i].set(rand()%7);
	}
	m_p1.set_new_drop(&m_drop_list[0]);	m_p1.set_drop_vailed(0);
	m_p2.set_new_drop(&m_drop_list[0]);	m_p2.set_drop_vailed(0);
	m_drop_num1=m_drop_num2=1;

//	g_gv.screen.load_back("test.png");

	m_p1.draw();
	m_p2.draw();

	g_gv.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
	g_gv.draw_stage(m_stage, GV::STAGE_CENTER_PIX_X, GV::STAGE_PIX_Y);
	m_play_time=0;
	return GV::GV_OK;
}

// bott[EAbv
GAME_VS_CPU::frame_up(){
	int res1, res2;
	m_mouse.update_stat();
	m_p1.update_input();
	switch(get_game_mode()){
	// 
	case GV::PLAY_STAND_BY:
		game_stand_by();
		m_p2.set_cpu_type(m_stage, 0);	// bot^Cvݒ
		g_gv.start_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);
		set_game_mode(GV::PLAY_GET_READY);
		break;
	// ʏv[
	case GV::PLAY_NOMAL:
		update_play_time();
		res1=m_p1.frame_up();
		res2=m_p2.frame_up();
		m_p1.draw();
		m_p2.draw();
		draw_play_time();
		if (res1==GV::GV_NEXT_DROP) {
			if (call_next_drop(&m_p1, &m_drop_num1)==GV::GV_NG) set_game_mode(GV::PLAY_OVER);
		}
		if (res2==GV::GV_NEXT_DROP) {
			if (call_next_drop(&m_p2, &m_drop_num2)==GV::GV_NG) set_game_mode(GV::PLAY_OVER);
		}
		break;
	// PQ[I
	case GV::PLAY_OVER:
		res1=m_p1.over_frame_up();
		res2=m_p2.over_frame_up();
		m_p1.over_draw();
		m_p2.over_draw();
		draw_play_time();
		if (res1==GV::GV_NG && res2==GV::GV_NG) {
			if (m_p1.is_win()) {	// vC[AXe[W
				set_game_mode(GV::PLAY_STAND_BY);
				if (proceed_stage()==GV::GV_NG) set_game_mode(GV::GAME_CLEAR);
			}
			else {
				m_continue_menu.set_cur_pos(m_p1.get_table_x()+30, GV::CONTINUE_CENTER_PIX_Y+40);
				set_game_mode(GV::PLAY_SELECT_CONTINUE);	// ReBj[I[h
				g_gv.main_to_back_draw(0,0, g_gv.get_win_width(), g_gv.get_win_height());
			}
		}
		break;
	// ReBj[I[h
	case GV::PLAY_SELECT_CONTINUE:
		if (m_mouse.is_move()) m_continue_menu.select_pos(m_mouse.get_pos());
		m_continue_menu.select_rel(m_p1.m_input.get_vert());
		m_p1.over_draw();
		m_p2.over_draw();
		if (m_p1.m_play_side==GV::GV_LEFT) res1=GV::LEFT_READY_CENTER_PIX_X;
		else res1=GV::RIGHT_READY_CENTER_PIX_X;
		g_gv.draw_contine_str(res1, GV::CONTINUE_CENTER_PIX_Y);
		m_continue_menu.draw();
		if (m_p1.m_input.get_any_btn() || m_mouse.get_left()){
			if (m_continue_menu.get_sel_id()==GV::GV_YES) {
				m_p1.set_game_continue();
				set_game_mode(GV::PLAY_STAND_BY);
			}
			else set_game_mode(GV::GAME_CLOSE);		// ReBj[Ȃ
		}
		break;
	// fBGO
	case GV::PLAY_GET_READY:
		m_p1.draw();
		m_p2.draw();
		draw_play_time();
		res1=g_gv.get_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);
		m_p1.ready_draw(res1);
		m_p2.ready_draw(res1);
		 if (res1>3600) {
			m_p1.set_new_drop(&m_drop_list[1]);
			m_p2.set_new_drop(&m_drop_list[1]);
			set_game_mode(GV::PLAY_NOMAL);
			m_drop_num1=m_drop_num2=2;
			g_gv.start_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);
		}
		break;
	case GV::GAME_CLOSE:
		if (m_game_effect_step==0){
			g_gv.set_effect(GV::GV_EFFECT_FADE_OUT);
			m_game_effect_step++;
		}
		else return GV::GV_TITLE;
		break;
	case GV::GAME_CLEAR:
		if (game_clear_frame_up()==GV::GV_NG) set_game_mode(GV::GAME_CLOSE);
		break;
	}
	return GV::GV_OK;
}
// Q[NÃGtFNg
GAME_VS_CPU::game_clear_frame_up(){
	int res1=GV::GV_OK;
	switch(m_game_effect_step){
	case 0:
		g_gv.set_effect(GV::GV_EFFECT_FADE_OUT);
		m_game_effect_step++;
		m_p_clear_ending = new GAME_CLEAR_ENDING;
		break;
	case 1:
		g_gv.fill_back(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[0]);
		m_game_effect_step++;
		break;
	case 2:
		if (m_p_clear_ending->frame_up()==GV::GV_NG) m_game_effect_step++;
		else if (m_p1.m_input.get_any_btn() || m_mouse.get_left()) m_game_effect_step++;
		break;
	case 3:
		delete m_p_clear_ending; m_p_clear_ending=NULL;
		return GV::GV_NG;
		break;
	}
	return GV::GV_OK;
}

//======================================
//		GAME_ALONE						
//======================================
class GAME_ALONE : public GAME_PLAY_TYPE_BASE {
	MOUSE m_mouse;
	MENU_BOX m_continue_menu;
	DROP_UNIT m_drop_list[GV::DROP_LIST_LEN];
	HUM_PLAYER m_p1;
	int m_drop_num1;

	public :
	frame_up();
	GAME_ALONE();
	game_stand_by();
};
// GAME_ALONE RXgN^
GAME_ALONE::GAME_ALONE(){
	g_gv.fill_main(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);
	g_gv.fill_back(0,0,g_gv.get_win_width(), g_gv.get_win_height(), g_gv.m_sys_hbr[9]);

	m_p1.init(GV::GV_LEFT);
	m_p1.m_input.set_joystick(&g_gv.m_joy1);
	m_p1.mouse_use_on(&m_mouse);

	m_continue_menu.push(GV::GV_YES, &g_gv.sys_img, 272,209,63, 32, &g_gv.sys_img, 272,170,63, 32);
	m_continue_menu.push(GV::GV_NO,  &g_gv.sys_img, 337,209,63, 32, &g_gv.sys_img, 337,170,63, 32);
	m_p1.draw();
	g_gv.set_effect(GV::GV_EFFECT_FADE_IN);
}
// game_stand_by
GAME_ALONE::game_stand_by(){
	int i;
	m_p1.init(m_p1.m_play_side);
	for(i=0;i<GV::DROP_LIST_LEN;i++){
		m_drop_list[i].set(rand()%7);
	}
	m_p1.set_new_drop(&m_drop_list[0]);	m_p1.set_drop_vailed(0);

	m_play_time=0;
	g_gv.start_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);	// vCԁifBfnpj
	return GV::GV_OK;
}
				proceed_stage();
// bott[EAbv
GAME_ALONE::frame_up(){
	int res1;
	m_mouse.update_stat();
	m_p1.update_input();
	switch(get_game_mode()){
	// 
	case GV::PLAY_STAND_BY:
		game_stand_by();
		set_game_mode(GV::PLAY_GET_READY);
		break;
	// ʏv[
	case GV::PLAY_NOMAL:
		update_play_time();
		res1=m_p1.frame_up();
		m_p1.draw();
		draw_play_time();
		if (res1==GV::GV_NEXT_DROP) {
			if(GV::GV_NG==m_p1.set_new_drop(&m_drop_list[m_drop_num1++])) {
				m_p1.set_lose();
				set_game_mode(GV::PLAY_OVER);
			}
			if (m_drop_num1%10==0) m_p1.fall_speed_up();
			if (m_drop_num1>=GV::DROP_LIST_LEN) m_drop_num1=0;
		}
		break;
	// PQ[I
	case GV::PLAY_OVER:
		res1=m_p1.over_frame_up();
		m_p1.over_draw();
		draw_play_time();
		if (res1==GV::GV_NG ) {
			m_continue_menu.set_cur_pos(m_p1.get_table_x()+30, GV::CONTINUE_CENTER_PIX_Y+40);
			set_game_mode(GV::PLAY_SELECT_CONTINUE);	// ReBj[I[h
		}
		break;
	// ReBj[I[h
	case GV::PLAY_SELECT_CONTINUE:
		if (m_mouse.is_move()) m_continue_menu.select_pos(m_mouse.get_pos());
		m_continue_menu.select_rel(m_p1.m_input.get_vert());
		m_p1.over_draw();
		if (m_p1.m_play_side==GV::GV_LEFT) res1=GV::LEFT_READY_CENTER_PIX_X;
		else res1=GV::RIGHT_READY_CENTER_PIX_X;
		g_gv.draw_contine_str(res1, GV::CONTINUE_CENTER_PIX_Y);
		m_continue_menu.draw();
		if (m_p1.m_input.get_any_btn() || m_mouse.get_left()){
			if (m_continue_menu.get_sel_id()==GV::GV_YES) set_game_mode(GV::PLAY_STAND_BY);
			else set_game_mode(GV::GAME_CLOSE);		// ReBj[Ȃ
		}
		break;
	case GV::GAME_CLOSE:
		if (m_game_effect_step==0){
			g_gv.set_effect(GV::GV_EFFECT_FADE_OUT);
			m_game_effect_step++;
		}
		else return GV::GV_TITLE;
		break;
	// fBGO
	case GV::PLAY_GET_READY:
		m_p1.draw();
		draw_play_time();
		res1=g_gv.get_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);
		m_p1.ready_draw(res1);
		 if (res1>3600) {
			m_p1.set_new_drop(&m_drop_list[1]);
			set_game_mode(GV::PLAY_NOMAL);
			m_drop_num1=2;
			g_gv.start_lapse_time(GV::LAPSE_TIME_ID_PLAY_TIME);
		}
		break;
	}
	return GV::GV_OK;
}

