
#include "gz_arc/gz_arc.h"
#include "puyo_screen.h"
//======================================
//		JOYSTICK `					
//======================================
class JOYSTICK {
	JOYSTICK(){};
	int		m_id;
	RECT	m_neutral_range;
	char	m_cross_stat[4], *m_button_stat;
	short	m_button_len;
	JOYINFO m_joyinfo;
	public :
	get_id(){ return m_id; }
	update_stat();	// ԍXV
	get_side();
	get_vert();
	get_btn(int n);
	JOYSTICK(int i, JOYCAPS jc);
	~JOYSTICK(){
		delete[] m_button_stat;
	};
	get_cross_stat(int i){
		if (i<0 || i>=4) return 0;
		return m_cross_stat[i];
	}
	get_button_stat(int i){
		if (i<0 || i>=m_button_len) return 0;
		return m_button_stat[i];
	}
};
//--------------------------------------
//		JOYSTICK ֐					
//--------------------------------------
JOYSTICK::get_side(){
	if (m_cross_stat[GV::GV_LEFT]) return -1;
	if (m_cross_stat[GV::GV_RIGHT]) return 1;
	return 0;
}
JOYSTICK::get_vert(){
	if (m_cross_stat[GV::GV_UP]) return -1;
	if (m_cross_stat[GV::GV_DOWN]) return 1;
	return 0;
}
JOYSTICK::get_btn(int n){
	if (m_button_len<=n) return 0;
	return m_button_stat[n];
}
JOYSTICK::JOYSTICK(int a_id, JOYCAPS jc){
	int i;
	m_id=a_id;
//	jc.szPname     //WCXeBbN̖O
	m_neutral_range.left  =	(jc.wXmin*2 + jc.wXmax	)/3;
	m_neutral_range.right =	(jc.wXmin	+ jc.wXmax*2)/3;
	m_neutral_range.top   =	(jc.wYmin*2	+ jc.wYmax	)/3;
	m_neutral_range.bottom=	(jc.wYmin	+ jc.wYmax*2)/3;

	m_button_len = jc.wNumButtons;	//{^̐
	m_button_stat = new char[m_button_len];
	m_cross_stat[GV::GV_LEFT]	= 0;
	m_cross_stat[GV::GV_RIGHT]	= 0;
	m_cross_stat[GV::GV_UP]		= 0;
	m_cross_stat[GV::GV_DOWN]	= 0;
	for(i=0;i<m_button_len;i++) m_button_stat[i]=0;
//	return 0;
};

//	WCXeBbNo	
JOYSTICK::update_stat(){
	int i, b;
	if (joyGetPos (JOYSTICKID1+m_id, &m_joyinfo)!=JOYERR_NOERROR) ;
	m_cross_stat[GV::GV_LEFT]	= (m_joyinfo.wXpos < m_neutral_range.left)	? 1:0;
	m_cross_stat[GV::GV_RIGHT]	= (m_joyinfo.wXpos > m_neutral_range.right)	? 1:0;
	m_cross_stat[GV::GV_UP]		= (m_joyinfo.wYpos < m_neutral_range.top)	? 1:0;
	m_cross_stat[GV::GV_DOWN]	= (m_joyinfo.wYpos > m_neutral_range.bottom)? 1:0;

	b = WORD(m_joyinfo.wButtons);
	for(i=0;i<m_button_len;i++){
		m_button_stat[i] = b & 1;
		b >>= 1;
	}
	return 0;
};
//======================================
//		LAPSE_TIME `					
//======================================
class LAPSE_TIME {
	public:
	int m_id, m_lapse_time, m_last_lapse_time;
	LAPSE_TIME(){
		m_id=-1;
		m_lapse_time=0;
		m_last_lapse_time=0;
	}
};
class SYS_VAR {
	public :
	int m_game_level;
	char m_frame_skip;
	int m_win_size_mode;				// EBhETCY
	POS m_win_out_pos, m_win_in_pos;	// EBhEʒu
};
//======================================
//		O[oϐ					
//======================================
class GV_EX : public GV, public SYS_VAR {
	int m_now_time;	// Q[̎
	PLIST<LAPSE_TIME> m_lapse_time_list;
	SCREEN screen;
	public :
	// ======O[oϐ============
	JOYSTICK *m_joy1, *m_joy2;			// WCXeBbN
	HBRUSH	m_sys_hbr[SYS_COL_LEN];		// Q[̃VXeFi HBRUSH j
	HPEN	m_sys_hpen[SYS_COL_LEN];	// Q[̃VXeFi HPEN j

	GSIZE m_win_in_size;				// EBhETCY
	int m_fps, m_last_fps;		// FPS

	// }EX
	char m_mouse_sys_showing, m_mouse_use_flag;
	GDIB m_mouse_stock_img;
	POSIZE m_mouse_img_pz;
	int m_mouse_type;

	GDIB sys_img;
	GDIB m_puyo_piece_img;
	GWIN *m_p_app_gwin;
	get_now_time(){ return m_now_time; };
	HWND m_hwnd;
	GFONT m_big_gfont, m_small_gfont;	// tHg
	HFONT m_focus_hfont;
	int m_effect_mode, m_effect_step;

	// ======O[o֐============
	~GV_EX();
	GV_EX();
	get_win_width(){	return GV_WIN_BASE_LEN*GV_BX; }
	get_win_height(){	return GV_WIN_BASE_LEN*GV_BY; }
	update_time(){	m_now_time=timeGetTime();	}	// Q[̎ԍXV
	detect_joystick();			// gp\ȃWCXeBbŇo

	// GtFNg
	effect();										// GtFNg
	set_effect(int mode_code);						// GtFNgEZbeBO
	is_effect(){ return (m_effect_mode!=GV_OK); };	// GtFNgE[h

	// EBhEE|C^ݒ
	set_p_gwin(GWIN *pwin);
	// EBhETCYύX
	change_win_size(int n);
	// tHgE^CvύX
	select_font(int size_code){
		if (size_code==GV_BIG){			m_focus_hfont = m_big_gfont.m_hfont;	}
		else if (size_code==GV_SMALL){	m_focus_hfont = m_small_gfont.m_hfont;	}
		return GV_OK;
	}

	set_bg_mode(int mode){	return screen.set_bg_mode(mode);	}	// eLXgwi[h
	set_text_color(COLORREF text_col, COLORREF back_col);			// eLXgFύX
	draw_text(char *s, int x, int y, int align=GV_LEFT, int v_align=GV_TOP, int rate=255);	// eLXg`
	SIZE get_str_size(char *s){	return screen.get_str_size(s);	}	// eLXgETCY擾

	//====hԂ=====================
	fill_main(int x, int y, int cx, int cy, HBRUSH hbr){
		screen.fill_main(x, y, cx, cy, hbr);
	}
	fill_main(int x, int y, int cx, int cy, char r, char g, char b, int rate){
		screen.fill_main(x, y, cx, cy, r, g, b, rate);
	}
	fill_back(int x, int y, int cx, int cy, HBRUSH hbr){
		screen.fill_back(x, y, cx, cy, hbr);
	}
	fill_work(int x, int y, int cx, int cy, HBRUSH hbr){
		screen.fill_work(x, y, cx, cy, hbr);
	}
	fill_work(int x, int y, int cx, int cy, char r, char g, char b, int rate){
		screen.fill_work(x, y, cx, cy, r, g, b, rate);
	}
	set_alpha_work(int x, int y, int cx, int cy, int rate){
		screen.set_alpha_work(x, y, cx, cy, rate);
	}
	alpha_paste_to_work(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate=255, int blend_flag=1){
		screen.alpha_paste_to_work(x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	//====ɉ摜`=====================
	// 摜`
	img_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate=255, int blend_flag=1){
		return screen.img_draw(x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	// wiɕ`
	to_back_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate=255, int blend_flag=1){
		return screen.to_back_draw(x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	// [Ncbɕ`
	to_work_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate=255, int blend_flag=1){
		return screen.to_work_draw(x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	//==== `=====================
	// [Ncb烁Cʂɕ`
	rework_draw(int x, int y, int cx, int cy, int rate=255, int blend_flag=0){
		return screen.rework_draw(x, y, cx, cy, rate, blend_flag); }
	// wi烁Cʂɕ`
	reback_draw(int x, int y, int cx, int cy, int rate=255, int blend_flag=0){
		return screen.reback_draw(x, y, cx, cy, rate, blend_flag); }
	// Cʂwi
	main_to_back_draw(int x, int y, int cx, int cy){			return screen.main_to_back_draw(x, y, cx, cy); }
	main_to_work_draw(int x, int y, int cx, int cy, int rate){	return screen.main_to_work_draw(x, y, cx, cy, rate); }

	//====VXe摜`=====================
	// 摜l
	img_num_draw(int num, int dx, int dy, int diff_dw, GDIB *pdib, int sx, int sy, int sw, int sh, double diff_sw);

	draw_score_str(int x, int y, int align);			// XRAE`
	draw_score_num(int num, int x, int y, int align);	// XRAlE`
	draw_stage(int num, int x, int y);	// Xe[W`
	draw_time(int num, int x, int y);	// ^C`
	// GAME CLEAR`
	draw_game_clear(int x, int y){	int w=349, h=68;	img_draw(x-w/2, y-h/2, &sys_img, 3, 330, w, 67);	}
	// nextE`
	draw_next_str(int x, int y){	img_draw(x, y-22, &sys_img, 3, 155, 51, 22);	}
	// readyE`
	draw_ready(int num, int x, int y){
		int w=94, h=32;
		img_draw(x-w/2, y-h, &sys_img, 81, 155, w, h);
		w=20;
		img_draw(x-w/2, y, &sys_img, 185+21*(num-1), 155, w, 32);
	}
	// GOE`
	draw_go_str(int x, int y){ int w=115, h=67;	img_draw(x-w/2, y-h/2, &sys_img, 3, 190, w, h); }
	// CONTINEE`
	draw_contine_str(int x, int y){	int w=122;	img_draw(x-w/2, y, &sys_img, 130, 208, w, 26);	}

	// YOU CPU WIN LOSE E`
	draw_you_str(int x, int y){ int w=64;	img_draw(x-w-5, y, &sys_img, 3,  257, w, 32);	 }
	draw_cpu_str(int x, int y){	int w=64;	img_draw(x-w-5, y, &sys_img, 74, 257, w, 32);	}
	draw_win_str(int x, int y){	img_draw(x+5, y, &sys_img, 142, 257, 60, 32);	}
	draw_lose_str(int x, int y){img_draw(x,   y, &sys_img, 208, 257, 76, 32);	}


	// Ԍo߃[`
	void stop_lapse_time();			// Ԍo߂̌vf
	void restart_lapse_time();		// fĂԌo߂̌vĊJ
	int start_lapse_time(int id);	// Ԍo߂̌vX^[g
	int make_lapse_time(int id);	// Ԍo߁E쐬
	int close_lapse_time(int id);	// Ԍo߁Ej
	int get_lapse_time(int id);		// oߎԂ̎擾

	load_img(GDIB *pdib, char* file_name);	// 摜Ǎ
	draw_fps();								// FPS `

	is_archive_have(char* file_name);					// A[JCuEt@CɖړIt@C邩
	load_img_by_archive(GDIB *pdib, char* file_name);	// A[JCuEt@C摜Ǎ
	img_frame_draw(int x, int y, int cx, int cy, int rate=255, int blend_flag=1);	// j[Ƃ̉摜g`
	set_fullscreen();		// tXN[N
	kill_fullscreen();		// tXN[j
	DEVMODE *m_p_devmode;	// tXN[pDEVMODE
	get_font_height(){ return screen.get_font_height(); }
	carry_out_draw(){  return screen.carry_out_draw(); }
	app_core_draw(HDC hdc);	// C`

	load_mouse(int type){ m_mouse_type=type; }
	draw_mouse(POINT *ppo);
	// nr}EX̕\E\
	void show_sys_mouse();
	void hide_sys_mouse();

	// ҂Ԃ̎זՂ
	draw_wait_jama(int x, int y){		img_draw(x, y, &m_puyo_piece_img, 150, 0, GV_BX, GV_BY);	}
	draw_mini_wait_jama(int x, int y){	img_draw(x, y, &m_puyo_piece_img, 175, 0, GV_BX/2, GV_BY/2); }

	draw_picker(int x, int y){
		int i=abs(get_now_time()%1100-550)/110;
		img_draw(x, y, &sys_img, 310+30*i, 265, 22, 20);
	}
};
// nr}EX̕\E\
void GV_EX::show_sys_mouse(){
	if (m_mouse_sys_showing) return;
	ShowCursor(1);
	m_mouse_sys_showing=1;
}
void GV_EX::hide_sys_mouse(){
	if (!m_mouse_sys_showing) return;
	ShowCursor(0);
	m_mouse_sys_showing=0;
};
// fXgN^
GV_EX::~GV_EX(){
	for(int i=0;i<SYS_COL_LEN;i++) DeleteObject(m_sys_hbr[i]);
	for(int i=0;i<SYS_COL_LEN;i++) DeleteObject(m_sys_hpen[i]);
}
// RXgN^
GV_EX::GV_EX(){
	m_win_in_size.set(400, 300);
	m_big_gfont.set_size(24);
	m_small_gfont.set_size(20);
	m_focus_hfont=m_small_gfont.m_hfont;

	m_mouse_sys_showing=m_mouse_use_flag=1;
	m_mouse_stock_img.make(MOUSE_CX_MAX, MOUSE_CY_MAX, 16,0);
	load_mouse(NORMAL_MOUSE);

	m_frame_skip=0;
	m_fps=0; m_last_fps=-1;
	m_game_level=GAME_LEVEL_NORMAL;
	m_p_devmode=NULL;
	m_win_size_mode=WIN_SIZE_DEFAULT;
	m_hwnd=NULL;
	m_p_app_gwin=NULL;
	m_effect_mode=GV_OK;
	m_joy1=m_joy2=NULL;
	for(int i=0;i<SYS_COL_LEN;i++) m_sys_hbr[i]=NULL;
	for(int i=0;i<SYS_COL_LEN;i++) m_sys_hpen[i]=NULL;
	m_now_time=0;
	load_img(&sys_img, "puyo_sys.png");
	m_puyo_piece_img.load_png("../data/puyo_block.png");
	m_win_in_size.set(GV_WIN_BASE_LEN*GV_BX, GV_WIN_BASE_LEN*GV_BY);
	screen.make(m_win_in_size.cx, m_win_in_size.cy);

	m_sys_hbr[0] = CreateSolidBrush(RGB(0,0, 0));
	if (SYS_COL_LEN>1) m_sys_hbr[1] = CreateSolidBrush(RGB(255,0,0));
	if (SYS_COL_LEN>2) m_sys_hbr[2] = CreateSolidBrush(RGB(0,255,0));
	if (SYS_COL_LEN>3) m_sys_hbr[3] = CreateSolidBrush(RGB(0,0,255));
	if (SYS_COL_LEN>4) m_sys_hbr[4] = CreateSolidBrush(RGB(255,255,0));
	if (SYS_COL_LEN>5) m_sys_hbr[5] = CreateSolidBrush(RGB(0,255,255));
	if (SYS_COL_LEN>6) m_sys_hbr[6] = CreateSolidBrush(RGB(255,0, 255));
	if (SYS_COL_LEN>7) m_sys_hbr[7] = CreateSolidBrush(RGB(255,255, 255));
	if (SYS_COL_LEN>8) m_sys_hbr[8] = CreateSolidBrush(RGB(192,192, 192));
	if (SYS_COL_LEN>8) m_sys_hbr[9] = CreateHatchBrush(HS_DIAGCROSS, RGB(255,192, 192));
	m_sys_hpen[0]= CreatePen(PS_SOLID, 1, RGB(255,255, 255));
	m_sys_hpen[1]= CreatePen(PS_SOLID, 1, RGB(255,0, 0));

	detect_joystick();	// gp\ȃWCXeBbŇo

}

inline GV_EX::draw_mouse(POINT *ppo){
	switch(m_mouse_type){
	case NORMAL_MOUSE: m_mouse_img_pz.set(317, 124, 12, 20); break;
	case LEFT_ARROW_MOUSE: break;
	case RIGHT_ARROW_MOUSE: break;
	case DOWN_ARROW_MOUSE: break;
	}
	screen.img_copy_direct(0, 0, &m_mouse_stock_img, ppo->x, ppo->y, m_mouse_img_pz.cx, m_mouse_img_pz.cy, 255, 0);
	screen.img_draw_direct(
		ppo->x, ppo->y, &sys_img, m_mouse_img_pz.x, m_mouse_img_pz.y, m_mouse_img_pz.cx, m_mouse_img_pz.cy, 255, 0);
}
// C`
inline GV_EX::app_core_draw(HDC hdc){
	POINT po;
	GetCursorPos(&po);
	ScreenToClient(m_hwnd, &po);

	// }EX`
	if (m_mouse_use_flag && !m_mouse_sys_showing) {
		if (m_win_size_mode!=WIN_SIZE_DEFAULT && m_win_size_mode!=WIN_SIZE_FULL){
			po.x = (get_win_width() *po.x/m_win_in_size.cx);
			po.y = (get_win_height()*po.y/m_win_in_size.cy);
		}
		draw_mouse(&po);
	}

	if (m_win_size_mode==WIN_SIZE_DEFAULT || m_win_size_mode==WIN_SIZE_FULL){
		BitBlt(hdc, m_win_in_pos.x,m_win_in_pos.y, get_win_width(), get_win_height(),
							screen.get_main_dc(), 0,0, SRCCOPY);
	} else {
		RECT rc;
		GetClientRect(m_hwnd, &rc);
		StretchBlt(hdc, m_win_in_pos.x,m_win_in_pos.y, rc.right-rc.left, rc.bottom,
			screen.get_main_dc(), 0,0, get_win_width(), get_win_height(), SRCCOPY);
	}

	// }EX`悵Ƃɖ߂
	if (m_mouse_use_flag && !m_mouse_sys_showing)
		screen.img_draw_direct(po.x, po.y, &m_mouse_stock_img, 0, 0, m_mouse_img_pz.cx, m_mouse_img_pz.cy, 255, 0);
}
// EBhEE|C^ݒ
GV_EX::set_p_gwin(GWIN *pwin){
	m_p_app_gwin=pwin;
	m_hwnd=pwin->m_hwnd;
	sys_img.stand_dc(m_hwnd);
	screen.stand_dc(m_hwnd);
	m_puyo_piece_img.stand_dc(m_hwnd);
	m_mouse_stock_img.stand_dc(m_hwnd);
	return GV::GV_OK;
}
//-------t@C-------------------------
// A[JCuEt@CɖړIt@C邩
GV_EX::is_archive_have(char* file_name){
#define PUYO_ARCHIVE_FILE  "puyo_arc.gza"
	GZ_ARCHIVE gz_arc;
	int i, len;
	gz_arc.load_list(PUYO_ARCHIVE_FILE);
	len=gz_arc.m_header_list.size();
	for(i=0;i<len;i++){
		if (!strcmp(gz_arc.m_header_list[i]->m_filename, file_name)) return 1;
	};
	return 0;
}
// A[JCuEt@C摜Ǎ
GV_EX::load_img_by_archive(GDIB *pdib, char* file_name){
	GZ_ARCHIVE gz_arc;
	int n, i, len;
	gz_arc.load_list(PUYO_ARCHIVE_FILE);
	for(i=0;i<len;i++){
		if (!strcmp(gz_arc.m_header_list[i]->m_filename, file_name)) {
			n=i;
			break;
		}
	};

	GZ_ARCHIVE_HEADR_LIST_ITEM *pitem;
	pitem = gz_arc.m_header_list[n];
	if (!pitem) return -1;
	len = (pitem->m_comp_size>0) ? pitem->m_comp_size : pitem->m_decomp_size ;
	if (len<0) return -1;

	FILE *fp_in;
	fp_in = fopen(PUYO_ARCHIVE_FILE, "rb");
	fseek(fp_in, pitem->m_index, SEEK_SET);
	pdib->load_png(fp_in);
	fclose(fp_in);
	return 0;
}
// 摜Ǎ
GV_EX::load_img(GDIB *pdib, char* file_name){
	char s[256];
	if (is_archive_have(file_name)) {
		load_img_by_archive(pdib, file_name);
	}
	/*
	else {
		sprintf(s, "../data/%s", file_name);
		pdib->load_png(s);
//	}	*/

	pdib->stand_dc(m_hwnd);
	return GV_OK;
}
//-------VXe摜`-------------------------
// XRAlE`
inline GV_EX::draw_score_num(int num, int x, int y, int align){
//	num=97654320;
	int w=20, h=35, i, len;
	len=get_figure(num);
	if (align==GV_RIGHT){
		reback_draw(x, y, 8*14+6, 60);
		if (len<=4) x+=4*14;
		else x+=len*14;
	}
	else {
		x-=6;
		reback_draw(x-8*14, y, 8*14+6, 60);
	}
	img_num_draw(num, x-14, y, 14, &sys_img, 78, 117, 20, 33, 20.2);
	return 0;
}
// 摜l
inline GV_EX::img_num_draw(int num, int dx, int dy, int diff_dw, GDIB *pdib, int sx, int sy, int sw, int sh, double diff_sw){
	int i, len=get_figure(num);
	for(i=0;i<len;i++){
		img_draw(dx, dy, pdib, sx+diff_sw*(num%10), sy, sw, sh);
		dx-=diff_dw;
		if (!(num=num/10)) break;
	}
}
// XRAE`
inline GV_EX::draw_score_str(int x, int y, int align){
	if (align==GV_LEFT) x-=58;
	img_draw(x, y, &sys_img, 2, 120, 58, 24);
}
// Xe[W`
inline GV_EX::draw_stage(int num, int x, int y){
	x-=10;
//	num=90;
	int w=87, h=48, sh, i, len;
	reback_draw(x-w/2,y, w, h);
	img_draw(x-w/2,y, &sys_img, 1, 3, w, h);
	sh=38;
	len=get_figure(num);
	x+=(len-1)*23-5;
	reback_draw(x+w/2,y, 23*2, sh);
	img_num_draw(num, x+w/2+10, y, 20, &sys_img, 95, 7, 27, sh, 28.9);
	return 0;
}
// ^C`
inline GV_EX::draw_time(int num, int x, int y){
//	num=950;
	if (num>999) num=999;
	else if (num<0) num=0;
	int w=74, h=41, i, len;
	reback_draw(x-w+5, y, w, 50);
	img_draw(x-w+5,y, &sys_img, 2, 65, w, h);
	len=get_figure(num);
	y+=(h-37)/2;
	reback_draw(x, y, 19*3, 37);
	x+=(len-1)*20-5;
	img_num_draw(num, x, y, 17, &sys_img, 77, 65, 26, 37, 27.0);
	return 0;
}
// FPS `
GV_EX::draw_fps(){
	if (m_fps>999) m_fps=999;
	if (m_fps==m_last_fps) return 0;
	int x=get_win_width()/2, y=2;
	int num=m_fps;
	int w, i, len;
	len=get_figure(num);		// Qbg
	w=54+3*20+4;
	reback_draw(x-w/2, y, w, 32);
	w=54+len*20+4;
		img_draw(x-w/2, y, &sys_img, 5, 303, 54, 32);
	img_num_draw(num, x+w/2-24, y, 20, &sys_img, 71, 304, 23, 32, 23);
	return 0;
}
// 摜g
GV_EX::img_frame_draw(int x, int y, int cx, int cy, int rate, int blend_flag){
	int i, len, sx, sy, sw, sh;
	sx=370; sy=333; sw=20; sh=20;
	x-=10; y-=10; cx+=20; cy+=20;
	len=(cx-sw)/sw;
	for(i=1;i<len;i++){
		to_work_draw		(x+i*sw, y, &sys_img, sx+sw, sy, sw, sh, rate, blend_flag);	// ドC
		alpha_paste_to_work	(x+i*sw, y, &sys_img, sx+sw, sy, sw, sh, rate, blend_flag);	// ドC
	}
	to_work_draw		(x+len*sw, y, &sys_img, sx+sw, sy, cx-len*sw-sw, sh, rate, blend_flag);	// ドC
	alpha_paste_to_work	(x+len*sw, y, &sys_img, sx+sw, sy, cx-len*sw-sw, sh, rate, blend_flag);	// ドC

	for(i=1;i<len;i++){
		to_work_draw		(x+i*sw,y+cy-sh, &sys_img, sx+sw, sy+sh*2, sw, sh, rate, blend_flag);	// C
		alpha_paste_to_work	(x+i*sw,y+cy-sh, &sys_img, sx+sw, sy+sh*2, sw, sh, rate, blend_flag);	// C
	}
	to_work_draw		(x+len*sw, y+cy-sh, &sys_img, sx+sw, sy+sh*2, cx-len*sw-sw, sh, rate, blend_flag);	// C
	alpha_paste_to_work	(x+len*sw, y+cy-sh, &sys_img, sx+sw, sy+sh*2, cx-len*sw-sw, sh, rate, blend_flag);	// C

	len=(cy-sh)/sh;
	for(i=1;i<len;i++){
		to_work_draw		(x, y+i*sh, &sys_img, sx, sy+sh, sw, sh, rate, blend_flag);	// C
		alpha_paste_to_work	(x, y+i*sh, &sys_img, sx, sy+sh, sw, sh, rate, blend_flag);	// C
	}
	to_work_draw		(x, y+len*sh, &sys_img, sx, sy+sh, sw, cy-len*sh-sh, rate, blend_flag);
	alpha_paste_to_work	(x, y+len*sh, &sys_img, sx, sy+sh, sw, cy-len*sh-sh, rate, blend_flag);

	for(i=1;i<len;i++){
		to_work_draw		(x+cx-sw, y+i*sh, &sys_img, sx+sw*2, sy+sh,	sw, sh, rate, blend_flag);	// EC
		alpha_paste_to_work	(x+cx-sw, y+i*sh, &sys_img, sx+sw*2, sy+sh,	sw, sh, rate, blend_flag);	// EC
	}
	to_work_draw		(x+cx-sw, y+len*sh, &sys_img, sx+sw*2, sy+sh, sw, cy-len*sh-sh, rate, blend_flag);
	alpha_paste_to_work	(x+cx-sw, y+len*sh, &sys_img, sx+sw*2, sy+sh, sw, cy-len*sh-sh, rate, blend_flag);

	to_work_draw(x, y,				&sys_img, sx, sy,			sw, sh, rate, blend_flag);	// 
	to_work_draw(x, y+cy-sh,		&sys_img, sx, sy+sh*2,		sw, sh, rate, blend_flag);	// 
	to_work_draw(x+cx-sw, y,		&sys_img, sx+sw*2, sy,		sw, sh, rate, blend_flag);	// E
	to_work_draw(x+cx-sw, y+cy-sh,	&sys_img, sx+sw*2, sy+sh*2, sw, sh, rate, blend_flag);	// E

	alpha_paste_to_work(x, y,			&sys_img, sx, sy,			sw, sh, rate, blend_flag);	// 
	alpha_paste_to_work(x, y+cy-sh,		&sys_img, sx, sy+sh*2,		sw, sh, rate, blend_flag);	// 
	alpha_paste_to_work(x+cx-sw, y,		&sys_img, sx+sw*2, sy,		sw, sh, rate, blend_flag);	// E
	alpha_paste_to_work(x+cx-sw, y+cy-sh,	&sys_img, sx+sw*2, sy+sh*2, sw, sh, rate, blend_flag);	// E
	return GV_OK;
}

// eLXg`
GV_EX::draw_text(char *s, int x, int y, int align, int v_align, int rate){
	if (!s) return 0;
	screen.draw_text(m_focus_hfont, s, x, y, align, v_align, rate);
	return GV_OK;
}
// eLXgFύX
GV_EX::set_text_color(COLORREF text_col, COLORREF back_col){
	return screen.set_text_color(text_col, back_col);
} 

// GtFNgEZbeBO
GV_EX::set_effect(int mode_code){
	m_effect_mode=mode_code;
	m_effect_step=0;
	if (m_effect_mode==GV_EFFECT_FADE_IN || m_effect_mode==GV_EFFECT_FADE_OUT){
		main_to_work_draw(0,0, screen.get_width(), screen.get_height(), 255);
	}
	if (m_effect_mode==GV_EFFECT_FADE_IN){
		fill_main(0,0, screen.get_width(), screen.get_height(), (HBRUSH)GetStockObject(BLACK_BRUSH));
	}
	return GV_OK;
}
// GtFNg
GV_EX::effect(){
	int fade_credits=20;
	if (m_effect_mode==GV_EFFECT_FADE_IN){
		if ((m_effect_step*fade_credits)<255) {
			rework_draw(0,0,screen.get_width(), screen.get_height(), m_effect_step*fade_credits, 0);
		}
		else {
			rework_draw(0,0,screen.get_width(), screen.get_height(), 255);
			m_effect_mode=GV_OK;
		}
	}
	if (m_effect_mode==GV_EFFECT_FADE_OUT){
		if ((m_effect_step*fade_credits)<255) {
			rework_draw(0,0,screen.get_width(), screen.get_height(), 255-m_effect_step*fade_credits, 0);
		}
		else {
			fill_main(0,0, screen.get_width(), screen.get_height(), (HBRUSH)GetStockObject(BLACK_BRUSH));
			m_effect_mode=GV_OK;
		}
	}
	m_effect_step++;
	return GV_OK;
}
//-------EBhE-------------------------
// EBhETCYύX
GV_EX::change_win_size(int n){
	if (!m_p_app_gwin) return GV_OK;
	m_win_size_mode=n;
	if (n==WIN_SIZE_DEFAULT)m_win_in_size.set(GV_WIN_BASE_LEN*GV_BX, GV_WIN_BASE_LEN*GV_BY);
	if (n==WIN_SIZE_640X480)m_win_in_size.set(640, 480);
	if (n==WIN_SIZE_FULL)	m_win_in_size.set(GV_WIN_BASE_LEN*GV_BX, GV_WIN_BASE_LEN*GV_BY);

	if (n==WIN_SIZE_FULL) {
		int w=800/2, h=600/2;
		m_p_app_gwin->set_size(w, h);
		m_win_in_pos.set((w-GV_WIN_BASE_LEN*GV_BX)/2, (h-GV_WIN_BASE_LEN*GV_BY)/2);
		set_fullscreen();
	}
	else {
		kill_fullscreen();
		RECT rc=m_win_in_size;
		AdjustWindowRectEx(&rc, m_p_app_gwin->get_style(), 0, m_p_app_gwin->get_ex_style());
		m_win_in_pos.set(0,0);
		m_p_app_gwin->set_size(rc.right-rc.left, rc.bottom-rc.top);
	}
	return GV_OK;
}
// tXN[j
GV_EX::kill_fullscreen(){
	if (!m_p_devmode) return 0;
	SetWindowLong(m_hwnd,GWL_STYLE,WS_VISIBLE | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX);
	::ChangeDisplaySettings(m_p_devmode, 0);
	delete m_p_devmode;
	m_p_devmode=NULL;
	RECT rc;
	GetWindowRect(m_hwnd, (LPRECT)&rc);
	if (SetWindowPos(m_hwnd,HWND_NOTOPMOST,m_win_out_pos.x,m_win_out_pos.y,
				rc.right-rc.left, rc.bottom-rc.top,SWP_SHOWWINDOW | SWP_DRAWFRAME))
		return 1;
	return 0;
}
// tXN[N
GV_EX::set_fullscreen(){
	POSIZE pz;
	RECT rc;
	GetWindowRect(m_hwnd, (LPRECT)&rc);
	pz=rc;
	m_win_out_pos.x=pz.x;
	m_win_out_pos.y=pz.y;
	if (m_p_devmode) return 0;
	m_p_devmode= new DEVMODE;
	HDC	hdc = GetDC(NULL);

	ZeroMemory(m_p_devmode, sizeof(DEVMODE));
	m_p_devmode->dmSize = sizeof(DEVMODE);
	m_p_devmode->dmPelsWidth  = GetDeviceCaps(hdc, HORZRES);
	m_p_devmode->dmPelsHeight = GetDeviceCaps(hdc, VERTRES);
	m_p_devmode->dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;

	// Windows NT/2000p
	if ((GetVersion() & 0x80000000) == 0) {				
		m_p_devmode->dmFields |= DM_DISPLAYFREQUENCY;
		m_p_devmode->dmDisplayFrequency = GetDeviceCaps(hdc, VREFRESH);
	}

	DEVMODE tmp_devmode;
	tmp_devmode = *m_p_devmode;
	tmp_devmode.dmPelsWidth  = pz.cx;
	tmp_devmode.dmPelsHeight = pz.cy;
	tmp_devmode.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;

	if (!SetWindowLong(m_hwnd,GWL_STYLE,WS_VISIBLE)) return GV_NG;
	if (ChangeDisplaySettings(&tmp_devmode, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL) return GV_NG;
	SetWindowPos(m_hwnd,HWND_TOPMOST,	0,0,pz.cx, pz.cy,SWP_SHOWWINDOW | SWP_DRAWFRAME);
	ReleaseDC(0,hdc);
	return GV_OK;
}
//-------Ԍo߃[`-------------------------
// Ԍo߂~߂
void GV_EX::stop_lapse_time() {
	int i, len=m_lapse_time_list.size();
	for(i=0;i<len;i++){
		m_lapse_time_list[i]->m_lapse_time += m_now_time - m_lapse_time_list[i]->m_last_lapse_time;
	}
}
// Ԍo߂ăX^[g
void GV_EX::restart_lapse_time() {
	int i, len=m_lapse_time_list.size();
	for(i=0;i<len;i++){
		m_lapse_time_list[i]->m_last_lapse_time = m_now_time;
	}
};
// Ԍo߂X^[g
int GV_EX::start_lapse_time(int id) {
	int i, len=m_lapse_time_list.size();
	LAPSE_TIME *p_lapse;
	for(i=0;i<len;i++){
		p_lapse=m_lapse_time_list[i];
		if (p_lapse->m_id==id){
			p_lapse->m_last_lapse_time = m_now_time;
			p_lapse->m_lapse_time = 0;
			return GV_OK;
		}
	}
	return GV_NG;
}
// Ԍo߂쐬
int GV_EX::make_lapse_time(int id) {
	int i, len=m_lapse_time_list.size();
	for(i=0;i<len;i++) if (m_lapse_time_list[i]->m_id==id) return GV_NG;
	LAPSE_TIME *p_lapse = new LAPSE_TIME;
	p_lapse->m_last_lapse_time=m_now_time;
	p_lapse->m_lapse_time=0;
	p_lapse->m_id=id;
	m_lapse_time_list.pushp(p_lapse);
	return GV_OK;
}
// Ԍo߂j
int GV_EX::close_lapse_time(int id) {
	int i, len=m_lapse_time_list.size();
	for(i=0;i<len;i++) if (m_lapse_time_list[i]->m_id==id) { m_lapse_time_list.pop(i); return GV_OK; }
	return GV_NG;
}
// oߎԂ擾
int GV_EX::get_lapse_time(int id) {
	int i, len=m_lapse_time_list.size();
	LAPSE_TIME *p_lapse;
	for(i=0;i<len;i++){
		p_lapse=m_lapse_time_list[i];
		if (p_lapse->m_id==id){
			return (p_lapse->m_lapse_time + (m_now_time-p_lapse->m_last_lapse_time));
		}
	}
	return 0;
}
// gp\ȃWCXeBbŇo
GV_EX::detect_joystick(){
	int i;
	static JOYCAPS joycaps;
	static JOYINFO joyinfo;
	bool ok, ok2;
	if (m_joy1 && m_joy2) return GV_OK;
	for(i=0;i<16;i++){
		ok=joyGetDevCaps(JOYSTICKID1+i, &joycaps, sizeof(JOYCAPS))==JOYERR_NOERROR;
		ok2=joyGetPos	(JOYSTICKID1+i, &joyinfo)==JOYERR_NOERROR;
		if (ok && ok2)	{
			if (m_joy1 && m_joy1->get_id()==i) continue;
			if (m_joy2 && m_joy2->get_id()==i) continue;

			if		(!m_joy1) m_joy1= new JOYSTICK(i, joycaps);
			else if	(!m_joy2) m_joy2= new JOYSTICK(i, joycaps);
		}
		if (m_joy1 && m_joy2) return GV_OK;
	}
	return GV_NG;	// WCXeBbN2ȉ
}
			//	MessageBox(NULL,"WCXeBbŇo", "", MB_OK);

// O[oϐ͂ꂾ
extern GV_EX g_gv;

