
//======================================
//		MENU_BOX						
//======================================
class MENU_BOX {
	class MENU_BOX_ITEM {
		public :
		STR m_str, m_sel_str;
		GDIB *m_pimg, *m_sel_pimg;
		int m_id;
		POSIZE m_posize, m_sel_posize, m_img_posize, m_img_sel_posize;
		MENU_BOX_ITEM(){
			m_pimg=m_sel_pimg=NULL;
		}
	};
	int m_pos_x, m_pos_y;
	int m_bg_mode, m_sel_bg_mode;
	char m_need_reback;
	PLIST<MENU_BOX_ITEM> m_items;
	COLORREF m_text_col, m_sel_text_col, m_bg_col, m_sel_bg_col;
	public :
	int m_select_val;
	MENU_BOX(){
		m_need_reback=1;
		m_select_val=0;
		m_pos_x=0; m_pos_y=0;
		m_text_col=RGB(0, 0, 0);
		m_sel_text_col=RGB(255, 0, 0);
		m_bg_col=m_sel_bg_col=RGB(255, 255, 255);
		m_bg_mode=m_sel_bg_mode=OPAQUE;
	}
	set_cur_pos(int x, int y){
		m_pos_x=x; m_pos_y=y;
	}
	POINT get_cur_pos(){
		POINT po;
		po.x=m_pos_x;
		po.y=m_pos_y;
		return po;
	}
	POSIZE get_item_posize(int i){
		POSIZE pz;
		if (m_items[i]) pz=m_items[i]->m_posize;
		return pz;
	}
	get_num_by_id(int id){
		int i, len=m_items.size();
		for(i=0;i<len;i++) if (m_items[i] && id==m_items[i]->m_id) return i;
		return -1;
	}
	POSIZE get_posize(){
		POSIZE *ppz, max_pz;
		int i, len=m_items.size();
		if (len<=0) return max_pz;
		max_pz=m_items[0]->m_posize;
		for(i=1;i<len;i++){
			ppz=&m_items[i]->m_posize;
			max_pz.x=min(max_pz.x, ppz->x);
			max_pz.y=min(max_pz.y, ppz->y);
			max_pz.cx=max(max_pz.x+max_pz.cx, ppz->x+ppz->cx)-max_pz.x;
			max_pz.cy=max(max_pz.y+max_pz.cy, ppz->y+ppz->cy)-max_pz.y;
		}
		max_pz.set_pos(m_pos_x+max_pz.x, m_pos_y+max_pz.y);
		return max_pz;
	}
	set_text_color(COLORREF normal_col, COLORREF sel_col){
		m_text_col=normal_col;
		m_sel_text_col=sel_col;
		return GV::GV_OK;
	}
	set_bg_color(COLORREF normal_col, COLORREF sel_col){
		m_bg_col=normal_col;
		m_sel_bg_col=sel_col;
		return GV::GV_OK;
	}
	set_bg_mode(int bg_mode, int sel_bg_mode){
		if (bg_mode==TRANSPARENT || bg_mode==OPAQUE) m_bg_mode=bg_mode;
		if (sel_bg_mode==TRANSPARENT || sel_bg_mode==OPAQUE) m_sel_bg_mode=sel_bg_mode;
		return GV::GV_OK;
	}
	get_sel(){ return m_select_val; };
	get_sel_id(){ return (m_items[m_select_val])? m_items[m_select_val]->m_id : 0 ; };
	is_ride(POINT po){
		POSIZE *ppz;
		int i, len=m_items.size();
		for(i=0;i<len;i++){
			ppz=&m_items[i]->m_posize;
			if (po.x>=(ppz->x+m_pos_x) && po.y>=(ppz->y+m_pos_y)
					&& po.x<=(ppz->x+ppz->cx+m_pos_x) && po.y<=(ppz->y+ppz->cy+m_pos_y)) {
						return 1;
			}
		}
		return 0;
	}
	select_id(int id){
		int i, len=m_items.size();
		for(i=0;i<len;i++){
			if (m_items[i]->m_id==id) {
				m_select_val=i;
				break;
			}
		}
		return GV::GV_OK;
	}
	select_pos(POINT po){
		POSIZE *ppz;
		int i, len=m_items.size(), new_select_val=-1;
		for(i=0;i<len;i++){
			ppz=&m_items[i]->m_posize;
			if (po.x>=(ppz->x+m_pos_x) && po.y>=(ppz->y+m_pos_y)
					&& po.x<=(ppz->x+ppz->cx+m_pos_x) && po.y<=(ppz->y+ppz->cy+m_pos_y)) {
				new_select_val=m_select_val=i;
				break;
			}
		}
		if (m_select_val<0) m_select_val=0;
		else if (m_select_val>=m_items.size()) m_select_val=m_items.size()-1;
		if (new_select_val<0) return GV::GV_NG;
		return GV::GV_OK;
	}
	select_none(){ return m_select_val=-1; };
	select_rel(int di){
		m_select_val+=di;
		if (m_select_val<0) m_select_val=0;
		else if (m_select_val>=m_items.size()) m_select_val=m_items.size()-1;
		return GV::GV_OK;
	}
	// ACeǉ(摜Łj
	push(int id, GDIB *pdib, int x, int y, int cx, int cy, GDIB *s_pdib, int sx, int sy, int scx, int scy){
		MENU_BOX_ITEM *pitem= new MENU_BOX_ITEM;
		pitem->m_id = id;	// ID Zbg
		pitem->m_pimg=pdib;
		pitem->m_img_posize.set(x, y, cx, cy);
		pitem->m_posize.set_size(cx, cy);
		pitem->m_posize.x=0;
		pitem->m_posize.y= (m_items.size()>0)?
			m_items[m_items.size()-1]->m_posize.y+m_items[m_items.size()-1]->m_posize.cy+1 : 0;

		pitem->m_sel_pimg=s_pdib;
		pitem->m_img_sel_posize.set(sx, sy, scx, scy);
		pitem->m_sel_posize.set_size(scx, scy);

		m_items.pushp(pitem);
		return GV::GV_OK;
	}
	// ACeǉ(Łj
	push(int id, char *s, char *sel_s=NULL){
		MENU_BOX_ITEM *pitem= new MENU_BOX_ITEM;
		pitem->m_id = id;	// ID Zbg
		pitem->m_str = s;
		if (sel_s) pitem->m_sel_str = sel_s;
		SIZE size, sel_size;
		size=g_gv.get_str_size(s);
		sel_size=g_gv.get_str_size(sel_s);
		pitem->m_posize.cx=max(size.cx, sel_size.cx);
		pitem->m_posize.cy=max(size.cy, sel_size.cy);
		pitem->m_posize.x=0;
		pitem->m_posize.y= (m_items.size()>0)?
			m_items[m_items.size()-1]->m_posize.y+m_items[m_items.size()-1]->m_posize.cy+1 : 0;
		m_items.pushp(pitem);
		return GV::GV_OK;
	}
	set_need_reback(char c){
		m_need_reback=c;
	};
	enum { TO_MAIN, TO_WORK };
	draw(int rate=255, int dst_id=TO_MAIN);
};
MENU_BOX::draw(int rate, int dst_id){
	int i, len=m_items.size();
	int h=g_gv.get_font_height()+5;
	POSIZE *ppz, *p_img_pz;
	GDIB *pdib;
	char *s;
	for(i=0;i<len;i++){
		ppz=&m_items[i]->m_posize;
		if (m_need_reback) g_gv.reback_draw(ppz->x+m_pos_x, ppz->y+m_pos_y, ppz->cx, ppz->cy);
		if (m_select_val==i) {
			pdib=m_items[i]->m_sel_pimg;
			if (pdib){
				p_img_pz=&m_items[i]->m_img_sel_posize;
				if (dst_id==TO_MAIN)
					g_gv.img_draw(ppz->x+m_pos_x, ppz->y+m_pos_y, pdib,
								p_img_pz->x, p_img_pz->y, p_img_pz->cx, p_img_pz->cy, rate);
				else if (dst_id==TO_WORK)
					g_gv.to_work_draw(ppz->x+m_pos_x, ppz->y+m_pos_y, pdib,
								p_img_pz->x, p_img_pz->y, p_img_pz->cx, p_img_pz->cy, rate);
			}
			s=m_items[i]->m_sel_str.buf;
			if (!s) s=m_items[i]->m_str.buf;
			if (s){
				g_gv.set_bg_mode(m_sel_bg_mode);
				g_gv.set_text_color(m_sel_text_col, m_sel_bg_col);
				g_gv.draw_text(s, ppz->x+m_pos_x, ppz->y+m_pos_y, GV::GV_LEFT, GV::GV_TOP, rate);
			}
		}
		else {
			pdib=m_items[i]->m_pimg;
			if (pdib){
				p_img_pz=&m_items[i]->m_img_posize;
				if (dst_id==TO_MAIN)
					g_gv.img_draw(ppz->x+m_pos_x, ppz->y+m_pos_y, pdib,
								p_img_pz->x, p_img_pz->y, p_img_pz->cx, p_img_pz->cy, rate);
				else if (dst_id==TO_WORK)
					g_gv.to_work_draw(ppz->x+m_pos_x, ppz->y+m_pos_y, pdib,
								p_img_pz->x, p_img_pz->y, p_img_pz->cx, p_img_pz->cy, rate);
			}
			s=m_items[i]->m_str.buf;
			if (s){
				g_gv.set_bg_mode(m_bg_mode);
				g_gv.set_text_color(m_text_col, m_bg_col);
				g_gv.draw_text(s, ppz->x+m_pos_x, ppz->y+m_pos_y, GV::GV_LEFT, GV::GV_TOP, rate);
			}
		}
	}
	return GV::GV_OK;
}
class PLURAL_MEMU_BOX_MANAGER {
	public:
	MENU_BOX **m_pmenus;
	int m_pmenu_len, m_focus_pmenu;
	int m_focus_main_rate, m_focus_back_rate, m_un_focus_main_rate, m_un_focus_back_rate;
	PLURAL_MEMU_BOX_MANAGER(){
		m_pmenu_len=m_focus_pmenu=0;
		m_pmenus=NULL;
		m_focus_main_rate=255;
		m_focus_back_rate=100;
		m_un_focus_main_rate=140;
		m_un_focus_back_rate=130;
	}
	~PLURAL_MEMU_BOX_MANAGER(){
		delete[] m_pmenus;
	}
	make(int n){
		if (n<=0) return 0;
		m_pmenus = new MENU_BOX*[n];
		m_pmenu_len=n;
		for(int i=0;i<m_pmenu_len;i++) m_pmenus[i]=NULL;
		m_focus_pmenu=0;
	}
	set_pmenu(int n, MENU_BOX *pmenu){
		if (n<0 || n>=m_pmenu_len) return -1;
		m_pmenus[n]=pmenu;
	//	if (pmenu) pmenu->set_need_reback(0);
		return 0;
	}
	set_rate(int focus_main, int focus_back, int un_focus_main, int un_focus_back){
		m_focus_main_rate=focus_main;
		m_focus_back_rate=focus_back;
		m_un_focus_main_rate=un_focus_main;
		m_un_focus_back_rate=un_focus_back;
	}
	draw_bg(GDIB *p_back_img){
		POSIZE pz;
		int i;
		g_gv.set_alpha_work(0,0, g_gv.get_win_width(), g_gv.get_win_height(), 0);
		for(i=0;i<m_pmenu_len;i++){
			if (!m_pmenus[i]) continue;
			pz=m_pmenus[i]->get_posize();
			g_gv.reback_draw(pz.x-30, pz.y-30, pz.cx+60, pz.cy+60);
			if (i==m_focus_pmenu) continue;
			g_gv.set_alpha_work(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 120);
			g_gv.fill_work(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 0,0,0, 255);
			g_gv.img_frame_draw(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 160, 1);
		}
		for(i=0;i<m_pmenu_len;i++){
			if (!m_pmenus[i] || i==m_focus_pmenu) continue;
			m_pmenus[i]->draw(m_un_focus_main_rate, MENU_BOX::TO_WORK);
		}
			pz=m_pmenus[m_focus_pmenu]->get_posize();
			g_gv.set_alpha_work(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 110);
			g_gv.fill_work(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 0,0,0, 255);
			g_gv.img_frame_draw(pz.x-10, pz.y-10, pz.cx+20, pz.cy+20, 255, 1);
	}
	draw(){
		draw_unfocus();
		draw_focus();
	}
	set_picker_back(){
		POINT po;
		POSIZE pz;
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return GV::GV_NG;
		MENU_BOX *pmenu=m_pmenus[m_focus_pmenu];
		if (pmenu){
			po=pmenu->get_cur_pos();
			pz=pmenu->get_item_posize(pmenu->get_sel());
			g_gv.main_to_work_draw	(po.x+pz.x-26, po.y+pz.y+(pz.cy-20)/2, 22, 20, 255);
			g_gv.set_alpha_work		(po.x+pz.x-26, po.y+pz.y+(pz.cy-20)/2, 22, 20, 255);
		}
	}
	draw_picker(){
		POINT po;
		POSIZE pz;
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return GV::GV_NG;
		MENU_BOX *pmenu=m_pmenus[m_focus_pmenu];
		if (pmenu){
			po=pmenu->get_cur_pos();
			pz=pmenu->get_item_posize(pmenu->get_sel());
			g_gv.rework_draw(po.x+pz.x-26, po.y+pz.y+(pz.cy-20)/2, 22, 20, 255, 1);
			g_gv.draw_picker(po.x+pz.x-26, po.y+pz.y+(pz.cy-20)/2);
		}
	}
	draw_unfocus(){
		int i;
		POSIZE pz;
		for(i=0;i<m_pmenu_len;i++){
			if (!m_pmenus[i]) continue;
			pz=m_pmenus[i]->get_posize();
			g_gv.reback_draw(pz.x-30, pz.y-30, pz.cx+60, pz.cy+60);
		}
		g_gv.rework_draw(0,0, g_gv.get_win_width(), g_gv.get_win_height(), 255, 1);
		return GV::GV_OK;
	}
	draw_focus(){
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return GV::GV_NG;
		if (m_pmenus[m_focus_pmenu])m_pmenus[m_focus_pmenu]->draw(m_focus_main_rate);
	}
	get_sel(){
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return -1;
		if (m_pmenus[m_focus_pmenu]) return m_pmenus[m_focus_pmenu]->get_sel();
		return -1;
	}
	select_rel(int di){
		if (!di) return GV::GV_NG;
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return GV::GV_NG;
		if (m_pmenus[m_focus_pmenu]) m_pmenus[m_focus_pmenu]->select_rel(di);
		return GV::GV_OK;
	}
	is_ride(POINT po){
		int i, res=GV::GV_NG;
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return 0;
		if (m_pmenus[m_focus_pmenu]) res=m_pmenus[m_focus_pmenu]->is_ride(po);
		return res;
	}
	select_pos(POINT po){
		int i, res=GV::GV_NG;
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return GV::GV_NG;
		if (m_pmenus[m_focus_pmenu]) res=m_pmenus[m_focus_pmenu]->select_pos(po);
		return res;
		if (res==GV::GV_NG){
			for(i=0;i<m_pmenu_len;i++){
				if (!m_pmenus[i] || i==m_focus_pmenu) continue;
				res=m_pmenus[i]->select_pos(po);
				if (res==GV::GV_OK) {
					m_focus_pmenu=i;
					break;
				}
			}
		}
	}
	change_focus_menu(int di){
		int n=m_focus_pmenu+di;
		if (n<0 || n>=m_pmenu_len) return GV::GV_NG;

		if (!di) return GV::GV_NG;
		if (m_pmenus[n]) m_focus_pmenu=n;

		return GV::GV_OK;
	}
	MENU_BOX *get_focus_pmenu(){
		if (m_focus_pmenu<0 || m_focus_pmenu>=m_pmenu_len) return NULL;
		return m_pmenus[m_focus_pmenu];
	}
};

