
//======================================
//		PLAYER_BASE						
//======================================
class PLAYER_BASE {
	protected :
	DROP_UNIT m_next_drop;
	PLAY_TABLE m_tab;
	int m_mode, m_fall_speed, m_player_down;
	int m_effect_step, m_score;
	char m_init, m_win_lose;
	int m_jama, m_stock_jama;
	PLAYER_BASE *m_enemy;
	public :
	char m_play_side;
	is_win(){ return (m_win_lose==GV::GAME_WIN); }
	is_lose(){ return (m_win_lose==GV::GAME_LOSE); }
	set_enemy(PLAYER_BASE *p_player){
		m_enemy=p_player;
		return GV::GV_OK;
	}
	virtual init(int play_side);
	virtual draw();
	virtual over_draw()=0;
	virtual play_nomal()=0;
	virtual wait_action()=0;		// ҂
	frame_up();
	ready_draw(int ready_time);
	PLAYER_BASE(){
		m_enemy=NULL;
		m_init=0;
		m_score=0;
	}
	fall_speed_up(int add_val=1){
		m_fall_speed=1;
	}
	virtual set_new_drop(DROP_UNIT *pdrop);	// VKp[c
	set_drop_vailed(int i);
	set_win(){
		m_tab.put_drop();
		set_drop_vailed(0);
		m_mode=GV::PLAY_OVER_EFFECT;
		m_effect_step=0;
		m_win_lose=GV::GAME_WIN;
	}
	set_lose(){
		m_tab.put_drop();
		set_drop_vailed(0);
		m_mode=GV::PLAY_OVER_EFFECT;
		m_win_lose=GV::GAME_LOSE;
		m_effect_step=0;
		if (m_enemy) m_enemy->set_win();
	}
	over_frame_up();
	drop_down(int dy);
	send_jama(int amount){
		if (m_enemy) m_enemy->add_jama(amount);
		return GV::GV_OK;
	}
	roll_stock_jama();		// זՂstock𗎉҂ɐ؂ւ
	add_jama(int amount);	// זՂǉ
	draw_wait_jama();		// ҂Ԃ̎זՂ`
	get_table_x(){
		return ((m_play_side==GV::GV_LEFT)? GV::LEFT_TABLE_PIX_X : GV::RIGHT_TABLE_PIX_X);
	}
	draw_score();		// XRA
	effect_frame_up();	// GtFNg
	move_shot_bullet_star(int x, int y);
	push_shot_bullet_star(int x, int y);
	draw_effect();
};

// VKp[c
inline PLAYER_BASE::set_new_drop(DROP_UNIT *pdrop){
	if (!m_init)return GV::GV_NG;
	m_player_down=0;
	m_tab.set_new_drop(&m_next_drop);
	if(m_tab.check_move_drop(0,0)==GV::GV_NG) {
		return GV::GV_NG;
	}
	m_next_drop=*pdrop;
	return GV::GV_OK;
}
// זՂstock𗎉҂ɐ؂ւ
inline PLAYER_BASE::roll_stock_jama(){
	m_jama+=m_stock_jama;
	m_stock_jama=0;
	add_jama(0);
}
// ҂Ԃ̎זՂ`
inline PLAYER_BASE::add_jama(int amount){
	m_jama+=amount;
	int onetime_jama=4*GV::TAB_IN_CX;	// x̗𐧌
	if (m_jama>onetime_jama) {
		m_stock_jama+=m_jama-onetime_jama;
		m_jama=onetime_jama;
	}
	return GV::GV_OK;
}

// drop_down
inline PLAYER_BASE::drop_down(int dy){
	if (!m_init)return GV::GV_NG;
	int i;
	if (m_tab.check_move_drop(0, dy)==GV::GV_NG) {	// s\
		for(i=0;i<GV::TAB_OUT_WIDTH;i++){
			if (m_tab.check_move_drop(0, dy-GV::GV_BY)==GV::GV_NG) {
				dy-=GV::GV_BY;
			}
			else break;
		}
		m_tab.put_drop();
		return GV::GV_NG;
	}
	else m_tab.move_drop(0,dy);
	return GV::GV_OK;
}
// ҂Ԃ̎זՂ
inline PLAYER_BASE::draw_wait_jama(){
	if (!m_init)return GV::GV_NG;
	int x, lim_x, i, len, y;

	x = get_table_x();
	lim_x = x + (GV::TAB_IN_CX-1)*GV::GV_BX;
	y = GV::TABLE_PIX_Y-GV::GV_BY*3/2;

	g_gv.reback_draw(x, y, GV::GV_BX*GV::TAB_IN_CX, GV::GV_BY);
	// 10Pʂ̐͑傫
	len=(m_jama+m_stock_jama)/10;
	for(i=0;i<len;i++){
		if (lim_x<x) break;
		g_gv.draw_wait_jama(x, y);
	//	g_gv.fill_main(x, y, GV::GV_BX, GV::GV_BY, g_gv.m_sys_hbr[8]);
		x+=GV::GV_BX;
	}
	// 10ȉ̐͏
	len=(m_jama+m_stock_jama)%10;
	y+=GV::GV_BY/2;
	for(i=0;i<len;i++){
		if (lim_x<x) break;
		g_gv.draw_mini_wait_jama(x, y);
	//	g_gv.fill_main(x, y, GV::GV_BX/2, GV::GV_BY/2, g_gv.m_sys_hbr[8]);
		x+=GV::GV_BX/2;
	}
	return GV::GV_OK;
}
// XRA`
PLAYER_BASE::draw_score(){
	int x;
	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_SCORE_PIX_X;
	else x=GV::RIGHT_SCORE_PIX_X;

	g_gv.draw_score_num(m_score, x, GV::SCORE_NUM_PIX_Y, m_play_side);
	g_gv.draw_score_str(x, GV::SCORE_STR_PIX_Y, m_play_side);
}

// `
PLAYER_BASE::draw(){
	if (!m_init)return GV::GV_NG;
	int x, y;
	m_tab.draw();

	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_NEXT_DROP_PIX_X;
	else x=GV::RIGHT_NEXT_DROP_PIX_X;

	g_gv.fill_main(x, GV::RIGHT_NEXT_DROP_PIX_Y,
			(GV::DROP_CX-1)*GV::GV_BX, GV::DROP_CY*GV::GV_BY, g_gv.m_sys_hbr[0]);
	x+=(GV::DROP_CX-1-m_next_drop.m_cx)*GV::GV_BX/2;
	y=GV::RIGHT_NEXT_DROP_PIX_Y + (GV::DROP_CY-m_next_drop.m_cy)*GV::GV_BY/2;
	m_next_drop.draw(x, y);
	draw_wait_jama();

	g_gv.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
	g_gv.select_font(GV::GV_SMALL);
	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_NEXT_DROP_PIX_X;
	else x=GV::RIGHT_NEXT_DROP_PIX_X;
	g_gv.draw_next_str(x, GV::RIGHT_NEXT_DROP_PIX_Y);

	// XRA`
	draw_score();
	// GtFNg`
	draw_effect();
	return GV::GV_OK;
};
// fBGOANV
PLAYER_BASE::ready_draw(int ready_time){
	if (!m_init)return GV::GV_NG;
	int x;
	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_READY_CENTER_PIX_X;
	else x=GV::RIGHT_READY_CENTER_PIX_X;
	ready_time=(4000-ready_time)/1000;
	if (ready_time) g_gv.draw_ready(ready_time, x, GV::READY_CENTER_PIX_Y);
	else g_gv.draw_go_str(x, GV::READY_CENTER_PIX_Y);

	return GV::GV_OK;
}
// 
PLAYER_BASE::init(int play_side){
	m_tab.reset();
	if (play_side!=GV::GV_LEFT && play_side!=GV::GV_RIGHT) return GV::GV_NG;
	m_tab.set_pos(get_table_x(), GV::TABLE_PIX_Y);
	m_effect_step=0;
	m_jama=0;
	m_play_side=play_side;
	m_fall_speed=1;
	m_player_down=0;
	m_mode=GV::PLAY_NOMAL;
	m_init=1;
	m_win_lose=0;
	m_stock_jama=0;

	g_gv.fill_back(get_table_x(), GV::TABLE_PIX_Y,
				GV::GV_BX*GV::TAB_IN_CX, GV::GV_BY*GV::TAB_IN_CY, (HBRUSH)GetStockObject(BLACK_BRUSH));
	g_gv.fill_main(get_table_x(), GV::TABLE_PIX_Y,
				GV::GV_BX*GV::TAB_IN_CX, GV::GV_BY*GV::TAB_IN_CY, (HBRUSH)GetStockObject(BLACK_BRUSH));
	return GV::GV_OK;
}

// p[c̗LEݒ
PLAYER_BASE::set_drop_vailed(int i){
	m_tab.set_drop_vailed(i);
	return GV::GV_OK;
}

// IANV
PLAYER_BASE::over_frame_up(){
	if (!m_init)return GV::GV_NG;
	int res;
	switch(m_mode){
	case GV::PLAY_OVER_EFFECT:
		if (m_win_lose==GV::GAME_LOSE) {
			res=m_tab.lose_effect(m_effect_step++);
		} else if (m_win_lose==GV::GAME_WIN) {
			res=m_tab.win_effect(m_effect_step++);
		}
		if (res==GV::GV_NG) m_mode=GV::PLAY_OVER_WAIT;
		break;
	case GV::PLAY_OVER_WAIT:
		if (wait_action()==GV::GV_NG) return GV::GV_NG;
		break;
	}
	return GV::GV_OK;
}
// GtFNg
PLAYER_BASE::effect_frame_up(){
	int res, x;
	SHOT_BULLET_STAR *p_star;
	if (m_tab.is_bullet_star()){
		if (m_play_side!=GV::GV_LEFT) x=get_table_x()-GV::GV_BX/2;
		else x=get_table_x()+GV::TAB_IN_CX*GV::GV_BX-GV::GV_BX/2;
		res=m_tab.move_bullet_star(x, GV::TABLE_PIX_Y-GV::GV_BY*2);
	}
	if (m_tab.is_shot_bullet_star()){
		if (m_enemy){
			x=m_enemy->get_table_x()+GV::TAB_IN_CX*GV::GV_BX/2-GV::GV_BX/2;
		}
		else {
			if (m_play_side!=GV::GV_LEFT) x=get_table_x()-GV::GV_BX/2;
			else x=get_table_x()+GV::TAB_IN_CX*GV::GV_BX-GV::GV_BX/2;
		}
		res=m_tab.move_shot_bullet_star(x, GV::TABLE_PIX_Y-GV::GV_BY*2);
		if (res){
			send_jama(res);
		}
	}
	return GV::GV_OK;
}

PLAYER_BASE::draw_effect(){
	m_tab.draw_effect();
	return GV::GV_OK;
}
// 
PLAYER_BASE::frame_up(){
	if (!m_init)return GV::GV_NG;

	effect_frame_up();	// GtFNg

	switch(m_mode){
	case GV::PLAY_NOMAL:
		if (play_nomal()==GV::GV_NG) {
			set_drop_vailed(0);
			m_mode=GV::PLAY_LANDING;
		}
		m_score+=(m_player_down/2);
		break;
	case GV::PLAY_JAMING:
		if (m_jama){
			if (m_tab.hang_jama(m_jama)==GV::GV_NG){
				m_mode=GV::PLAY_LANDING;	// [UEvC[h
			};
			m_jama-=GV::TAB_IN_CX;
			if (m_jama<0) m_jama=0;
			m_tab.landing();
		}
		else {
			m_mode=GV::PLAY_LANDING;
		}
		break;
	case GV::PLAY_LANDING:
		if (m_tab.landing()==0) m_mode=GV::PLAY_TRANSFER_ERASE;
		break;
	case GV::PLAY_TRANSFER_ERASE:
		m_tab.transfer_erase(); m_mode=GV::PLAY_ERASING;
		break;
	case GV::PLAY_ERASING:
		if (m_tab.erase_action()==0) {
			if (m_jama) m_mode=GV::PLAY_JAMING;	// זՂ旎[h
			else {
				m_mode=GV::PLAY_NOMAL;	// [UEvC[h
				roll_stock_jama();
				return GV::GV_NEXT_DROP;
			}
		}
		else {
			if (m_tab.get_erase()){
			//	send_jama(m_tab.calculate_send_jama());
				m_score+=m_tab.calculate_erase_score();
			}
			m_mode=GV::PLAY_LANDING;
		}
		break;
	}
	return GV::GV_OK;
}
//======================================
//		HUM_PLAYER						
//======================================
class HUM_PLAYER : public PLAYER_BASE {
	public:
	int m_continued_count;
	INPUT	m_input;
	MOUSE *m_p_mouse;
	HUM_PLAYER(){
		m_continued_count=0;
		m_p_mouse=NULL;
	}
	play_nomal();
	wait_action();
	mouse_use_on(MOUSE *p_mouse){
		m_p_mouse=p_mouse;
	}
	mouse_use_off(){
		m_p_mouse=NULL;
	}
	update_input(){
		m_input.update_stat();
	}
	set_game_continue(){
		m_continued_count++;
		m_score=0;
	}
	clear_frame_up();
	clear_draw();
	over_draw();
};
HUM_PLAYER::clear_frame_up(){
	if (m_input.get_any_btn(0)) return GV::GV_NG;
	return GV::GV_OK;
}
HUM_PLAYER::clear_draw(){
	draw();
	char *s=NULL;
	int x;
	x = get_table_x();

	s="GAME CLEAR";

	g_gv.set_text_color(RGB(255, 255, 255), RGB(0, 0, 0));
	g_gv.draw_text(s, x+10, GV::TABLE_PIX_Y+10);
	g_gv.set_text_color(RGB(0, 0, 0), RGB(255, 255, 255));
	return GV::GV_OK;

}
HUM_PLAYER::wait_action(){
	if (m_input.get_any(0)) return GV::GV_NG;
	if (m_p_mouse && (m_p_mouse->get_left() || m_p_mouse->get_right())) return GV::GV_NG;
	return GV::GV_OK;
}
HUM_PLAYER::play_nomal(){
	int dx, dy, angle, i;
	POINT mou_po;
	// ]ړ
	angle=0;
	if (m_input.get_btn(0) || m_input.get_btn(2)) angle=90;		// L[{[hE{^P
	if (m_input.get_btn(1) || m_input.get_btn(3)) angle=-90;	// L[{[hE{^Q
	if (m_p_mouse && m_p_mouse->get_right()) angle=90;			// }EX

	if (angle){
		if (m_tab.check_rotate_drop(angle)==GV::GV_OK) {
			m_tab.rotate_drop(angle);
		}
	}

	if (m_p_mouse && m_p_mouse->get_left(0)) {	// }EXW
		mou_po = m_p_mouse->get_pos();
	}
	// Rړ
	dx=m_input.get_side();						// L[{[h
	if (m_p_mouse && m_p_mouse->get_left(1)) {	// }EX
		i = get_table_x()+(m_tab.get_drop_x()-GV::TAB_IN_X)*GV::GV_BX;
		if (mou_po.x<i) dx=-1;
		if (mou_po.x>(i+m_tab.get_drop_cx()*GV::GV_BX)) dx=1;
	}
	if (m_tab.check_move_drop(dx, 0)==GV::GV_OK) m_tab.move_drop(dx,0);	// Rړs

	// ^eړ
	dy=m_input.get_vert(0);						// L[{[h
	if (m_p_mouse && m_p_mouse->get_left(0)) {	// }EX
		i = GV::TABLE_PIX_Y+(m_tab.get_drop_y()-GV::TAB_IN_Y)*GV::GV_BY;
		if (mou_po.y>(i+m_tab.get_drop_cy()*GV::GV_BY)) dy=1;
	}
	if (dy>0) m_player_down++; else m_player_down=0;	// A

	i=(dy>0)*m_player_down+m_fall_speed;
	if (drop_down(i)==GV::GV_NG) return GV::GV_NG;	// ^eړs
	return GV::GV_OK;
}
// PQ[I`
HUM_PLAYER::over_draw(){
	draw();
	int x;
	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_READY_CENTER_PIX_X;
	else x=GV::RIGHT_READY_CENTER_PIX_X;

	g_gv.draw_you_str(x, GV::READY_CENTER_PIX_Y);
	if (m_win_lose==GV::GAME_LOSE) g_gv.draw_lose_str(x, GV::READY_CENTER_PIX_Y);
	else if (m_win_lose==GV::GAME_WIN) g_gv.draw_win_str(x, GV::READY_CENTER_PIX_Y);

	return GV::GV_OK;
}
//======================================
//		SIM_TAB							
//======================================
// e[u]l
class SIM_TAB {
	char m_vailed;
	public:
	int m_cmb_val, m_height_val, m_chain;
	SIM_TAB();
	reset();
	is_vailed(){ return m_vailed; };
	set_vailed(int n){ m_vailed=n; };
};

SIM_TAB::reset(){
	memset(this, 0, sizeof(SIM_TAB));
};
SIM_TAB::SIM_TAB(){reset();};

//======================================
//		CPU_PLAYER						
//======================================
class CPU_PLAYER : public PLAYER_BASE {
	char m_decide, m_aim_ang, m_aim_x, m_aim_chain;
	SIM_TAB m_sim_tab[4][GV::TAB_OUT_WIDTH];
	enum { MAX_LEVEL=14 };
	int m_cpu_level, m_cpu_type;
	public:
	wait_action();
	each_simulate_dropdown(int sim_ang, int sim_x);
	simulate_dropdown();
	play_nomal();
	virtual set_new_drop(DROP_UNIT *pdrop){
		m_decide=0;
		return PLAYER_BASE::set_new_drop(pdrop);
	}
	set_cpu_type(int level, int type);
	get_drop_level(){ return (GV::TAB_IN_CY+GV::TAB_IN_X-m_cpu_level)-1; };
	over_draw();
};
CPU_PLAYER::over_draw(){
	draw();
	int x;
	if (m_play_side==GV::GV_LEFT) x=GV::LEFT_READY_CENTER_PIX_X;
	else x=GV::RIGHT_READY_CENTER_PIX_X;

	g_gv.draw_cpu_str(x, GV::READY_CENTER_PIX_Y);
	if (m_win_lose==GV::GAME_LOSE) g_gv.draw_lose_str(x, GV::READY_CENTER_PIX_Y);
	else if (m_win_lose==GV::GAME_WIN) g_gv.draw_win_str(x, GV::READY_CENTER_PIX_Y);
	return GV::GV_OK;
}
inline CPU_PLAYER::set_cpu_type(int level, int type){
	m_cpu_level = level*g_gv.m_game_level;
	m_cpu_type	= type;
	m_score=0;
}
// [U͑҂̂Ƃp
inline CPU_PLAYER::wait_action(){
	return GV::GV_NG;
}
// L[͂ɂ鉉Z				
CPU_PLAYER::play_nomal(){
	int dy=m_fall_speed;
	if (m_decide>0){	// ڕWm莞
		if (m_aim_ang){
			switch(m_aim_ang) {
			case 1 : m_tab.rotate_drop(90); break;
			case 2 : m_tab.rotate_drop(90);m_tab.rotate_drop(90); break;
			case 3 : m_tab.rotate_drop(-90); break;
			}
			m_aim_ang=0;
		}
		else if (m_aim_x>m_tab.get_drop_x()) m_tab.move_drop(1, 0);
		else if (m_aim_x<m_tab.get_drop_x()) m_tab.move_drop(-1, 0);
		else if (m_aim_x==m_tab.get_drop_x()) {
			if (get_drop_level()<=m_tab.get_drop_y()) m_player_down++;
		}
	}
	else simulate_dropdown();

	if (drop_down(dy+m_player_down)==GV::GV_NG) return GV::GV_NG;
	return GV::GV_OK;
};

// V~[V
CPU_PLAYER::each_simulate_dropdown(int sim_ang, int sim_x){
	static PLAY_TABLE tmp_tab;
	int i, dx;
	SIM_TAB *psim=&m_sim_tab[sim_ang][sim_x];

	psim->reset();	// s[Xړ\tO 
	tmp_tab = m_tab;

	for(i=0;i<sim_ang;i++) {
		if (tmp_tab.check_rotate_drop(90)==GV::GV_NG) return GV::GV_NG;	// ]
		tmp_tab.rotate_drop(90);
	}

	if (tmp_tab.get_drop_x()<sim_x) dx=1; else dx=-1;
	while(tmp_tab.get_drop_x()!=sim_x) {	// Rړ
		if (tmp_tab.check_move_drop(dx, 0)==GV::GV_NG)	return GV::GV_NG;	// Rړs\
		tmp_tab.move_drop(dx, 0);
	}
	psim->set_vailed(1);	// s[Xړ\tOnm

	tmp_tab.put_drop();	// ɗs[X
	while(tmp_tab.landing());	// ė

	while(tmp_tab.transfer_erase()){
		psim->m_chain++;	// A]
		while(tmp_tab.erase_action());	// 
		while(tmp_tab.landing());		// ė
	}
	psim->m_height_val=tmp_tab.height_evaluate();	// ] 
	psim->m_cmb_val=tmp_tab.cmb_evaluate();	// ]
	return 0;
};
// V~[VS
CPU_PLAYER::simulate_dropdown(){
	static int val, i, i_ang, i_x;
	SIM_TAB *psim, *aim_sim;

	// V~[V
	for(i_ang=0;i_ang<4;i_ang++){
		for(i_x=GV::TAB_IN_X;i_x<(GV::TAB_IN_X+GV::TAB_IN_CX);i_x++) each_simulate_dropdown(i_ang, i_x);
	}

	m_aim_x=0;	m_aim_ang=0;	m_aim_chain=1;	// ڕWʒu 
	aim_sim =NULL;
	i=m_tab.get_height_average();
	if (i<(GV::TAB_IN_CY/3))m_aim_chain=4;
	else if (i<(GV::TAB_IN_CY/2))m_aim_chain=3;
	else if (i<(GV::TAB_IN_CY*2/3))m_aim_chain=2;

	// Ał邩ȁH
	for(i_ang=0;i_ang<4;i_ang++){
		for(i_x=GV::TAB_IN_X;i_x<(GV::TAB_IN_X+GV::TAB_IN_CX);i_x++){
			psim=&m_sim_tab[i_ang][i_x];
			if (!psim->is_vailed()) continue;	// s[Xړ\tO
			val=psim->m_chain;	// A
			if		(val< m_aim_chain) continue;	// A ڕWȉ
			else if (val==m_aim_chain) {	// A Ȃ獂]ȕZ^N
				if (aim_sim && (psim->m_height_val)<(aim_sim->m_height_val)) continue;
			}
			else if (val> m_aim_chain) m_aim_chain=val;	// AڕWl̊iグ
			m_aim_x=i_x; m_aim_ang=i_ang; aim_sim = psim;	// AڕWl
		}
	}
	if (aim_sim){ m_decide=1; return GV::GV_OK; }	// A\

	for(i_ang=0;i_ang<4;i_ang++){
		for(i_x=(GV::TAB_IN_X+GV::TAB_IN_CX-1);i_x>=0;i_x--){
			psim = &m_sim_tab[i_ang][i_x];
			if (!psim->is_vailed()) continue;	// s[Xړ\tO
			if (aim_sim){
				if (psim->m_height_val< aim_sim->m_height_val)	continue;	// ]
				if (psim->m_cmb_val	< aim_sim->m_cmb_val)				continue;	// F]
				if (psim->m_cmb_val==aim_sim->m_cmb_val) {	// F]Ȃ
					if (psim->m_height_val< aim_sim->m_height_val)	continue;	// ̕]lD
				}
			}
			m_aim_x=i_x; m_aim_ang=i_ang;
			aim_sim = psim;
		}
	}
	if (aim_sim){ m_decide=1; return GV::GV_OK; }	// ]lŌ
	m_decide=1;	// ړȂ
	return GV::GV_OK;
}

