
class BULLET_STAR {
	int m_pos_x, m_pos_y, m_last_pos_x, m_last_pos_y, m_dx, m_dy;
	char m_act, m_valied;
	int m_id;
	public :
	enum { INVALIED, VALIED };
	BULLET_STAR(){
		m_act=m_pos_x=m_pos_y=m_valied=m_id=0;
		m_dx=m_dy=0;
	}
	get_id(){ return m_id; };
	make(int id, int x, int y){
		m_dx=m_dy=0;
		m_id=id;
		m_pos_x=x; m_pos_y=y;
		m_last_pos_x=x;m_last_pos_y=y;
		m_act=0;
		m_valied=1;
	}
	destroy(){
		m_valied=0;
		g_gv.reback_draw(m_last_pos_x-GV::GV_BX/2, m_last_pos_y-GV::GV_BY/2, GV::GV_BX*2, GV::GV_BY*2);
		m_dx=m_dy=0;
	}
	is_valied(){ return (m_valied==VALIED); };
	is_invalied(){ return (m_valied==INVALIED); };
	draw(){
		m_act++;
		if (m_act>=4) m_act=0;
		g_gv.reback_draw(m_last_pos_x-GV::GV_BX/2, m_last_pos_y-GV::GV_BY/2, GV::GV_BX*2, GV::GV_BY*2);
		g_gv.img_draw(m_pos_x-(GV::GV_BX/2), m_pos_y-(GV::GV_BY/2), 
				&g_gv.m_puyo_piece_img, m_act/2*42 , 95, GV::GV_BX*2, GV::GV_BY*2);
		m_last_pos_x=m_pos_x;m_last_pos_y=m_pos_y;
	}
	move_one_step(int x, int y){
		int i;
		if (m_dx>0) m_dx++; else if (m_dx<0) m_dx--;
		if (m_dy>0) m_dy++; else if (m_dy<0) m_dy--;
		if (!m_dx) { m_dx = ((x-m_pos_x)>0)? 1 : -1; }
		if (!m_dy) { m_dy = ((y-m_pos_y)>0)? 1 : -1; }
		if (abs(x-m_pos_x)>abs(m_dx)) { m_pos_x+= m_dx; } else m_pos_x= x;
		if (abs(y-m_pos_y)>abs(m_dy)) { m_pos_y+= m_dy; } else m_pos_y= y;
		if (m_pos_x==x && m_pos_y==y) return GV::GV_OK;
		return GV::GV_NG;
	}
};
class SHOT_BULLET_STAR {
	public :
	enum { INVALIED, VALIED, WAITING };
	char m_valied;
	int m_id, m_jama_amt, m_star_len;
	BULLET_STAR m_bullet_star;

	is_wait(){ return (m_valied==WAITING); };
	is_valied(){ return (m_valied==VALIED); };
	is_invalied(){ return (m_valied==INVALIED); };
	draw(){ return m_bullet_star.draw(); }
	move_one_step(int x, int y){ return m_bullet_star.move_one_step(x, y); }
	make(int id, int star_len, int jama_amt){
		m_id=id;
		m_star_len= star_len ;
		m_jama_amt = jama_amt ;
		m_valied = WAITING;
	}
	void decrease_star(int x, int y){
		m_star_len--;
		if (m_star_len<=0) {
			m_star_len=0;
			m_valied = VALIED;
			m_bullet_star.make(0, x, y);
		}
	}
	SHOT_BULLET_STAR(){ reset(); }
	void reset(){
		m_valied=INVALIED;
		m_id=m_jama_amt=m_star_len=0;
	}
	destroy(){
		reset();
		m_bullet_star.destroy();
	}
};
class BULLET_STAR_ADMIN {
	public :
	enum { SHOT_BULLET_STAR_MAX = GV::TAB_IN_CX*GV::TAB_IN_CY/4+1,
			BULLET_STAR_MAX=GV::TAB_IN_CX*GV::TAB_IN_CY
	};
	SHOT_BULLET_STAR	m_shot_bullet_stars[SHOT_BULLET_STAR_MAX];
	BULLET_STAR			m_bullet_stars[BULLET_STAR_MAX];
	int m_bullet_star_len, m_shot_bullet_star_len;

	BULLET_STAR_ADMIN(){ reset(); }
	move_bullet_star(int x, int y);
	push_bullet_star(int id, int x, int y);
	push_shot_bullet_star(int id, int star_len, int jama_amt);
	move_shot_bullet_star(int x, int y);
	draw();
	is_bullet_star()	{	return (bool)m_bullet_star_len; }
	is_shot_bullet_star(){	return (bool)m_shot_bullet_star_len; }
	reset(){
		m_bullet_star_len = m_shot_bullet_star_len=0;
	}
	decrease_bullet_star(int id, int x, int y);
};
BULLET_STAR_ADMIN::decrease_bullet_star(int id, int x, int y){
	int i;
	for(i=0;i<BULLET_STAR_MAX;i++){
		if (m_shot_bullet_stars[i].is_wait() && m_shot_bullet_stars[i].m_id==id) {
			m_shot_bullet_stars[i].decrease_star(x, y);
			break;
		}
	}
	return GV::GV_OK;
}
BULLET_STAR_ADMIN::draw(){
	int i;
	for(i=0;i<BULLET_STAR_MAX;i++){
		if (m_bullet_stars[i].is_valied()) m_bullet_stars[i].draw();
	}
	for(i=0;i<SHOT_BULLET_STAR_MAX;i++){
		if (m_shot_bullet_stars[i].is_valied()) m_shot_bullet_stars[i].draw();
	}
	return GV::GV_OK;
}
// obgEX^[ǉ
BULLET_STAR_ADMIN::push_shot_bullet_star(int id, int star_len, int jama_amt){
	int i;
	for(i=0;i<SHOT_BULLET_STAR_MAX;i++){
		if (m_shot_bullet_stars[i].is_invalied()) {
			m_shot_bullet_stars[i].make(id, star_len, jama_amt);
			m_shot_bullet_star_len++;
			break;
		}
	}
	return 0;
}
// obgEX^[ړ
BULLET_STAR_ADMIN::move_shot_bullet_star(int x, int y){
	int i, res=0;
	for(i=0;i<SHOT_BULLET_STAR_MAX;i++){
		if (m_shot_bullet_stars[i].is_valied() && ((m_shot_bullet_stars[i].move_one_step(x, y))==GV::GV_OK)) {
			res+=m_shot_bullet_stars[i].m_jama_amt;
			m_shot_bullet_stars[i].destroy();
			m_shot_bullet_star_len--;
		}
	}
	return res;
}
// obgEX^[ǉ
BULLET_STAR_ADMIN::push_bullet_star(int id, int x, int y){
	int i;
	for(i=0;i<BULLET_STAR_MAX;i++){
		if (!m_bullet_stars[i].is_valied()) {
			m_bullet_stars[i].make(id, x, y);
			m_bullet_star_len++;
			break;
		}
	}
	return 0;
}
// obgEX^[ړ
BULLET_STAR_ADMIN::move_bullet_star(int x, int y){
	int i;
	for(i=0;i<BULLET_STAR_MAX;i++){
		if (m_bullet_stars[i].is_valied() && ((m_bullet_stars[i].move_one_step(x, y))==GV::GV_OK)) {
			decrease_bullet_star(m_bullet_stars[i].get_id(), x, y);
			m_bullet_stars[i].destroy();
			m_bullet_star_len--;
		}
	}
	return 0;
}
//======================================
//		PLAY_TABLE						
//======================================
class PLAY_TABLE {
	private :
	int m_bullet_stars_order_id;
	BULLET_STAR_ADMIN m_bullet_star_admin;
	enum { OUT_WIDTH=GV::TAB_OUT_WIDTH, OUT_HEIGHT=GV::TAB_OUT_HEIGHT,
			IN_X=GV::TAB_IN_X, IN_Y=GV::TAB_IN_Y, IN_CX=GV::TAB_IN_CX, IN_CY=GV::TAB_IN_CY,

	};

	DROP_UNIT m_drop;		// p[c
	DROP_PEICE m_cells[OUT_WIDTH][OUT_HEIGHT];	// e[u
	char m_erase_serch[OUT_WIDTH][OUT_HEIGHT];	// pz
	int m_drop_vailed, m_drop_x, m_drop_y, m_drop_pix_y;
	int m_erase_col_len, m_erase_col[GV::DROP_COL_LEN];
	int m_erase_len;
	int m_chain;
	int m_cur_pos_x, m_cur_pos_y;

	public :
	PLAY_TABLE();			// RXgN^

	calculate_send_jama(){ return (get_erase()*m_chain*m_chain*(get_erase_col_len()+1)/5); }	// זՂvZ
	calculate_erase_score(){ return (get_erase()*m_chain*m_chain*get_erase_col_len()*10); }		// XRAvZ
	move_bullet_star(int x, int y){
		return m_bullet_star_admin.move_bullet_star(x, y);
	};
	move_shot_bullet_star(int x, int y){
		return m_bullet_star_admin.move_shot_bullet_star(x, y);
	};
	is_bullet_star()	{	return m_bullet_star_admin.is_bullet_star(); }
	is_shot_bullet_star(){	return m_bullet_star_admin.is_shot_bullet_star(); }

	get_erase(){ return m_erase_len; }	// قƂɏ
	get_erase_col_len(){ return m_erase_col_len; }	// F
	get_drop_x(){ return m_drop_x; };		// p[cwWQbg
	get_drop_y(){ return m_drop_y; };		// @V@@@x@@V
	get_drop_cx(){ return m_drop.m_cx; };	// p[cwQbg
	get_drop_cy(){ return m_drop.m_cy; };	// @V@@@x@V

	draw();				// `
	draw_effect();		// GtFNg`

	set_new_drop(DROP_UNIT *pdrop);	// p[cXV
	put_drop();						// p[cݒu
	move_drop(int x, int y);		// p[cړ
	check_move_drop(int x, int y);	// p[cړ`FbN
	rotate_drop(int angle);			// p[c]
	check_rotate_drop(int angle);	// p[c]`FbN
	landing();					// n
	transfer_erase();		// [hɈڍs
	erase_action();			// ANV
	visit(int id, int sx, int sy, int *amt);
	height_evaluate();		// ]
	cmb_evaluate();			// F]
	get_height_average();	// ύ
	set_drop_vailed(int i){
		m_drop_vailed=i;
	}
	win_effect(int y);		// GtFNg
	lose_effect(int y);		// skGtFNg
	hang_jama(int amount);	// זՂݒu
	reset();
	set_pos(int x, int y);
};

// זՂݒu
PLAY_TABLE::hang_jama(int amount){
	int ix, start_ix;
	if (amount>=IN_CX){
		for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
			m_cells[ix][0].set_jama();
		}
	}
	else {
		while(amount-->0){
			ix=rand()%IN_CX + IN_X;
			start_ix=ix;
			while(m_cells[ix][0].is_jama()){
				ix++;
				if (ix>=(IN_X+IN_CX)) ix=IN_X;
				if (start_ix==ix) return GV::GV_NG;
			}
			m_cells[ix][0].set_jama();
		}
	}
	return GV::GV_OK;
}
// GtFNg
PLAY_TABLE::win_effect(int ay){
	int iy, ix=IN_Y+IN_CY-1-ay;
	if (ix<0 || ix>=(IN_Y+IN_CY)) return GV::GV_NG;
	for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
		iy=IN_Y+IN_CY-1-ay;
		if (m_cells[ix][iy].is_vailed()) m_cells[ix][iy].reset();
	}
	return GV::GV_OK;
}
// skGtFNg
PLAY_TABLE::lose_effect(int ay){
	int iy, ix=IN_Y+IN_CY-1-ay;
	if (ix<0 || ix>=(IN_Y+IN_CY)) return GV::GV_NG;
	for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
		iy=IN_Y+IN_CY-1-ay;
		if (m_cells[ix][iy].is_vailed()) m_cells[ix][iy].set_jama();
	}
	return GV::GV_OK;
}
// ύ
PLAY_TABLE::get_height_average(){
	int heaps_height[OUT_WIDTH];
	int h, ix, iy;
	// e[ue̍Qbg
	for(ix=IN_X;ix<(IN_CX+IN_X);ix++){
		for(iy=(IN_CY+IN_Y-1);iy>=0;iy--){
			if (m_cells[ix][iy].is_vailed()) continue;
			heaps_height[ix]=IN_CY+IN_Y-iy;
			break;
		}
	}
	// ς̍Qbg
	h=0;	for(ix=IN_X;ix<(IN_CX+IN_X);ix++) h+=heaps_height[ix];
	return (h/IN_CX);
}
// ]
PLAY_TABLE::height_evaluate(){
	int heaps_height[OUT_WIDTH];
	int res=0, h, ix, iy, avr, center_x=IN_CX/2+IN_X;
	// e[ue̍Qbg
	for(ix=IN_X;ix<(IN_CX+IN_X);ix++){
		for(iy=(IN_CY+IN_Y-1);iy>=0;iy--){
			if (m_cells[ix][iy].is_vailed()) continue;
			heaps_height[ix]=IN_CY+IN_Y-iy;
			break;
		}
	}
	// ς̍Qbg
	h=0;	for(ix=IN_X;ix<(IN_CX+IN_X);ix++) h+=heaps_height[ix];
	avr= (h/IN_CX);

	// ŜJ^ɂȂĂΕ]l͎኱
	h=heaps_height[IN_CX+IN_X-1];
	for(ix=IN_CX+IN_X-2;ix>=center_x;ix--){
		iy=heaps_height[ix]-h;	if (iy<0){ res+=abs(iy); }	h=heaps_height[ix];
	}
	h=heaps_height[IN_X];
	for(ix=IN_X+1;ix<=center_x;ix++){
		iy=heaps_height[ix]-h;	if (iy<0){ res+=abs(iy); }	h=heaps_height[ix];
	}

	// ς̍ɋ߂قǍ]
	for(ix=IN_X;ix<(IN_CX+IN_X);ix++) {
		iy=abs(heaps_height[ix]-avr);
		res-=(iy*10);
	}

	return res;
}

// F]
PLAY_TABLE::cmb_evaluate(){
	int res=0, ix, iy, id;
	DROP_PEICE *ppc;
	for(ix=IN_X;ix<(IN_CX+IN_X);ix++){
		id=0;
		for(iy=IN_Y;iy<(IN_CY+IN_Y);iy++){
			ppc=&m_cells[ix][iy];
			switch(ppc->m_cmb){
			case 0 : break;
			case 1 : res+=-1; break;
			case 2 : res+=9; break;
			case 3 : res+=16; break;
			}
			if (ppc->is_normal() && ppc->m_id==id) res+=5;	// ^eɓF
			if (ppc->is_jama()) res-=50;
			id=ppc->m_id;
		}
	}
	return res;
};
// p[c]ł邩
PLAY_TABLE::check_rotate_drop(int angle){
	static DROP_UNIT work_drop;
	int res;
	work_drop=m_drop;
	m_drop.rotate(angle);
	if (check_move_drop(0,0)==GV::GV_OK
		|| check_move_drop(1,0)==GV::GV_OK
		|| check_move_drop(-1,0)==GV::GV_OK) res=GV::GV_OK;
	else res=GV::GV_NG;
	m_drop=work_drop;
	return res;
}
// p[c]
PLAY_TABLE::rotate_drop(int angle){
	int res;
	m_drop.rotate(angle);
	res=GV::GV_OK;
	if (check_move_drop(0,0)==GV::GV_NG) {
		if (check_move_drop(1,0)==GV::GV_OK) move_drop(1,0);
		else if (check_move_drop(-1,0)==GV::GV_OK) move_drop(-1,0);
		else res=GV::GV_NG;
	}
	return res;
}

// ANV
PLAY_TABLE::erase_action(){
	int ix,iy, res=0;
	m_erase_len=0;
	for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
		for(iy=IN_Y;iy<(IN_Y+IN_CY);iy++){
			if (m_cells[ix][iy].is_erase()){
				if (m_cells[ix][iy].erase_action()==GV::GV_OK) {
					if (!m_erase_len) m_bullet_stars_order_id++;
					m_bullet_star_admin.push_bullet_star(
						m_bullet_stars_order_id, m_cur_pos_x+(ix-IN_X)*GV::GV_BX, m_cur_pos_y+(iy-IN_Y)*GV::GV_BY);
					m_erase_len++;
				}
				res++;
			};
		}
	}
	if (m_erase_len) {
		m_chain++;
		m_bullet_star_admin.push_shot_bullet_star(
			m_bullet_stars_order_id, m_erase_len, calculate_send_jama());
	}
	if (m_bullet_stars_order_id>100000) m_bullet_stars_order_id=0;
	return res;
}
// n
PLAY_TABLE::landing(){
	int ix,iy, ey, res=0;
	for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
		for(iy=(IN_Y+IN_CY-1);iy>=0;iy--){
			if (m_cells[ix][iy+1].is_vailed() || !m_cells[ix][iy].is_vailed()) continue;
			for(ey=iy;ey>=0;ey--) {
				m_cells[ix][ey+1]=m_cells[ix][ey];
				m_cells[ix][ey].reset();
			};
			res++;
			break;
		}
	}
	return res;
}
// ċA 
int PLAY_TABLE::visit(int id, int sx, int sy, int *amt){
	if (	m_cells[sx][sy].m_id == 0			// s[X
		||	m_cells[sx][sy].m_id != id			// FႢ
		||	m_cells[sx][sy].m_type== GV::GV_PEICE_WALL	// 
		||	m_cells[sx][sy].m_id  == GV::GV_PEICE_JAMA	// ܂Ղ
		||	m_erase_serch[sx][sy]>0		)		// 
				return 0;	// I

	m_erase_serch[sx][sy]=1;	// σ}[N
	(*amt)++;
	if (sx<(IN_X+IN_CX))visit(id, sx+1,	sy,		amt);	// E 
	if (sy>IN_Y)		visit(id, sx,	sy-1,	amt);	//  
	if (sx>IN_X)		visit(id, sx-1,	sy,		amt);	//  
	if (sy<(IN_Y+IN_CY))visit(id, sx,	sy+1,	amt);	//  
	return 0;
}
// 
PLAY_TABLE::transfer_erase(){
	m_erase_col_len=0;
	int ix,iy, tx, ty, id, res=0, amt;
	for(iy=0;iy<OUT_HEIGHT;iy++){
		for(ix=0;ix<OUT_WIDTH;ix++){
			m_erase_serch[ix][iy]=0;
		}
	}
	for(ix=0;ix<GV::DROP_COL_LEN;ix++)m_erase_col[ix]=0;

	for(iy=(IN_Y+IN_CY-1);iy>=0;iy--){
		for(ix=IN_X;ix<(IN_X+IN_CX);ix++){
			amt=0;
			id=m_cells[ix][iy].m_id;
			visit(id, ix,iy, &amt);	// F̍ċA^
			if (!m_erase_serch[ix][iy]) m_erase_serch[ix][iy]=1;	// σ}[N
			m_cells[ix][iy].m_cmb=amt;
			if (amt>=4){
				m_erase_col[id]++;
				for(ty=(IN_Y+IN_CY-1);ty>=0;ty--){
				for(tx=IN_X;tx<(IN_X+IN_CX);tx++){
					if (m_erase_serch[tx][ty]!=1) continue;
					m_cells[tx][ty].set_erase();
					if (ty>0 && m_cells[tx][ty-1].is_jama()) m_cells[tx][ty-1].set_erase();
					if (m_cells[tx][ty+1].is_jama()) m_cells[tx][ty+1].set_erase();
					if (m_cells[tx+1][ty].is_jama()) m_cells[tx+1][ty].set_erase();
					if (m_cells[tx-1][ty].is_jama()) m_cells[tx-1][ty].set_erase();
					res++;
				}
				}
			}
				for(ty=(IN_Y+IN_CY-1);ty>=IN_Y;ty--){
				for(tx=IN_X;tx<(IN_X+IN_CX);tx++){
					if (m_erase_serch[tx][ty]==1) {
						m_erase_serch[tx][ty]=2;
						m_cells[tx][ty].m_cmb=amt;
					}
				}
				}
		}
	};
	for(ix=0;ix<GV::DROP_COL_LEN;ix++) if (m_erase_col[ix])m_erase_col_len++;
	return res;
}
// Zbg
PLAY_TABLE::reset(){
	m_chain=0;
	m_cur_pos_x=m_cur_pos_y=0;
	m_bullet_stars_order_id=0;
	m_bullet_star_admin.reset();
	int ix, iy;
	// ǁ@q_
	for(iy=0;iy<OUT_HEIGHT;iy++){
		for(ix=0;ix<IN_X;ix++){
			m_cells[ix][iy].set_wall();
		}
	}
	// ǁ@~M
	for(iy=0;iy<OUT_HEIGHT;iy++){
		for(ix=(IN_CX+IN_X);ix<OUT_WIDTH;ix++){
			m_cells[ix][iy].set_wall();
		}
	}
	// ǁ@V^
	for(iy=(IN_CY+IN_Y);iy<OUT_HEIGHT;iy++){
		for(ix=0;ix<OUT_WIDTH;ix++){
			m_cells[ix][iy].set_wall();
		}
	}
	// gZbg
	for(iy=IN_Y;iy<(IN_CY+IN_Y);iy++){
		for(ix=IN_X;ix<(IN_CX+IN_X);ix++){
			m_cells[ix][iy].reset();
		}
	}
	return GV::GV_OK;
}
// RXgN^
PLAY_TABLE::PLAY_TABLE(){
	reset();
}
// p[cݒu
PLAY_TABLE::put_drop(){
	if (!m_drop_vailed) return GV::GV_NG;
	m_chain=0;
	int ix, iy, pos_x, pos_y;
	pos_x=(m_drop_x   );
	pos_y=(m_drop_pix_y)/GV::GV_BY;
	if (pos_x<IN_X || (pos_x+m_drop.m_cx)>(IN_CX+IN_X)) return GV::GV_NG;
	if (pos_y<0 || (pos_y+m_drop.m_cy)>(IN_CY+IN_Y)) return GV::GV_NG;
	for(iy=0;iy<m_drop.m_cy;iy++){
		for(ix=0;ix<m_drop.m_cx;ix++){
			if (m_drop.m_pcs[ix][iy].is_vailed())
				m_cells[(m_drop_x)+ix][(m_drop_y)+iy]=m_drop.m_pcs[ix][iy];
		}
	}
	return GV::GV_OK;
}
// p[cړ`FbN
PLAY_TABLE::check_move_drop(int dx, int pix_y){
	int ix, iy, pos_x, pos_y;
	pos_x=(m_drop_x     +dx   );
	pos_y=(m_drop_pix_y +pix_y)/GV::GV_BY;
	if (pos_x<IN_X || (pos_x+m_drop.m_cx)>(IN_CX+IN_X)) return GV::GV_NG;
	if (pos_y<0 || (pos_y+m_drop.m_cy)>(IN_CY+IN_Y)) return GV::GV_NG;
	for(iy=0;iy<m_drop.m_cy;iy++){
		for(ix=0;ix<m_drop.m_cx;ix++){
			if (m_drop.m_pcs[ix][iy].is_vailed()
				&& m_cells[pos_x+ix][pos_y+iy].is_vailed())
						return GV::GV_NG;
		}
	}
	return GV::GV_OK;
}
// p[cړ
PLAY_TABLE::move_drop(int dx, int dy){
	m_drop_x+=dx;
	m_drop_pix_y+=dy;
	m_drop_y=m_drop_pix_y/GV::GV_BY;
	return GV::GV_OK;
}
// VKp[c
PLAY_TABLE::set_new_drop(DROP_UNIT *pdrop){
	m_drop=*pdrop;
	m_drop_x=IN_X+(IN_CX-m_drop.m_cx)/2;
	m_drop_y=IN_Y;
	m_drop_pix_y=m_drop_y*GV::GV_BY;
	set_drop_vailed(1);
	return GV::GV_OK;
}
// `
PLAY_TABLE::draw_effect(){
	m_bullet_star_admin.draw();
	return GV::GV_OK;
};
PLAY_TABLE::set_pos(int x, int y){
	m_cur_pos_x=x;
	m_cur_pos_y=y;
}
PLAY_TABLE::draw(){
	int ix, iy, pos_y;
	// {̕`
	for(iy=IN_Y;iy<(IN_CY+IN_Y);iy++){
		pos_y = m_cur_pos_y+(iy-IN_Y)*GV::GV_BY;
		for(ix=IN_X;ix<(IN_CX+IN_X);ix++){
			m_cells[ix][iy].draw((ix-IN_X)*GV::GV_BX +m_cur_pos_x, pos_y);
		}
	}
	// p[c`
	if (m_drop_vailed){
		if (check_move_drop(0, GV::GV_BY)==GV::GV_OK) pos_y=m_drop_pix_y-IN_Y*GV::GV_BY;
		else pos_y=(m_drop_pix_y/GV::GV_BY-IN_Y)*GV::GV_BY;
		m_drop.draw(m_cur_pos_x +(m_drop_x-IN_X)*GV::GV_BX, m_cur_pos_y+pos_y);
	}
//	rim_draw(g_gv.get_main_dc(), x, y, IN_CX*GV::GV_BX+x, IN_CY*GV::GV_BY+y, g_gv.m_sys_hpen[0]);
//	g_gv.draw_text("a", 0,0);
	return GV::GV_OK;
};
